var dragging = false;
var dragObject;

function Buttons ( parentId, thisClass, buttons, drag ) {

	var self = this;
	var scrollBox = document.getElementById('scroll');
	this.display = false;
	this.opacity = 0;

	this.parent = document.getElementById(parentId);

	this.object = newObject('div',parentId+'-buttons',thisClass);
	this.object.style.opacity = 0;
	this.parent.appendChild(this.object);

	this.setOpacity = function ( animation, now, first, done ) {
		self.object.style.opacity = now;
	}

	this.clearTimer = function () {
		if (self.delay !== undefined) {
			clearTimeout(self.delay);
			delete self.delay;
		}
	}

	this.startAnimation = function ( from, to ) {

		self.clearTimer();
		if (!dragging) {
			if (to == 1 && self.display || to == 0 && !self.display) return;
	
			var duration = 500;
			if (self.animation !== undefined) {
				from = self.animation.now;
				duration = (new Date).getTime() - self.animator.startTime;
				self.animator.stop();
			}
			if (to == 1) self.display = true;
			self.animator = new AppleAnimator(duration,13);
			self.animator.oncomplete = self.animationComplete;
			
			self.animation = new AppleAnimation(from,to,self.setOpacity);
			self.animator.addAnimation(self.animation);
			self.animator.start();
			if (to == 0) self.display = false;
		}

	}

	this.animationComplete = function() {
		delete self.animation;
		delete self.animator;
	}

	this.parentMove = function () {
		self.startAnimation(0,1);
	}

	this.parentOutDelay = function () {
		if (self.delay === undefined) {
			self.delay = setTimeout(self.parentOut,0,self);
		}
	}

	this.parentOut = function (self) {
		self.startAnimation(1,0);
	}

	this.buttonOver = function () {
		self.clearTimer();
		if (!dragging) {
			self.display = true;
			if (self.animation !== undefined) self.animator.stop();
			self.object.style.opacity = 1;
		}
	}

	this.parent.addEventListener('mousemove',self.parentMove,true);
	this.parent.addEventListener('mouseout',self.parentOutDelay,true);
	this.object.addEventListener('mouseover',self.buttonOver,true);

	for (var i = 0; i < buttons.length; i++) {
		this.object.appendChild(buttons[i]);
	}

	if (drag) {

		this.startDrag = function (e) {
			dragging = true;
			offset.x = 0;
			offset.y = (scrollBox.scrollTop + e.pageY) - self.parent.offsetTop;
			var top = self.parent.offsetTop;
	
			dragObject = self.parent.cloneNode(true);
			dragObject.style.position = 'absolute';
			dragObject.style.left = '0';
			dragObject.style.top = top + 'px';
			dragObject.style.width = scrollBox.offsetWidth + 'px';
			dragObject.style.opacity = 0.8;
			dragObject.origin = getPosition(top,0);
			dragObject.position = dragObject.origin;
			dragObject.scrollMax = scrollBox.scrollHeight - scrollBox.offsetHeight;
	
			self.parent.style.opacity = 0;
			document.getElementById('deliveries').appendChild(dragObject);
	
			window.addEventListener('mousemove',self.moveDrag,true);
			window.addEventListener('mouseup',self.stopDrag,true);
		}
		
		this.moveDrag = function (e) {
			if (dragObject !== undefined) {
	
				if (dragObject.timer) clearTimeout(dragObject.timer);
	
				var y = scrollBox.scrollTop + e.pageY;
				var top = y - offset.y;

				if (e.pageY < 52 && scrollBox.scrollTop > 0) {
	
					var adjustment = Math.ceil((52 - e.pageY) / 2);
					var newTop = scrollBox.scrollTop - adjustment;
					if (newTop < 0) newTop = 0;
					scrollArea.verticalScrollTo(newTop);
					dragObject.style.top = (top - adjustment) + 'px';
					dragObject.timer = setTimeout(self.moveDrag,100,e);
					
				} else if (window.innerHeight - e.pageY < 89 && 
					scrollBox.scrollTop < dragObject.scrollMax) {
	
					var adjustment = Math.ceil((89 - (window.innerHeight - e.pageY)) / 2);
					var newTop = scrollBox.scrollTop + adjustment;
					if (newTop > dragObject.scrollMax) newTop = dragObject.scrollMax;	
					scrollArea.verticalScrollTo(newTop);
					dragObject.style.top = (top + adjustment) + 'px';
					dragObject.timer = setTimeout(self.moveDrag,100,e);
	
				} else dragObject.style.top = top + 'px';
	
				var position = getPosition(y,dragObject.origin);
				var nextElement = null;
				if (position < deliveries.length) {
					nextElement = document.getElementById(deliveries[position].id);
				}
				document.getElementById('deliveries').insertBefore(self.parent,nextElement);
				dragObject.position = position;
	
			}
		}
		
		this.stopDrag = function (e) {
			if (dragObject !== undefined) {

				if (dragObject.timer) clearTimeout(dragObject.timer);
	
				var newDeliveries = new Array();
				var x = 0;
				for (var i = 0; i < deliveries.length + 1; i++) {
					if (i == dragObject.position) {
						newDeliveries.push(deliveries[dragObject.origin]);
						x++;
					}
					if (i != dragObject.origin && deliveries[i]) {
						newDeliveries.push(deliveries[i]);
						x++;
					}
				}
				deliveries = newDeliveries;
				saveDeliveries();
	
				self.parent.style.opacity = 1;
				if (dragObject) document.getElementById('deliveries').removeChild(dragObject);
				delete dragObject;
				
				window.removeEventListener('mousemove',self.moveDrag,true);
				window.removeEventListener('mouseup',self.stopDrag,true);
	
			}
			dragging = false;
		}

		var dragHandle = newObject('div',parentId+'-drag','drag');
		dragHandle.addEventListener('mousedown',this.startDrag,true);
		this.object.appendChild(dragHandle);

	}

}

function getPosition ( y, origin ) {
	var position = Math.ceil(y/74);
	if (position <= origin) position--;
	if (position < 0) {
		position = 0;
	} else if (position > deliveries.length) {
		position = deliveries.length;
	}
	return position;
}
