function setFrom ( ) {

	this.extraRequired = false;
	this.passRequired = false;

	switch(this.from) {
		case 'www.adobe.com':
			this.fromClass = 'Adobe';
			this.url = 'https://store1.adobe.com/cfusion/store/html/index.cfm';
			this.extraRequired = true;
			this.passRequired = true;
			break;
		case 'www.apple.com':
		case 'www.apple.com/zip':
		case 'www.apple.com/japan':
		case 'www.apple.com/japanzip':
		case 'www.apple.com/hk':
			this.domain = 'www.apple.com';
			this.fromClass = 'Apple';
			switch (this.from) {
				case 'www.apple.com':
				case 'www.apple.com/zip':
					this.url = 'https://store.apple.com/1-800-MY-APPLE/WebObjects/OrderStatus';
					break;
				case 'www.apple.com/japan':
				case 'www.apple.com/japanzip':
					this.url = 'https://store.apple.com/AsiaApple/WebObjects/JapanOrderStatus';
					break;
				case 'www.apple.com/hk':
					this.url = 'https://store.apple.com/AsiaApple/WebObjects/HongkongZHOrderStatus';
					break;
			}
			this.extraRequired = true;
			break;
		case 'www.aramex.com':
			this.fromClass = 'Aramex';
			this.url = 'http://www.aramex.com/express/track.aspx';
			break;
		case 'em.canadapost.ca':
			this.fromClass = 'CanadaPost';
			this.url = 'http://www.canadapost.ca/cpotools/apps/track/personal/findByTrackNumber';
			break;
		case 'www.city-link.co.uk':
			this.fromClass = 'CityLink';
			this.url = 'http://www.city-link.co.uk/';
			break;
		case 'www.dhl.com':
		case 'track.dhl-usa.com':
			this.fromClass = 'DHL';
			this.url = 'http://www.dhl.com/en/express/tracking.html';
			break;
		case 'www.dhlglobalmail.com':
			this.fromClass = 'DHL';
			this.url = 'http://webtrack.dhlglobalmail.com/';
			break;
		case 'nolp.dhl.de':
		case 'nolp.dhl.de/int':
			this.from = 'nolp.dhl.de';
			this.fromClass = 'DHL';
			this.url = 'http://www.dhl.de/';
			break;
		case 'www.dhl.co.uk':
			this.fromClass = 'DHL';
			this.url = 'http://track.dhl.co.uk/tracking/';
			break;
		case 'www.dpd.com':
			this.fromClass = 'DPD';
			this.url = 'http://www.dpd.net/index.php?id=43727&language_id=1';
			break;
		case 'www.fedex.com':
			this.fromClass = 'FedEx';
			this.url = 'https://www.fedex.com/Tracking?action=track&language=english&cntry_code=us';
			break;
		case 'www.gls-germany.com':
			this.fromClass = 'GLS';
			this.url = 'http://www.gls-group.eu/';
			break;
		case 'checkout.google.com':
			this.fromClass = 'Google';
			this.url = 'https://checkout.google.com/';
			this.extraRequired = true;
			this.passRequired = true;
			break;
		case 'www.hlg.de':
			this.fromClass = 'HLG';
			this.url = 'https://www.myhermes.de/wps/portal/PRIPS_DEU/SENDUNGSSTATUS';
			this.oneByOne = true;
			break;
		case 'www.hongkongpost.com':
			this.fromClass = 'HongkongPost';
			this.url = 'http://app3.hongkongpost.com/CGI/mt/enquiry.jsp';
			break;
		case 'www.japanpost.jp/ems':
		case 'www.japanpost.jp/m10':
		case 'www.japanpost.jp/reg':
		case 'www.japanpost.jp/yupack':
			this.fromClass = 'JapanPost';
			var lang = (translate('Japan Post') == '日本郵便') ? 'jp' : 'en';
			switch (this.from) {
				case 'www.japanpost.jp/reg':
					var kind = 'S001';
					break;
				case 'www.japanpost.jp/yupack':
					var kind = 'S002';
					break;
				case 'www.japanpost.jp/m10':
					var kind = 'S003';
					break;
				case 'www.japanpost.jp/ems':
					var kind = 'S004';
					break;
			}
			this.url = 'http://tracking.post.japanpost.jp/service/numberSearch.do?locale='+lang+'&searchKind='+kind;
			break;
		case 'www.laposte.fr':
			this.fromClass = 'LaPoste';
			this.url = 'http://www.colissimo.fr/portail_colissimo/suivre.do';
			break;
		case 'www.ontrac.com':
			this.fromClass = 'OnTrac';
			this.url = 'https://www.ontrac.com/tracking.asp';
			break;
		case 'www.parcelforce.com':
			this.fromClass = 'Parcelforce';
			this.url = 'http://www.parcelforce.com/portal/pw';
			this.oneByOne = true;
			break;
		case 'www.post.at':
			this.fromClass = 'Post-at';
			this.url = 'https://nachschau.post.at/Default.aspx?lang='+translate('xx');
			break;
		case 'www.postdanmark.dk':
			this.fromClass = 'PostDanmark';
			this.url = 'http://www.postdanmark.dk/contentfull.dk?lang='+translate('xx');
			break;
		case 'www.poste.it/posta1':
		case 'www.poste.it/pacco1':
		case 'www.poste.it/maxi':
		case 'www.poste.it':
		case 'www.poste.it/pacco':
		case 'www.poste.it/ems':
			this.fromClass = 'Poste-it';
			this.url = 'http://www.poste.it/online/dovequando/';
			break;
		case 'www.posten.no':
			this.fromClass = 'Posten-no';
			this.url = 'http://sporing.posten.no/';
			break;
		case 'www.posten.se':
			this.fromClass = 'Posten-se';
			this.url = 'http://www.posten.se/';
			break;
		case 'www.purolator.com':
			this.fromClass = 'Purolator';
			this.url = 'http://www.purolator.com/';
			this.encoding = 'iso-8859-1';
			break;
		case 'www.royalmail.com':
			this.fromClass = 'RoyalMail';
			this.url = 'http://www.royalmail.com/trackdelivery';
			this.oneByOne = true;
			break;
		case 'www.sagawa-exp.co.jp':
			this.fromClass = 'Sagawa';
			this.url = 'http://k2k.sagawa-exp.co.jp/';
			break;
		case 'www.post.ch':
			this.fromClass = 'SwissPost';
			this.url = 'http://www.post.ch/';
			break;
		case 'www.tnt.com':
		case 'www.tnt.com/ref':
			this.domain = 'www.tnt.com';
			this.fromClass = 'TNT';
			this.url = 'http://www.tnt.com/webtracker/tracker.do?navigation=1&respLang=en&respCountry=US';
			break;
		case 'www.tntpost.nl':
			this.fromClass = 'TNT';
			this.url = 'https://tracktrace.tntpostpakketservice.nl/Search/SearchBasic.aspx?lang='+translate('xx');
			break;
		case 'www.ups.com':
			this.fromClass = 'UPS';
			this.url = 'http://wwwapps.ups.com/WebTracking/processInputRequest?loc=en_US';
			break;
		case 'www.ups-mi.net':
			this.fromClass = 'UPS';
			this.url = 'http://www.ups-mi.net/packageID/';
			break;
		case 'www.usps.com':
			this.fromClass = 'USPS';
			this.url = 'http://trkcnfrm1.smi.usps.com/PTSInternetWeb/InterLabelInquiry.do';
			break;
		case 'www.kuronekoyamato.co.jp':
			this.fromClass = 'Yamato';
			this.url = 'http://toi.kuronekoyamato.co.jp/cgi-bin/tneko';
			break;
		case 'www.amazon.com':
		case 'www.amazon.ca':
		case 'www.amazon.co.uk':
		case 'www.amazon.co.jp':
		case 'www.amazon.de':
		case 'www.amazon.at':
		case 'www.amazon.fr':
		case 'www.amazon.it':
			if (this.domain == 'www.amazon.at') this.domain = 'www.amazon.de';
			this.fromClass = 'Amazon';
			this.url = 'https://'+this.domain+'/gp/css/homepage.html';
			this.extraRequired = true;
			this.passRequired = true;
			break;
		case 'other':
		default:
			this.fromClass = 'Other';
			this.url = this.extra;
			break;
	}

}

function updateStatus () {

	if (this.passRequired && (!this.password || this.password == ' ')) {

		if (!iPhone) updatingCount++;
		this.count = 0;
		this.notFound();
		this.updateItems();

	} else {

		if (!iPhone) {
			updatingCount++;
			this.startLoad();
		}
		this.resetRequests(true);	
		this.success = 2;
		this.showMessage(translateFormat('Contacting %@…',this.fromTrans));
		if (this.items.length > 0) this.previousItems = this.items;

		if (this.fromClass == 'Adobe') {

			this.url = 'https://store1.adobe.com/cfusion/store/html/index.cfm?store=OLS-US&event=displayOrderDetail&ordernumber='+
				fullEscape(this.no);	
			var orderData = 'event=login&up_login=yes&has_pwd=true&rememberMe=true&up_username='+fullEscape(this.extra)+'&up_password='+fullEscape(this.password)+'&submit_button=Continue&returnURL=%2Fcfusion%2Fstore%2Fhtml%2Findex.cfm%3Fstore%3DOLS-US%26event%3DdisplayOrderDetail%26ordernumber%3D'+fullEscape(this.no)+'%26nr%3D0';

			this.loadCookiePage(this.url,sessionAdobe,orderData,false);

		} else if (this.fromClass == 'Apple') {

			switch (this.from) {
				case 'www.apple.com':
				case 'www.apple.com/zip':
					this.url = 'http://store.apple.com/go/us/vieworder/'+fullEscape(this.no)+'/'+fullEscape(this.extra)+'/AOS';
					break;
				case 'www.apple.com/japan':
				case 'www.apple.com/japanzip':
					this.url = 'http://store.apple.com/go/jp/vieworder/'+fullEscape(this.no)+'/'+fullEscape(this.extra)+'/AOS';
					break;
				case 'www.apple.com/hk':
					this.url = 'http://store.apple.com/go/hk-zh/vieworder/'+fullEscape(this.no)+'/'+fullEscape(this.extra)+'/AOS';
					break;
			}
			this.loadPage(this.url,getApple,false,false);

		} else if (this.fromName == 'Aramex') {

			this.url = 'http://www.aramex.com/express/track_results_multiple.aspx?ShipmentNumber='+fullEscape(this.no)+'&TrackType=EXP,DOM,FRT';	
			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['theSite'] = 'Aramex';
			this.loadCookiePage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'CanadaPost') {

			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['lang'] = (translate('xx') == 'fr') ? 'fr' : 'en';

			this.url = 'http://www.canadapost.ca/cpotools/apps/track/personal/findByTrackNumber?trackingNumber='+
				fullEscape(this.no)+'&LOCALE='+theArgs['lang'];
			theArgs['theSite'] = 'CanadaPost';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'CityLink') {

			this.url = 'http://www.city-link.co.uk/dynamic/track.php?parcel_ref_num='+fullEscape(this.no)+'&postcode='+fullEscape(this.extra);
			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['theSite'] = 'CityLink';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'DHL') {

			var theArgs = new Array();
			theArgs['y'] = 0;

			if (this.from == 'www.dhlglobalmail.com') {

				thisUrl = this.url = 'http://webtrack.dhlglobalmail.com/?trackingnumber='+fullEscape(this.no);
				theArgs['theSite'] = 'DHL GlobalMail';
				this.loadPage(thisUrl,getTracker,false,theArgs);

			} else if (this.from == 'nolp.dhl.de') {

				theArgs['lang'] = (translate('xx') == 'de') ? 'de' : 'en';
				thisUrl = this.url = 'http://nolp.dhl.de/nextt-online-public/set_identcodes.do?lang='+
					theArgs['lang']+'&idc='+fullEscape(this.no)+'&zip='+fullEscape(this.extra);
				theArgs['theSite'] = 'DHL (Germany)';
				this.loadPage(thisUrl,getMultiple,false,theArgs);

			} else  if (this.from == 'www.dhl.co.uk') {

				thisUrl = this.url = 'http://track.dhl.co.uk/tracking/wrd/run/wt_xhistory_pw.execute?PCL_INST=1&CNTRY=GB&PCL_NO='+fullEscape(this.no);
				theArgs['theSite'] = 'DHL UK';
				this.loadPage(thisUrl,getTracker,false,theArgs);

			} else {

				thisUrl = this.url = 'http://www.dhl.com/content/g0/en/express/tracking.shtml?brand=DHL&AWB='+fullEscape(this.no.replace(/ /g,''));
				theArgs['theSite'] = 'DHL';
				this.loadPage(thisUrl,getMultiple,false,theArgs);

			}

		} else if (this.fromClass == 'DPD') {

			var theArgs = new Array();
			theArgs['lang'] = (translate('Germany') == 'Deutschland') ? 'de' : 'uk';
			this.url = 'https://extranet.dpd.de/cgi-bin/delistrack?typ=1&lang='+theArgs['lang']+
				'&pknr='+fullEscape(this.no)+'&submit=Search';
			theArgs['y'] = 0;
			theArgs['theSite'] = 'DPD';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'FedEx') {

			this.url = 'https://www.fedex.com/Tracking?action=track&language=english&cntry_code=us&initial=x&tracknumbers='+fullEscape(this.no);
			// if (iPhone) this.url = 'https://mobile.usablenet.com/mt/www.fedex.com/Tracking?action=track&language=english&cntry_code=us&initial=x&tracknumbers='+fullEscape(this.no);	
			this.loadPage(this.url,getFedEx,false,false);

		} else if (this.fromClass == 'GLS') {

			var theArgs = new Array();
			switch(translate('Germany')) {
				case 'Deutschland':
					theArgs['lang'] = 'DE03/DE'; // German
					break;
				case 'Tyskland':
					theArgs['lang'] = 'DK01/DA'; // Danish
					break;
				case 'Allemagne':
					theArgs['lang'] = 'FR01/FR'; // French
					break;
				default:
					theArgs['lang'] = 'NL99/EN'; // English
					break;
			}
			this.url = 'http://www.gls-group.eu/276-I-PORTAL-WEB/content/GLS/'+theArgs['lang']+
				'/5004.htm?txtAction=71000&txtRefNo='+fullEscape(this.no);
			theArgs['y'] = 0;
			theArgs['theSite'] = 'GLS';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'Google') {

			this.url = 'https://checkout.google.com/view/receipt?t='+fullEscape(this.no);
			var thisUrl = 'https://checkout.google.com/m/confirm?action=LOGOUT_USER&skip=true&continueUrl=https://checkout.google.com/m/main&cancelUrl=https://checkout.google.com/m/main'; 
			this.loadCookiePage(thisUrl,getGoogle,false,false);

		} else if (this.fromClass == 'HLG') {

			thisUrl = 'https://www.myhermes.de/wps/portal/PRIPS_DEU/SENDUNGSSTATUS';
			this.url = (iPhone) ? thisUrl : 'http://tracking.hlg.de/Tracking.jsp?TrackID='+fullEscape(this.no.replace(/[^0-9]/g,''));
			this.loadPage(thisUrl,getHermes,false,false);

		} else if (this.fromClass == 'HongkongPost') {

			var theArgs = new Array();
			theArgs['y'] = 0;
			
			this.url = 'http://app3.hongkongpost.com/CGI/mt/genresult.jsp?tracknbr='+fullEscape(this.no);
			// Chinese: http://app3.hongkongpost.com/CGI/mt/c_genresult.jsp?tracknbr=

			theArgs['theSite'] = 'HongkongPost';
			this.loadPage(this.url,getHongkong,false,theArgs);

		} else if (this.fromClass == 'JapanPost') {

			var theArgs = new Array();
			theArgs['y'] = 0;

			theArgs['lang'] = (translate('Japan Post') == '日本郵便') ? 'jp' : 'en';
			switch (this.from) {
				case 'www.japanpost.jp/reg':
					var kind = 'S001';
					break;
				case 'www.japanpost.jp/yupack':
					var kind = 'S002';
					break;
				case 'www.japanpost.jp/m10':
					var kind = 'S003';
					break;
				case 'www.japanpost.jp/ems':
					var kind = 'S004';
					break;
			}
			this.url = 'http://tracking.post.japanpost.jp/service/singleSearch.do?searchKind='+kind+'&locale='+theArgs['lang']+'&SVID=020&reqCodeNo1='+fullEscape(this.no);

			theArgs['theSite'] = 'JapanPost';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'LaPoste') {

			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['theSite'] = 'LaPoste';
			var thisNo = this.no.replace(/ /g,'');
			this.url = 'http://www.colissimo.fr/portail_colissimo/suivre.do?parcelnumber='+fullEscape(thisNo);
			var thisUrl = 'http://www.laposte.fr/widgetcourrier/php/suiviCourrierJSONproxy.php?code='+fullEscape(thisNo);
			this.loadPage(thisUrl,getJSON,false,theArgs);

		} else if (this.fromClass == 'OnTrac') {

			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['theSite'] = 'OnTrac';
			this.url = 'https://www.ontrac.com/trackingres.asp?tracking_number='+fullEscape(this.no);
			this.loadPage(this.url,getOnTrac,false,theArgs);

		} else if (this.fromClass == 'Parcelforce') {

			this.url = 'http://www.parcelforce.com/portal/pw/track?trackNumber='+fullEscape(this.no);
			this.loadCookiePage(this.url,getParcelforce,false,false);

		} else if (this.fromClass == 'Post-at') {

			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['theSite'] = 'Post.at';
			this.url = 'https://nachschau.post.at/SendungsSuche.aspx?lang='+translate('xx')+'&pnum1='+fullEscape(this.no);
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'PostDanmark') {

			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['lang'] =  (translate('xx') == 'da') ? 'IND' : 'INE';
			this.url = 'http://www.postdanmark.dk/tracktrace/TrackTrace.do?i_stregkode='+fullEscape(this.no)+'&i_lang='+theArgs['lang']+'&sourceurl=http://www.postdanmark.dk/tracktrace/';

			theArgs['theSite'] = 'PostDanmark';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'Poste-it') {

			var theArgs = new Array();
			theArgs['y'] = 0;

			var kind = '';
			switch (this.from) {
				case 'www.poste.it/posta1':
					kind = 'POSTA1';
					break;
				case 'www.poste.it/pacco1':
					kind = 'PACCO1';
					break;
				case 'www.poste.it/maxi':
					kind = 'POSTA';
					break;
				case 'www.poste.it':
					kind = '';
					break;
				case 'www.poste.it/pacco':
					kind = 'PACCO';
					break;
				case 'www.poste.it/ems':
					kind = 'EMS';
					break;
			}
			if (kind) {
				this.url = 'http://javapc.poste.it/tracking/trackingPacchi?Action=ActionCore&Method=Tracking&PRODOTTO='+kind+'&ID_LDV='+fullEscape(this.no);
			} else this.url = 'http://javapc.poste.it/tracking/trackingPacchi?Action=ActionTracking&Method=Tracking&ldv='+fullEscape(this.no);

			theArgs['theSite'] = 'Poste-it';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'Posten-no') {

			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['lang'] =  (translate('xx') == 'no') ? 'no' : 'en';
			this.url = 'http://sporing.posten.no/sporing.html?layout=normal&lang='+theArgs['lang']+'&q='+fullEscape(this.no);

			theArgs['theSite'] = 'Posten-no';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'Posten-se') {

			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['lang'] = (translate('xx') == 'sv') ? 'SE' : 'GB';

			if (this.no.match(/^[a-z]{2}/i)) {
				this.url = 'http://www.posten.se/tracktrace/TrackConsignments_do.jsp?trackntraceAction=saveSearch&lang='+theArgs['lang']+'&consignmentId='+fullEscape(this.no);
				theArgs['type'] = 1;
			} else {
				this.url = 'http://server.logistik.posten.se/servlet/PacTrack?lang='+theArgs['lang']+'&xslURL=/xsl/pactrack/standard.xsl&kolliid='+fullEscape(this.no);
				theArgs['type'] = 0;
			}

			theArgs['theSite'] = 'Posten-se';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'Purolator') {

			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['lang'] = (translate('xx') == 'fr') ? 'F' : 'E';

			this.url = 'http://shipnow.purolator.com/shiponline/track/purolatortrack.asp?pinno='+fullEscape(this.no)+'&lang='+theArgs['lang'];

			theArgs['theSite'] = 'Purolator';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'RoyalMail') {

			this.url = 'http://www.royalmail.com/portal/rm/track?trackNumber='+fullEscape(this.no);
			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['theSite'] = 'RoyalMail';
			this.loadCookiePage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'Sagawa') {

			this.url = 'http://k2k.sagawa-exp.co.jp/p/web/okurijosearch.do?okurijoNo='+fullEscape(this.no);
			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['theSite'] = 'Sagawa';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'SwissPost') {

			this.url = 'https://www.post.ch/EasyTrack/submitParcelData.do?formattedParcelCodes='+fullEscape(this.no)+';&p_language='+translate('xx');
			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['theSite'] = 'SwissPost';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'TNT') {

			if (this.fromName == 'TNTPost.nl') {

				var theArgs = new Array();
				theArgs['y'] = 0;

				this.url = 'https://tracktrace.tntpostpakketservice.nl/Search/SearchBasic.aspx?B='+fullEscape(this.no);
				this.url += (this.extra) ? '&P='+fullEscape(this.extra) : '&I=True';
				theArgs['theSite'] = 'TNTPost.nl';
				this.loadPage(this.url,getTNTPost,false,theArgs);

			} else {

				var mode = (this.from == 'www.tnt.com/ref') ? 'REF' : 'CON';
				this.url = 'http://www.tnt.com/webtracker/tracking.do?respLang=en&respCountry=US&searchType='+
					fullEscape(mode)+'&cons='+fullEscape(this.no);
				this.loadPage(this.url,getTNT,false,false);

			}

		} else if (this.fromName == 'UPS') {

			this.url = 'http://wwwapps.ups.com/WebTracking/processInputRequest?sort_by=status&tracknums_displayed=1&TypeOfInquiryNumber=T&loc=en_US&track.x=0&track.y=0&InquiryNumber1='+fullEscape(this.no);	
			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['theSite'] = 'UPS';
			this.loadPage(this.url,getMultiple,false,theArgs);

		} else if (this.fromName == 'UPS Mail Innovations') {

			this.url = 'http://www.ups-mi.net/packageID/packageid.aspx?pid='+fullEscape(this.no);
			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['theSite'] = 'UPS Mail Innovations';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'USPS') {

			this.url = 'http://trkcnfrm1.smi.usps.com/PTSInternetWeb/InterLabelInquiry.do?strOrigTrackNum='+fullEscape(this.no);	
			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['theSite'] = 'USPS';
			this.loadPage(this.url,getTracker,false,theArgs);

		} else if (this.fromClass == 'Yamato') {

			thisUrl = 'http://toi.kuronekoyamato.co.jp/cgi-bin/tneko';
			theData = 'number00=1&number01='+fullEscape(this.no);
			this.url = 'http://otodoke.kuronekoyamato.co.jp/otodoke/servlet/jp.co.kuronekoyamato.otodoke.jikan.browser.S_CRTMENQ0000?id='+fullEscape(this.no.replace(/-/g,''));

			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['theSite'] = 'Yamato';
			this.loadPage(thisUrl,getTracker,theData,theArgs);

		} else if (this.fromClass == 'Amazon') {

			this.url = 'https://'+this.domain+'/gp/css/summary/edit.html?ie=UTF8&orderID='+fullEscape(this.no);
			var thisUrl = 'http://'+this.domain+'/gp/flex/sign-out.html/ref=pd_irl_gw_r/?ie=UTF8&path=%2Fgp%2Fyourstore&signIn=1&useRedirectOnSuccess=0&action=sign-out';
			this.loadCookiePage(thisUrl,sessionAmazon,false,false);

		} else if (this.from == 'other') {

			this.url = this.extra;
			if (this.url) {
				if (!this.url.match(/^https?:\/\//i)) this.url = 'http://'+this.url;
				this.loadPage(this.url,getOther,false,false);
			} else {
				if (!iPhone) updateOther(this);
				this.updateItems();
			}

		} else {

			this.count = 0;
			this.items = new Array();
			this.displayed = 0;
			this.updateItems();
		
		}

	}

}

function sessionAdobe () {
	var delivery = this.delivery;
	delivery.loadCookiePage(delivery.url,getAdobe,false,false);
	delivery.reqComplete++;
}

function getAdobe () {

	var delivery = this.delivery;
	var theSections = false;
	var theItems = false;
	var theResult = false;
	var thisResult = false;
	var theStatus = false;
	var trackingUrl = false;
	var x = 0;
	var y = 0;
	var z = 0;

	if (this.responseText) {

		theOutput = stripWhiteSpace(this.responseText);
		if (iPhone) delivery.html = theOutput;

		// Get each section of the order
		theSections = theOutput.match(/<td colspan="5"> ?<strong> ?Package(.*?)(<tbody ?class="?pckg-ovw"?>|<\/table>)/gi);

		for (y in theSections) {

			var thisItem = resetItem();

			// Get the name and status of this section
			theResult = theSections[y].match(/Package [0-9]+:<\/strong> ?(<span[^>]*>)?([^\*<]*)/i);

			if (theResult) {

				if (theResult[2]) theStatus = theResult[2];
				if (theStatus.match(/^shipped/i)) {
	
					// Get the ship date for shipped items
					theResult = theStatus.match(/shipped on (.*)/i);
					if (theResult && theResult[1]) thisItem['shipSaved'] = theResult[1];
					theStatus = 'Shipped';

				} else if (theStatus.match(/^pre-order/i)) {

					// Get the ship date for pre-orders
					theResult = theStatus.match(/pre-order estimated availability date (.*)/i);
					if (theResult && theResult[1]) thisItem['shipSaved'] = theResult[1];

				} else if (theStatus.match(/^expected arrival/i)) {

					// Get the ship date for pre-orders
					theResult = theStatus.match(/expected arrival date (.*)/i);
					if (theResult && theResult[1]) thisItem['deliverySaved'] = theResult[1];

				}
				thisItem['theStatus'] = theStatus;

				// Get the tracking number for shipped items
				theResult = theSections[y].match(/Tracking Number:<\/strong> ?(<a href="?https?:\/\/([^\/]*)[^>]*>)? ?([^<]*)/i);

				if (theResult && theResult[3]) {

					var trackingNo = trim(theResult[3]);
					var theLength = trackingNo.length;
					var trackingSite = (theResult[2]) ? trim(theResult[2]) : null;
					var trackingUrl;
					var theArgs = new Array();
					theArgs['y'] = y;
					theArgs['child'] = true;

					if (trackingSite == 'www.dhl.com' || trackingSite == 'track.dhl-usa.com') {
						theArgs['theSite'] = 'DHL';
					} else if (trackingSite == 'wwwapps.ups.com') {
						theArgs['theSite'] = 'UPS';
					} else if (trackingSite == 'www.fedex.com') {
						theArgs['theSite'] = 'FedEx';
					} else if (trackingNo.substring(0,2) == '1Z') {
						theArgs['theSite'] = 'UPS';
					} else if (theLength == 11) {
						theArgs['theSite'] = 'DHL';
					} else if (theLength == 15 || theLength == 12) {
						theArgs['theSite'] = 'FedEx';
					}

					if (theArgs['theSite'] == 'UPS') {
						trackingUrl = 'http://wwwapps.ups.com/WebTracking/processInputRequest?sort_by=status&tracknums_displayed=1'+
							'&TypeOfInquiryNumber=T&loc=en_US&track.x=0&track.y=0&InquiryNumber1='+fullEscape(trackingNo);
					} else if (theArgs['theSite'] == 'DHL') {
						trackingUrl = 'http://www.dhl.com/content/g0/en/express/tracking.shtml?brand=DHL&AWB='+fullEscape(trackingNo);
					} else if (theArgs['theSite'] == 'FedEx') {
						trackingUrl = 'https://www.fedex.com/Tracking?action=track&language=english&cntry_code=us&initial=x&tracknumbers='+fullEscape(trackingNo);
					}
					
					if (theArgs['theSite']) delivery.loadPage(trackingUrl,getTracker,false,theArgs);

				}

				// Get each item in the section
				theItems = theSections[y].match(/<tr[^>]*> ?<td[^>]*> ?<strong>(<span[^>]*>[^<]*<\/span>)?([^<]*)/gi);
				var firstItem = true;
				for (z in theItems) {

					// Get the name of the item
					theResult = theItems[z].match(/<strong>(<span[^>]*>[^<]*<\/span>)?([^<]*)/i);
					if (theResult && theResult[2]) {
						if (firstItem) {
							firstItem = false;
							thisItem['theItem'] = (delivery.name) ? htmlEntities(delivery.name)+": "+theResult[2] : theResult[2];
						} else thisItem['theItem'] += ", "+theResult[2];
					}
		
				}

				if (x == 0) delivery.items = new Array();
				delivery.items[x] = thisItem;
				x++;

			}

		}

		delivery.count = delivery.items.length;
		if (!delivery.items[0]) delivery.count = 0;

	} else delivery.count = -1;

	if (delivery.count <= 0) {

		// Check for an error message. Doesn't seem to work, but it should...?
		theResult = theOutput.match(/<span class="required">([^<]*)/i);
		if (theResult && theResult[1]) {
			delivery.notFound(theResult[1]);
		} else delivery.notFound();

	}
	delivery.reqComplete++;
	delivery.updateItems();

	return;

}

function sessionAmazon () {

	var delivery = this.delivery;
	if (this.responseText) {

		delivery.showMessage(translate('Getting delivery status…'));
		var theOutput = stripWhiteSpace(this.responseText);
		if (iPhone) delivery.html = theOutput;

		if (theOutput && (theResult = theOutput.match(/<form[^>]*name=.?signIn.?[^>]*action="([^"]*)[^>]*>(.*?)<\/form>/i))) {

			// New login style, works but requires three attempts?
			/* var thisUrl = theResult[1];
			if (thisUrl.charAt(0) == '/') thisUrl = 'https://'+delivery.domain+thisUrl;

			var orderData = 'openid.return_to=https%3A%2F%2F'+delivery.domain+'%2Fgp%2Fcss%2Fsummary%2Fedit.html%3Fie%3DUTF8%26orderID%3D'+fullEscape(delivery.no)+'&openid.pape.max_auth_age=ape%3AOTAw&create=0&email='+fullEscape(delivery.extra)+'&password='+fullEscape(delivery.password);
			var theInputs = theResult[2].match(/<input.*?>/gi);
			for (y in theInputs) {
				if (theResult = theInputs[y].match(/name="(.*?)".*?value="(.*?)"/i)) {
					var theName = theResult[1];
					if (theName != 'create' && theName != 'openid.return_to' && theName != 'openid.pape.max_auth_age' && 
						theName != 'email' && theName != 'password') orderData += '&'+theName+'='+fullEscape(theResult[2]);
				}
			}
			delivery.loadCookiePage(thisUrl,getAmazon,orderData,false); */

			// Or we can force logging in the old way (for now)
			var thisUrl = 'https://'+delivery.domain+'/gp/flex/sign-in/select.html';
			var orderData = 'path=%2Fgp%2Fcss%2Fsummary%2Fedit.html&useRedirectOnSuccess=0&query=orderID%3D'+fullEscape(delivery.no)+
				'&mode=&redirectProtocol=&pageAction=%2Fgp%2Fcss%2Fsummary%2Fedit.html&disableCorpSignUp=&action=sign-in&email='+
				fullEscape(delivery.extra)+'&password='+fullEscape(delivery.password)+'&language=en';
			delivery.loadCookiePage(thisUrl,getAmazon,orderData,false);

		} else if (theOutput && (theResult = theOutput.match(/<form.*?name=.?sign-in.*?action="([^"]*)/i))) {

			theResult = theResult[1];
			if (theResult.charAt(0) == '/') theResult = 'https://'+delivery.domain+theResult;
			var thisUrl = theResult;

			var orderData = 'path=%2Fgp%2Fcss%2Fsummary%2Fedit.html&useRedirectOnSuccess=0&query=orderID%3D'+fullEscape(delivery.no)+
				'&mode=&redirectProtocol=&pageAction=%2Fgp%2Fcss%2Fsummary%2Fedit.html&disableCorpSignUp=&action=sign-in&email='+
				fullEscape(delivery.extra)+'&password='+fullEscape(delivery.password)+'&language=en';
			delivery.loadCookiePage(thisUrl,getAmazon,orderData,false);

		} else delivery.loadCookiePage(delivery.url,getAmazon,false,false);

	} else {
		if (!delivery.count) delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getAmazon () {

	var delivery = this.delivery;
	var theSections = false;
	var theItems = false;
	var theResult = false;
	var thisResult = false;
	var theStatus = '';
	var trackingUrl = false;
	var x = 0;
	var y = 0;
	var yy = 0;
	var z = 0;

	if (this.responseText) {

		theOutput = stripWhiteSpace(this.responseText);
		if (iPhone) delivery.html = theOutput;

		// Get each section of the order
		theSections = theOutput.match(/<a name="?(un)?shipped-items(-[0-9]*)?"?>(.*?)<\/table> ?<br \/>/gi);
		if (!theSections) theSections = theOutput.match(/<a name="?(un)?shipped-items(-[0-9]*)?"?>(.*)/gi);

		for (y in theSections) {

			var thisItem = resetItem();

			// Get the name and status of this section
			theResult = theSections[y].match(/<b class="?sans"?>([^:]*): ?([^<]*)/i);
			if (theResult) {

				thisItem['theItem'] = '';

				if (theResult[2]) {
					theStatus = theResult[2];
					if (theStatus.match(/(Not Yet Shipped|Not Yet Dispatched|Noch nicht versandt|À expédier|Non ancora spedito)/i)) theStatus = '';
				}

				if (theStatus.match(/^shipped/i)) {
	
					// Get the ship date for shipped items
					theResult = theStatus.match(/shipped on (.*)/i);
					if (theResult && theResult[1]) thisItem['shipSaved'] = theResult[1];
					theStatus = 'Shipped';
	
				} else {

					// Get ship date for the japanese store, possibly others
					theResult = theStatus.match(/([0-9]{4}\/[0-9]{1,2}\/[0-9]{1,2})/i);
					if (theResult && theResult[1]) thisItem['shipSaved'] = theResult[1];

					// Get ship date for the german store, possibly others
					theResult = theStatus.match(/([0-9]{1,2}[^a-z]{1,2}[a-z]*.?[0-9]{4})/i);
					if (theResult && theResult[1]) thisItem['shipSaved'] = theResult[1];

				}
				thisItem['theStatus'] = theStatus;

				// Get the tracking number for shipped items
				theResult = theSections[y].match(/<a href="(https:\/\/[^\/]*)?(\/gp\/css\/shiptrack\/[^"]*)">/i);
				if (theResult && theResult[2]) {
					if (theResult[1]) {
						trackingUrl = theResult[1]+theResult[2];
					} else trackingUrl = 'https://'+delivery.domain+theResult[2];

					var theArgs = new Array();
					theArgs['y'] = x;
					theArgs['child'] = true;
					theArgs['theSite'] = 'AmazonTracker';
					delivery.loadCookiePage(trackingUrl,getTracker,false,theArgs);
				}

				// Check if this shipment is split up
				subSections = theSections[y].match(/(.*?)(<hr size="-1" noshade="noshade" color="#CCCC99" \/>|$)/gi);

				for (yy in subSections) {
					if (subSections[yy]) {

						if (yy > 0) var thisItem = resetItem();

						// Get the shipping and delivery estimate for this section
						// First check for it with the sub arrow, then without
						var theResult = subSections[yy].match(/<td(?: valign="top")?>.?(?:<font[^>]*><b>)?.?<b>([^<]*)<\/b>([^<]+)<br \/>[^<]*<img src="?[^"]*arrow_subordinate(?:\.[^\.]*)?\.gif"?[^>]*\/>.?<b>[^<]*<\/b>([^<]*)(?!<\/td>)/i);						
						if (theResult && theResult[2]) {
							thisItem['shipSaved'] = splitDate(theResult[2]);
							if (theResult[3]) thisItem['deliverySaved'] = splitDate(theResult[3]);
						} else {

							theResult = subSections[yy].match(/<td(?: valign="top")?>.?(?:<font[^>]*><b>)?.?<b>([^<]*)<\/b>([^<]*)(?:<br \/>.?<b>[^<]*<\/b>([^<]*))?(?!<\/td>)/i);

							// When two pre-order shipments are grouped into one, the date gets lost for the first. This should catch it.
							subResult = subSections[yy].match(/<tr valign="top"> .?<td valign="top"> .?<b>([^<]*)<\/b>([^<]*)/i);
							if (subResult && trim(subResult[2])) theResult = subResult;

							if (theResult && theResult[2]) {
								if (theResult[1].match(/(Shipping estimate|Dispatch estimate|発送予定日|Voraussichtliches Versanddatum|Date d'envoi estimée|Date d&#39;envoi estim&eacute;e)/i)) {
									thisItem['shipSaved'] = splitDate(theResult[2]);
									if (theResult[3]) thisItem['deliverySaved'] = splitDate(theResult[3]);
								} else thisItem['deliverySaved'] = splitDate(theResult[2]);
							}
						}
			
						// Get each item in the section
						theItems = subSections[yy].match(/<td colspan="1" valign="top">(.*?)<br \/>/gi);
						var firstItem = true;
						for (z in theItems) {
							// Get the name of the item
							theResult = theItems[z].match(/>([^>]*)(<\/a>|<br \/>)/i);
							if (theResult && theResult[1]) {
								if (firstItem) {
									firstItem = false;
									thisItem['theItem'] = (delivery.name)?htmlEntities(delivery.name)+": "+theResult[1]:theResult[1];
								} else thisItem['theItem'] += ", "+theResult[1];
							}
						}

						if (x == 0) delivery.items = new Array();
						delivery.items[x] = thisItem;
						x++;

					}
				}

			}

		}

		delivery.count = delivery.items.length;
		if (!delivery.items[0] || delivery.items[0]['theItem'] == translate('Unknown Item')) delivery.count = 0;

	}

	if (delivery.count == 0) {
		if (delivery.tries < 2) {
			delivery.tries++;
		} else {
			delivery.tries = 0;

			// Check for an error message
			// NEW login: theResult = theOutput.match(/<div id="message_error"[^>]*>.*?<h6>[^<]*<\/h6> ?<p>(.*?)<\/p> ?<\/div>/i);
			theResult = theOutput.match(/<br \/><font color="#990000">([^<]*)/i);
			if (theResult && theResult[1]) {
				theResult = theResult[1].replace(/(\. |。).*/i,'$1');
				delivery.notFound(theResult);
			} else {
				if (theOutput.match(/<h2>We're sorry!<\/h2> ?An error occurred when we tried to process your request./)) delivery.count = -1;
				delivery.notFound();
			}
		}
	} else delivery.tries = 0;

	if (delivery.tries == 0) {
		delivery.reqComplete++;
		delivery.updateItems();
	} else {
		this.sessionAmazon = sessionAmazon;
		this.sessionAmazon();
	}

	return;

}

function getApple () {

	var delivery = this.delivery;
	var theSections = false;
	var theItems = false;
	var theResult = false;
	var thisResult = false;
	var theStatus = false;
	var sectionShipped = false;
	var sectionDelivered = false;
	var trackingUrl = false;
	var trackingNo = false;
	var cancelledItems = false;
	var x = 0;
	var y = 0;
	var z = 0;
	var thisItem = resetItem();

	if (this.status == 200 && this.responseText) {

		theOutput = stripWhiteSpace(this.responseText);
		if (iPhone) delivery.html = theOutput;

		// Get each section of the order
		theSections = theOutput.match(/<div class="headerTextwhite"> ([^<]*) (.*?) (<div class="rightHeader">|<div class="rightClearer">)/gi);

		for (y in theSections) {

			sectionShipped = false;
			sectionDelivered = false;
			thisItem = resetItem();

			// Get the status of this section: not yet shipped, shipped, complete, or replaced with new product
			// If no status is found, assume it's the same as the previous item
			theResult = theSections[y].match(/<div class="headerTextwhite">([^<]*)/i);
			if (theResult && theResult[1]) theStatus = trim(theResult[1]);

			// Skip replaced or cancelled items
			// Cancelled - Replaced with New Product ?
			if (!theStatus.match(/^(Replaced with New Product|Cancelled|Returns Completed)$/i)) {

				// Get each item in the section
				theItems = theSections[y].match(/(<div class="(rightSubheader|infoRight)">|<td width="340" class="line">)(.*?)<td colspan="7"> ?&nbsp; ?<\/td> ?<\/tr>/gi);
				for (z in theItems) {

					if (theStatus.match(/^(Shipped|出荷完了|已出貨)$/i)) {

						// Get the ship date for shipped items
						theResult = theItems[z].match(/(?:Shipped on|出荷日：|出貨日期):? ?<strong> ?([^<]*)/i);
						if (theResult && theResult[1]) {
							sectionShipped = reorderInternationalDate(theResult[1]);
							trackingUrl = false;
							trackingNo = false;
						}

						// Get the tracking number for shipped items
						theResult = theItems[z].match(/<a href=(?:"|')([^"']*)(?:"|') target= ?"carrierPage">([^<]*)/i);
						if (!theResult) theResult = theItems[z].match(/<a target="carrierpage" href="([^"]*)">/i);
						if (theResult && theResult[1]) {
							trackingUrl = theResult[1];
							trackingNo = theResult[2];
							trackingUrl = trackingUrl.replace(/&amp;/g,'&');
							if (trackingUrl.charAt(0) == '/') trackingUrl = 'https://store.apple.com'+trackingUrl;
							if (theResult[2]) thisItem['trackingNo'] = theResult[2];
						} else if (theResult = theItems[z].match(/Tracking #: ?<\/span> ?<span[^>]*>([^<]*)/i)) {
							thisItem['trackingNo'] = theResult[1];
						}

						if (trackingUrl) {

							var theArgs = new Array();
							theArgs['y'] = x;
							theArgs['child'] = true;
							theArgs['trackingNo'] = thisItem['trackingNo'];
							theResult = trackingUrl.match(/carrierURL=https?%3A%2F%2F([^%]*)/i);
							if (!theResult) theResult = trackingUrl.match(/https?:\/\/([^\/]*)/i);

							if (theResult && theResult[1]) {
								if (theResult[1] == 'applestore.bridge-point.com') {

									// If there are multiple tracking numbers, we want to be able to match them
									theNos = theItems[z].match(/<a href=(?:"|')([^"']*)(?:"|') target= ?"carrierPage">([^<]*)/gi);
									for (zz in theNos) thisItem['trackingNo'] += ' '+theNos[zz].replace(/<[^>]*>/,'');

									theArgs['theSite'] = 'BridgePoint';
									delivery.loadPage(trackingUrl,getBridgePoint,false,theArgs);

								} else if (theResult[1] == 'apple.mytracking.net') {
									theArgs['theSite'] = 'MyTracking';
									delivery.loadPage(trackingUrl,getTracker,false,theArgs);
								} else if (theResult[1] == 'www.ups.com' || theResult[1] == 'wwwapps.ups.com') {
									theArgs['theSite'] = 'UPS';
									// Currently only set up to parse US formatted results
									trackingUrl = trackingUrl.replace(/loc%3D[a-z]{2}_[A-Z]{2}/,'loc=en_US');
									delivery.loadPage(trackingUrl,getTracker,false,theArgs);
								} else if (theResult[1] == 'www.tnt.com') {
									theArgs['theSite'] = 'TNT';
									trackingUrl = 'http://www.tnt.com/webtracker/tracking.do?respLang=en&respCountry=US&searchType=CON&cons='+fullEscape(trackingNo);
									delivery.loadPage(trackingUrl,getTracker,false,theArgs);
								} else if (theResult[1] == 'www.purolator.com') {
									theArgs['theSite'] = 'Purolator';
									theArgs['lang'] = (translate('xx') == 'fr') ? 'F' : 'E';
									trackingUrl = 'http://shipnow.purolator.com/shiponline/track/purolatortrack.asp?pinno='+
										fullEscape(trackingNo)+'&lang='+theArgs['lang'];
									delivery.loadPage(trackingUrl,getTracker,false,theArgs);
								} else if (theResult[1] == 'toidirect.kuronekoyamato.co.jp') {
									theArgs['theSite'] = 'Yamato';
									delivery.loadPage(trackingUrl,getTracker,false,theArgs);
								} else {
									theArgs['theSite'] = 'FedEx';
									delivery.loadPage(trackingUrl,getTracker,false,theArgs);
								}
							}

						}
		
					}

					thisItem['theStatus'] = theStatus;
		
					// Get the name of the item
					theResult = theItems[z].match(/<td width="340" class="[^"]*"> ?<div(?: class="")?> ?([^<]*)/i);
					if (theResult && theResult[1]) {
						thisItem['theItem'] = (delivery.name)?htmlEntities(delivery.name)+": "+theResult[1]:theResult[1];
					}

					if (sectionShipped) thisItem['shipSaved'] = sectionShipped;
					if (sectionDelivered) thisItem['deliverySaved'] = sectionDelivered;

					thisResult = theItems[z].match(/(?:Estimated Delivery|Delivers on|Delivers by|Delivers|お届け予定日：|運送日期):? ?([^<]*)/i);
					if (thisResult && thisResult[1]) {
						thisItem['deliverySaved'] = reorderInternationalDate(splitDate(thisResult[1]));
					}

					thisResult = theItems[z].match(/(?:Estimated Shipping|Ships by|Estimated Ship|Ships|出荷日：|已上市):? ?([^<]*)/i);
					if (thisResult && thisResult[1]) {
						var thisShip = splitDate(thisResult[1]);
						thisResult = thisShip.match(/(?:Estimated Delivery|Delivers on|Delivers by|Delivers|お届け予定日：|運送日期):? ?([a-z]+ [0-9]{1,2}|[0-9]{1,2}\/[0-9]{1,2})/i);
						if (thisResult && thisResult[1]) {
							if (!thisItem['deliverySaved']) thisItem['deliverySaved'] = thisResult[1];
						} else thisItem['shipSaved'] = reorderInternationalDate(thisShip);
					}

					if (z == 0) {
						if (!sectionShipped) sectionShipped = thisItem['shipSaved'];
						if (!sectionDelivered) sectionDelivered = thisItem['deliverySaved'];
					}

					if (x == 0) delivery.items = new Array();
					delivery.items[x] = thisItem;
					thisItem = resetItem();
					thisItem['trackingNo'] = delivery.items[x]['trackingNo'];
					x++;

				}

			} else cancelledItems = true;

		}

		delivery.count = delivery.items.length;
		if (!delivery.items[0] || delivery.items[0]['theItem'] == translate('Unknown Item')) delivery.count = 0;

		if (x == 0) {
			if (cancelledItems) {
				delivery.count = 1;
				delivery.items[0] = resetItem();
				delivery.items[0]['theItem'] = translate('No Items Found');
				delivery.items[0]['shipDate'] = translate('Your order contains only items that'); 
				delivery.items[0]['shipDays'] = delivery.items[0]['shipDate'];
				delivery.items[0]['deliveryDate'] = translate('have been cancelled or replaced.');
				delivery.items[0]['deliveryDays'] = delivery.items[0]['deliveryDate'];
			} else if (theOutput.match(/(Apple's Online and phone Order Status services are temporarily unavailable due to a scheduled upgrade to our systems|error in session title)/i)) {
				delivery.count = -1;
				delivery.notFound();
			} else {
				delivery.count = 0;
				delivery.notFound();
			}
		}

	} else {
		if (!delivery.count) delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getGoogle () {

	var delivery = this.delivery;
	
	if (this.responseText) {

		theOutput = stripWhiteSpace(this.responseText);

		if (theResult = theOutput.match(/(?:The document has moved <A HREF="([^"]*)">here<\/A>|Click <a href="([^"]*)">here<\/a> if not redirected)/i)) {

			if (!theResult[1]) theResult[1] = theResult[2];
			var thisUrl = theResult[1].replace(/&amp;/g,'&');
			if (thisUrl.charAt(0) == '/') thisUrl = 'https://checkout.google.com'+thisUrl;
			delivery.loadCookiePage(thisUrl,getGoogle,false,false);

		} else if (theResult = theOutput.match(/<meta[^>]*http-equiv="refresh"[^>]*content="[^"]*url=&#39;(.*?)&#39;"[^>]*>/i)) {

			var thisUrl = theResult[1];
			delivery.loadCookiePage(thisUrl,getGoogle,false,false);

		} else if (delivery.tries <= 3 && (theResult = theOutput.match(/<a href="(https?:\/\/www.google.com\/accounts\/ServiceLogin[^"]*)"[^>]*>/i))) {

			delivery.tries++;
			var thisUrl = 'https://www.google.com/accounts/ServiceLogin?service=sierra&nui=5&ltmpl=mobilec&rm=hide&skipvpage=true&btmpl=mobile';
			delivery.loadCookiePage(thisUrl,getGoogle,false,false);

		} else if (delivery.tries <= 3 && (theResult = theOutput.match(/<form.*?id="gaia_loginform".*?action= ?"([^"]*)"/i))) {

			delivery.tries++;
			var thisUrl = theResult[1].replace(/&amp;/g,'&');
			if (thisUrl.charAt(0) == '/') {
				thisUrl = 'https://checkout.google.com'+thisUrl;
			} else if (thisUrl.charAt(0) != 'h') {
				thisUrl = 'https://checkout.google.com/accounts/'+thisUrl;
			}	

			theResult = theOutput.match(/<input type="hidden".*?name="GALX".*?value="([^"]*)"/i);
			if (theResult) var GALX = theResult[1];

			orderData = 'service=sierra&continue=https%3A%2F%2Fcheckout.google.com%2Fm%2Fview%2Freceipt%3Ft%3D'+fullEscape(delivery.no)+
				'%26upgrade%3Dtrue&nui=5&skipvpage=true&rm=hide&ltmpl=mobilec&btmpl=mobile&Email='+
				fullEscape(delivery.extra)+'&Passwd='+fullEscape(delivery.password)+'&GALX='+GALX;

			delivery.loadCookiePage(thisUrl,getGoogle,orderData,false);

		} else if (delivery.tries <= 3 && (theResult = theOutput.match(/<h3>\s*Purchase history\s*<\/h3>/i))) {

			delivery.tries++;
			var thisUrl = 'https://checkout.google.com/m/view/receipt?t='+fullEscape(delivery.no);
			delivery.loadCookiePage(thisUrl,getGoogle,false,false);

		} else {

			delivery.tries++;
			if (iPhone) delivery.html = theOutput;

			var theSections = false;
			var theResult = false;
			var lastResult = false;
			var theStatus = false;
			var theseDetails = new Array();
			var x = 0;
			var y = 0;

			var statusRegEx = /<ul class="progress"><li><b>([^<]*)<\/b> <span class="nb">(.*?)<\/span><\/li>/i
			var itemRegEx = /<tr><td class="item">(.*?)<\/tr>/gi

			// Get the main order status and date
			theResult = theOutput.match(statusRegEx);
			if (theResult && theResult[1]) {
				theseDetails['date'] = theResult[1];
				theseDetails['status'] = theStatus = theResult[2];
				theseDetails['location'] = '';
			}

			// Get each section of the order
			theSections = theOutput.match(itemRegEx);
			for (y in theSections) {

				var thisItem = resetItem();
				thisItem['theDetails'] = theseDetails;

				theResult = theSections[y].match(/<td class="item">(.*?)<\/td>/i);
				if (theResult && theResult[1] && !theResult[1].match(/^(Shipping|Tax):/i)) {

					thisItem['theItem'] = (delivery.name)?htmlEntities(delivery.name)+": "+theResult[1]:theResult[1];
					if (x == 0) delivery.items = new Array();

					// Get the tracking number for shipped items
					theResult = thisItem['theDetails']['status'].match(/<a href="([^"]*)">Track/i);
					if (theResult && theResult[1]) {
						trackingUrl = removeHtmlEntities(theResult[1]);
						var theArgs = new Array();
						theArgs['y'] = x;
						theArgs['child'] = true;
						theResult = trackingUrl.match(/https?:\/\/([^\/]*)/i);
						if (theResult && theResult[1]) {
							if (theResult[1] == 'wwwapps.ups.com') {
								theArgs['theSite'] = 'UPS';
								delivery.loadPage(trackingUrl,getTracker,false,theArgs);
							} else if (theResult[1] == 'www.fedex.com') {
								theArgs['theSite'] = 'FedEx';
								delivery.loadPage(trackingUrl,getTracker,false,theArgs);
							}
						}
					}

					delivery.items[x] = thisItem;
					x++;
				}
	
			}
	
			delivery.count = delivery.items.length;
			if (!delivery.items[0] || delivery.items[0]['theItem'] == translate('Unknown Item')) delivery.count = 0;
			if (delivery.count == 0) {

				// Check for an error message
				theResult = theOutput.match(/<div class="errormsg"[^>]*>(.*?)\[<a/i);
				if (theResult && theResult[1]) {
					delivery.notFound(theResult[1]);
				} else delivery.notFound();
				
			}

		}

	} else {
		if (!delivery.count) delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getHermes () {

	var delivery = this.delivery;
	delivery.tries++;
	if (this.responseText) {

		theOutput = stripWhiteSpace(this.responseText);
		if (delivery.tries == 1 && (theResult = theOutput.match(/<a[^>]*href="([^"]*)"[^>]*> ?Sendungsstatus ?<\/a>/i))) {

			var thisUrl = 'https://www.myhermes.de'+theResult[1];
			delivery.loadPage(thisUrl,getHermes,false,false);

		} else if (delivery.tries <= 3 && (theResult = theOutput.match(/<form name=".*_AuftragSucheForm" method="post" action="([^#"]*)/i))) {

			if (errorResult = theOutput.match(/<span class="fehlermeldung">(.*?)<\/span>/i)) {
				delivery.tries = 0;
				delivery.count = 0;
				delivery.notFound(stripHTML(errorResult[1]));
			} else {
				var thisUrl = theResult[1];
				if (thisUrl.charAt(0) == '/') thisUrl = 'https://www.myhermes.de'+thisUrl;
				thisUrl += '?auftragsNummer='+delivery.no.replace(/\./g,'');
				delivery.loadPage(thisUrl,getHermes,false,false);
			}

		} else {

			delivery.tries = 0;
			this.args = new Array();
			this.args['y'] = 0;
			this.args['theSite'] = 'HLG';
			delivery.reqCount++;
			this.getTracker();

		}

	} else {
		if (!delivery.count) delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getHongkong () {

	var delivery = this.delivery;
	theOutput = stripWhiteSpace(this.responseText);
	var theResult = theOutput.match(/<!-- #[a-z]* --> ?<tr> ?<td> ?<a href="([^"]*)">/i);
	if (theResult && theResult[1]) {

		delivery.url = theResult[1].replace(/&amp;/g,'&');
		var theArgs = new Array();
		theArgs['y'] = 0;
		theArgs['theSite'] = 'HongkongPost';
		theArgs['type'] = 1;
		delivery.loadPage(delivery.url,getTracker,false,theArgs);

	} else {

		this.args = new Array();
		this.args['y'] = 0;
		this.args['theSite'] = 'HongkongPost';
		this.args['type'] = 0;
		delivery.reqCount++;
		this.getTracker();

	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getTNT () {

	var delivery = this.delivery;
	var theSections = false;
	var theItems = false;
	var theResult = false;
	var theseDetails;
	var x = 0;
	var y = 0;
	var thisItem = resetItem();

	if (this.status == 200 && this.responseText) {

		theOutput = stripWhiteSpace(this.responseText);
		if (iPhone) delivery.html = theOutput;

		// Get each section of the page
		theSections = theOutput.match(/<a xmlns="" name="[^"]*">(.*?)<\/table> ?<\/td> ?<\/tr> ?<\/table>/gi);

		for (y in theSections) {

			theResult = theSections[y].match(/(?:Consignment|Reference) ?<\/td> ?<td[^>]*> ?<b>([^<]*)/i);
			if (theResult) {

				if (delivery.name) {
					if (theSections.length > 1 && theResult[1]) {
						thisItem['theItem'] = htmlEntities(delivery.name)+': '+trim(theResult[1]);
					} else thisItem['theItem'] = htmlEntities(delivery.name);
				} else if (trim(theResult[1])) {
					thisItem['theItem'] = trim(theResult[1]);
				} else thisItem['theItem'] = htmlEntities(delivery.no);

				// Get the details
				theResult = theSections[y].match(/<tr vAlign="top"><td noWrap="true">([0-9]+ [a-z]+ [0-9]+)[^<]*<\/td><td>([^<]*)<\/td><td>([^<]*)<\/td><td>([^<]*)/i);
				if (theResult && theResult[1]) {
					thisItem['theDetails']['date'] = theResult[1];
					thisItem['theDetails']['location'] = theResult[3];
					thisItem['theDetails']['status'] = theResult[4];
				}

				theResult = theSections[y].match(/<tr valign="top"> ?<td[^>]*>[^<]*<\/td> ?<td>[^<]*<\/td> ?<td>[^<]*<\/td> ?<td>([a-z0-9\s]*)/i);
				if (theResult && theResult[1].match(/^(Delivered|Shipment Delivered)/i)) {
					thisItem['theStatus'] = 'Complete';
					thisItem['deliverySaved'] = stripHTML(thisItem['theDetails']['date']);
				} else {
		
					// Get the ship date  
					theResult = theSections[y].match(/Pick up date ?<\/td> ?<td[^>]*> ?<b>([a-z0-9\s]*)/i);
					if (theResult && theResult[1]) thisItem['shipSaved'] = theResult[1];

					// Get the delivery date  
					theResult = theSections[y].match(/Delivery Date ?<\/td> ?<td[^>]*> ?<b>(?:[0-9]{1,2}\:[0-9]{1,2}, )?([a-z0-9\s]*)/i);
					if (theResult && theResult[1]) thisItem['deliverySaved'] = theResult[1];

				}

				if (x == 0) delivery.items = new Array();
				delivery.items[x] = thisItem;
				thisItem = resetItem();
				x++;

			}

		}

		if (x == 0) {
			// Check if it's a not found page or a connection error
			if (theOutput.match(/<td colspan="3"> ?Not Found ?<\/td>/i)) {
				delivery.count = 0;
			} else if (!delivery.count) {
				delivery.count = -1;
			}
			delivery.notFound();
		} else delivery.count = delivery.items.length;

	} else {
		if (!delivery.count) delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getTNTPost () {

	var delivery = this.delivery;

	if (!this.responseText) this.responseText = '';
	if (theResult = this.responseText.match(/Object moved to <a href="([^"]*)">here<\/a>/i)) {

		var thisUrl = unescape(theResult[1]);
		if (thisUrl.charAt(0) == '/') thisUrl = 'https://tracktrace.tntpostpakketservice.nl'+thisUrl;
		var theArgs = new Array();
		theArgs['y'] = 0;
		theArgs['theSite'] = 'TNTPost.nl';
		theArgs['type'] = 1;
		delivery.loadCookiePage(thisUrl,getTracker,false,theArgs);

	} else {

		this.args = new Array();
		this.args['y'] = 0;
		this.args['theSite'] = 'TNTPost.nl';
		this.args['type'] = 0;
		delivery.reqCount++;
		this.getTracker();

	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getBridgePoint () {

	var delivery = this.delivery;
	var theSections = false;
	var theResult = false;
	var x = 0;
	var y = 0;
	var z = 0;

	if (this.status == 200 && this.responseText) {

		theOutput = stripWhiteSpace(this.responseText);

		// Get each section of the page
		theSections = theOutput.match(/<table border="?0"? align="?center"? class="?maxtable"?>(.*?)<tr class="?productHeader"?> ?<td colspan="?3"?> ?&nbsp; ?<\/td> ?<\/tr> ?<\/table>/gi);

		for (y in theSections) {

			var thisItem = -1;
			if (theSections.length > 1) {

				// Attempt to match the tracking with an item
				
				var trackingNo = theSections[y].match(/(?:Carrier Tracking Number|Spediteur-Referenz-Nummer|Trackingsnummer vervoerder|Numéro de suivi du transporteur|Budfirmaets sporingsnummer|Número de seguimiento del transportista|Numero di tracking del corriere|Número de localização da empresa transportadora|Budfirmans spårningsnummer) ?<\/td> ?<\/tr> ?<tr> ?<td[^>]*> ?([^<]*)/i);
				var referenceNo = theSections[y].match(/(?:Our Delivery Reference Number|Unsere Lieferreferenznummer|Ons leveringsnummer|Référence d’expédition Apple|Vårt referansenummer på leveransen|Número de referencia del envío|Numero di riferimento spedizione interno|O nosso número de referência para o envio|Vårt leveransreferensnummer) ?<\/td> ?<\/tr> ?<tr> ?<td[^>]*> ?([^<]*)/i);

				for (x in delivery.items) {
					if (trackingNo && trackingNo[1] && delivery.items[x]['trackingNo']) {
						if (delivery.items[x]['trackingNo'].search(trackingNo[1]) >= 0) {
							thisItem = x;
							break;
						}
					}
					if (referenceNo && referenceNo[1] && delivery.items[x]['trackingNo']) {
						if (delivery.items[x]['trackingNo'].search(referenceNo[1]) >= 0) {
							thisItem = x;
							break;
						}
					}
				}

			} else thisItem = this.args['y'];

			if (thisItem != -1) {

				var thisShipDate;
				var thisDeliverLoc;

				// Get the ship date and location
				theResult = theSections[y].match(/(?:Shipped to|Versendet an|Verzonden naar|Adresse d’expédition|Sendt til|Destino|Spedito a|Expedido para|Skickat till) ?<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)/i);
				if (theResult) {
					thisDeliverLoc = theResult[1];
					thisShipDate = theResult[2];
				}

				// Get the details
				theResult = theSections[y].match(/(?:Current Delivery Status|Aktueller Lieferstatus|Huidige bezorgstatus|État actuel de l’expédition|Nåværende leveringsstatus|Estado actual del envío|Stato attuale della consegna|Estado da actual entrega|Aktuell leveransstatus)<\/TD><TD>([^<]*)<\/TD><TD CLASS=dateColumn>([^<]*)/i);
				if (theResult && theResult[1]) {
					delivery.items[thisItem]['theDetails']['date'] = theResult[2];
					delivery.items[thisItem]['theDetails']['status'] = theResult[1];
				}

				theResult = theSections[y].match(/(?:Current Delivery Status|Aktueller Lieferstatus|Huidige bezorgstatus|État actuel de l’expédition|Nåværende leveringsstatus|Estado actual del envío|Stato attuale della consegna|Estado da actual entrega|Aktuell leveransstatus)<\/td><td[^>]*>([^<]*)/i);
				if (theResult && theResult[1].match(/^(Delivered|Geliefert|Geleverd|Livré|Utlevert|Entregado|Consegnato|Entregue|Levererat)$/i)) {

					delivery.items[thisItem]['theStatus'] = 'Complete';
					delivery.items[thisItem]['deliverySaved'] = delivery.items[thisItem]['theDetails']['date'];
					if (thisDeliverLoc) delivery.items[thisItem]['theDetails']['location'] = thisDeliverLoc;

				} else {

					if (thisShipDate) delivery.items[thisItem]['shipSaved'] = thisShipDate;
	
					// Get the delivery date  
					theResult = theSections[y].match(/(?:Estimated Delivery Date|Voraussichtliches Lieferdatum|Verwachte bezorgdatum|Date de livraison estimée|Beregnet leveringsdato|Fecha de entrega prevista|Data di consegna stimata|Data prevista de entrega|Beräknat leveransdatum)(?: \([^)]*\))? ?<\/td> ?<td[^>]*>([^<(]*)/i);
					if (theResult && theResult[1]) delivery.items[thisItem]['deliverySaved'] = theResult[1];
	
				}

			}

		}

	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getFedEx () {

	var delivery = this.delivery;
	var theSections = false;
	var theResult = false;
	var x = 0;
	var y = 0;
	var thisItem = resetItem();

	if (this.status == 200 && this.responseText) {

		theOutput = stripWhiteSpace(this.responseText);
		if (iPhone) delivery.html = theOutput;

		theResult = theOutput.match(/<DIV id="associatedShipLink"> ?<A HREF="(.*?)">/i);
		if (theResult && theResult[1]) {

			// If this has multiple packages, look up the others.

			var thisUrl = theResult[1];
			if (thisUrl.charAt(0) == '/') thisUrl = 'https://www.fedex.com'+thisUrl;
			delivery.loadPage(thisUrl,getFedEx,false,false);

		} else if (theSections = theOutput.match(/'<A href=\\"(\/Tracking\/Detail.*?)\\">([^<]*)/gi)) {

			// If this has multiple packages, continue looking up the others.

			for (y in theSections) {

				theResult = theSections[y].match(/'<A href=\\"(\/Tracking\/Detail.*?)\\">([^<]*)/i);
				if (theResult && theResult[1]) {
	
					if (delivery.name) {
						if (theSections.length > 1 && theResult[2]) {
							thisItem['theItem'] = htmlEntities(delivery.name)+': '+theResult[2];
						} else thisItem['theItem'] = htmlEntities(delivery.name);
					} else if (theResult[2]) {
						thisItem['theItem'] = theResult[2];
					} else thisItem['theItem'] = htmlEntities(delivery.no);
	
					var thisUrl = theResult[1];
					if (thisUrl.charAt(0) == '/') thisUrl = 'https://www.fedex.com'+thisUrl;

					var theArgs = new Array();
					theArgs['y'] = y;
					theArgs['child'] = true;
					theArgs['theSite'] = 'FedEx';
					delivery.loadPage(thisUrl,getTracker,false,theArgs);
	
					if (x == 0) delivery.items = new Array();
					delivery.items[x] = thisItem;
					thisItem = resetItem();
					x++;
	
				}
			}
			delivery.count = delivery.items.length;
			if (delivery.count == 0) delivery.notFound();

		} else if (theSections = theOutput.match(/'<input type=\\"radio\\" value=\\"(.*?)\\" name=\\"dup_number_[0-9]*\\">/gi)) {

			// If this has multiple packages, continue looking up the others.

			for (y in theSections) {

				theResult = theSections[y].match(/'<input type=\\"radio\\" value=\\"(.*?)\\" name=\\"dup_number_[0-9]*\\">/i);
				if (theResult && theResult[1]) {
	
					if (delivery.name) {
						thisItem['theItem'] = htmlEntities(delivery.name);
					} else thisItem['theItem'] = htmlEntities(delivery.no);
	
					var thisUrl = 'https://www.fedex.com/Tracking?action=track&language=english&cntry_code=us&initial=x&tracknumbers='+
						delivery.no+'&dup_number_0='+theResult[1];

					var theArgs = new Array();
					theArgs['y'] = y;
					theArgs['child'] = true;
					theArgs['theSite'] = 'FedEx';
					delivery.loadPage(thisUrl,getTracker,false,theArgs);
	
					if (x == 0) delivery.items = new Array();
					delivery.items[x] = thisItem;
					thisItem = resetItem();
					x++;
	
				}
			}
			delivery.count = delivery.items.length;
			if (delivery.count == 0) delivery.notFound();

		} else {

			this.args = new Array();
			this.args['y'] = y;
			this.args['theSite'] = 'FedEx';
			delivery.reqCount++;
			this.getTracker();
		
		}

	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getOnTrac () {

	var delivery = this.delivery;
	if (this.responseText) {

		theOutput = stripWhiteSpace(this.responseText);
		if ((theResult = theOutput.match(/<a href="([^"]*)">DETAILS<\/a>/i))) {

			var thisUrl = theResult[1];
			if (!thisUrl.match(/^https?:\/\//i)) thisUrl = 'https://www.ontrac.com/'+thisUrl;
			delivery.url = thisUrl;
			delivery.loadPage(delivery.url,getTracker,false,this.args);

		} else {
			delivery.reqCount++;
			this.getTracker();
		}

	} else {
		if (!delivery.count) delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getParcelforce () {

	var delivery = this.delivery;	
	if (this.responseText && 
		!this.responseText.match(/Sorry, there has been a problem with the reference number you've entered.\s+Please try again./i)) {

		delivery.tries = 0;
		theOutput = stripWhiteSpace(this.responseText);
		theResult = theOutput.match(/<a href="([^"]*)"><img border="0" alt="Tracking details"/i);
		if (theResult && theResult[1]) {

			var thisUrl = 'http://www.parcelforce.com'+theResult[1];
			var theArgs = new Array();
			theArgs['y'] = 0;
			theArgs['theSite'] = 'Parcelforce';
			theArgs['type'] = 1;
			delivery.loadCookiePage(thisUrl,getTracker,false,theArgs);

		} else {

			this.args = new Array();
			this.args['y'] = 0;
			this.args['theSite'] = 'Parcelforce';
			this.args['type'] = 0;
			delivery.reqCount++;
			this.getTracker();

		}

	} else if (delivery.tries < 2) {

		delivery.tries++;
		delivery.loadCookiePage(delivery.url,getParcelforce,false,false);

	} else {

		delivery.tries = 0;
		if (!delivery.count) delivery.count = -1;
		delivery.notFound();

	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getJSON () {

	var delivery = this.delivery;
	var theResult = false;
	var y = this.args['y'];
	var theSite = this.args['theSite'];
	var theType = this.args['type'];
	var isChild = false; // this.args['child']; not currently used

	if ((this.status == 200 || this.status == 0) && trim(this.responseText)) {

		var deliveredString = /Delivered/i;
		var thisSuccess = true;
		var foundStatus = false;
		var thisStatus;
		var theseDetails = new Array();
		var thisShipped; // ship date, not used yet
		var thisDelivered; // delivery date, not used yet
		var thisError;

		if (!isChild) {
			var thisItem = resetItem();
			thisItem['theItem'] = (delivery.name) ? htmlEntities(delivery.name) : htmlEntities(delivery.no);
			delivery.items = new Array();
			delivery.items[y] = thisItem;
		}

		try {
			var theOutput = JSON.parse(this.responseText);
		} catch(err) {
			var theOutput = new Array();
			thisSuccess = false;
		}

		if (theSite == 'LaPoste') {
			thisSuccess = theOutput.status;
			if (theOutput.link) delivery.url = theOutput.link;
			theseDetails['date'] = theOutput.date;
			theseDetails['status'] = theOutput.message;
			// theseDetails['location'] not included?
			deliveredString = /(Votre colis est livré|Livraison effectuée)/i;
			if (!thisSuccess) thisError = theOutput.message;
		}

		if (!thisStatus) thisStatus = theseDetails['status'];
		if (thisStatus && thisStatus.match(deliveredString)) thisStatus = 'Complete';
		if (thisStatus == 'Complete' && !thisDelivered) thisDelivered = theseDetails['date'];
		if (theseDetails['location'] == undefined) theseDetails['location'] = '';

		if (!thisSuccess) {
			delivery.tries = 0;
			delivery.count = 0;
			delivery.notFound(thisError);
		} else delivery.count = 1;

		if (delivery.items[y]) {
			if (thisStatus) delivery.items[y]['theStatus'] = thisStatus;
			if (theseDetails) delivery.items[y]['theDetails'] = theseDetails;
			if (thisShipped) delivery.items[y]['shipSaved'] = thisShipped;
			if (thisDelivered) delivery.items[y]['deliverySaved'] = thisDelivered;
		}

	} else {
		delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getMultiple () {

	var delivery = this.delivery;
	var theSections = false;
	var theSite = this.args['theSite'];
	var packageRegEx;
	var labelRegEx;

	if ((this.status == 200 || this.status == 0) && this.responseText) {

		theOutput = stripWhiteSpace(this.responseText);
		if (iPhone) delivery.html = theOutput;

		if (theSite == 'DHL') {
			packageRegEx = /<div id="resolveDuplicate[0-9]"[^>]*>(.*?)<a[^>]*> ?Hide Details ?<\/a> ?<\/div>/gi
		} else if (theSite == 'DHL (Germany)') {
			packageRegEx = /<tr[^>]*> ?<th class="explorer_spezial">(.*?)<a class="dlLink"[^>]*>[^<]*<\/a> ?<\/td> ?<\/tr>/gi;
			labelRegEx = /<th[^>]*> ?(?:Packstücknummer|Package number) ([^<]*)/i;
		} else if (theSite == 'UPS') {
			packageRegEx = /<!-- Begin Section Module --> ?<div class="secLvl[^"]*"> ?<fieldset> ?<form[^>]*>(.*?)<\/fieldset> ?<\/div> ?<!-- End Section Module -->/gi;
			labelRegEx = /<input[^>]*name="trackNums"[^>]*value="([^"]*)"[^>]*>/i;
		}

		if (packageRegEx && (theSections = theOutput.match(packageRegEx))) {
			for (var y in theSections) {

				var thisItem = resetItem();
				if (y == 0) delivery.items = new Array();

				var theLabel = false;
				if (labelRegEx) {
					var theResult = theSections[y].match(labelRegEx);
					if (theResult) theLabel = trim(theResult[1]);
				}
				if (delivery.name) {
					if (theSections.length > 1 && theLabel) {
						thisItem['theItem'] = htmlEntities(delivery.name)+': '+theLabel;
					} else thisItem['theItem'] = htmlEntities(delivery.name);
				} else if (theLabel) {
					thisItem['theItem'] = theLabel;
				} else thisItem['theItem'] = htmlEntities(delivery.no);

				delivery.items[y] = thisItem;

				var theArgs = this.args;
				theArgs['y'] = y;
				theArgs['child'] = true;
				delivery.loadSection(theSections[y],theArgs);

			}
			delivery.count = delivery.items.length;
		} else {
			delivery.reqCount++;
			this.getTracker();
		}

	} else {
		delivery.reqCount++;
		this.getTracker();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getTracker () {

	var delivery = this.delivery;
	var theResult = false;
	var y = this.args['y'];
	var theSite = this.args['theSite'];
	var theType = this.args['type'];
	var isChild = this.args['child'];

	if ((this.status == 200 || this.status == 0) && this.responseText) {

		var statusRegEx;
		var statusNo = 1;
		var detailSection;
		var detailRegEx;
		var detailDateNo;
		var detailLocationNo;
		var detailLocationNoExtra = -1;
		var detailStatusNo;
		var detailStatusNoExtra = -1;
		var shipDateRegEx;
		var deliverDateRegEx;
		var deliverLocRegEx;
		var updatedRegEx; // used if there's a second, preferred delivery date
		var deliveredRegEx;
		var deliveredString = /Delivered/i;
		var errorRegEx;
		var connectRegEx;
		var foundStatus = false;
		var thisStatus;
		var theseDetails;
		var thisShipped;
		var thisDelivered;
		var thisError;
		var useCache = true;

		theOutput = stripWhiteSpace(this.responseText);

		if (theSite == 'AmazonTracker') {

			statusRegEx = /<strong ?(?:class="alertgreen")>([^<]*)/i;
			detailRegEx = /<tr> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>(.*?)<\/td> ?<\/tr>/i;
			detailDateNo = 1;
			detailLocationNo = 3;
			detailStatusNo = 4;
			shipDateRegEx = /(?:Shipment Date|発送日|Versanddatum|Date d'expédition|Data di spedizione)(?:&nbsp;|&#160;)? ?(?::|：) ?<\/b><\/td> ?<td[^>]*>([^<]*)/i;
			deliverDateRegEx = /(?:Estimated Arrival|配送予定|Date de livraison estim&eacute;e|Arrivo previsto)(?:&nbsp;|&#160;)? ?(?::|：) ?<\/b><\/td> ?<td[^>]*>([^<]*)/i;
			// deliverLocRegEx = /(?:Destination)(?:&nbsp;|&#160;)? ?(?::|：) ?<\/b><\/td> ?<td[^>]*>([^<]*)/i;
			deliveredString = /^(Delivered|配達を完了しました|Zugestellt|Livré|Consegnato)/i;

		} else if (theSite == 'Aramex') {

			statusRegEx = /(?:<td[^>]*> ?Current Status: ?<\/td> ?<td[^>]*> ?<b> ?<span[^>]*>|<tr> ?<td valign="top" nowrap> ?1<\/a>&nbsp; ?<\/td> ?<td valign="top">[^<]*<\/td> ?<td valign="top">)([^<]*)/i;
			detailRegEx = /<tr> ?<td[^>]*>([^<]*)<\/td> <td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)/i;
			detailDateNo = 2;
			detailLocationNo = 1;
			detailStatusNo = 3;
			// shipDateRegEx = /<td[^>]*>([^<]*)<\/td> ?<td[^>]*>Shipment received at operations facility/i;
			deliverDateRegEx = /<td[^>]*> ?Delivered on: ?<\/td> ?<td[^>]*>([^<]*)/i;
			deliveredString = /(Delivered|Shipment Collected by Consignee)/i;

		} else if (theSite == 'CanadaPost') {

			statusRegEx = detailRegEx = /<tr[^>]*> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)/i;
			statusNo = 4;
			detailDateNo = 1;
			detailLocationNo = 3;
			detailStatusNo = 4;
			deliverDateRegEx = /(?:Date de livraison selon les normes de service|Livraison prévue|Service Standard Delivery Date|Expected Delivery)[^<]*<\/strong>:? ?(?:<b>)?([^<]*)/i;
			updatedRegEx = /(?:Updated Delivery|Livraison mise à jour)[^<]*<\/strong>:? ?(?:<b>)?([^<]*)/i;
			deliveredString = /(Item successfully delivered|Article livré avec succès)/i;
			connectRegEx = /<div id="byTrackingNumber" class="section"> ?<form id="tapByTrackSearch:trackSearch"/i;

		} else if (theSite == 'CityLink') {

			statusRegEx = detailRegEx = /<tbody> ?<tr[^>]*> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)/i;
			statusNo = 3;
			detailDateNo = 1;
			detailStatusNo = 3;
			deliverDateRegEx = /Planned Delivery Date<\/[^>]*> ?<[^>]*>(?:Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday)([^<]*)/i;
			deliveredRegEx = /Current Status ?<\/span> ?<div> ?<h2>([^<]*)/i;
			deliveredString = /Delivered/i;
			errorRegEx = /<h4>Refine your search<\/h4> ?<p>(.*?) below to refine your search: ?<\/p>/i;

		} else if (theSite == 'DHL') {

			statusRegEx = detailRegEx = /<tr> ?<th[^>]*>([A-Z]+, ([^<]*))?<\/th> ?<th[^>]*>[^<]*<\/th> ?<th[^>]*>[^<]*<\/th> ?<th[^>]*>[^<]*<\/th> ?<\/tr> ?<\/thead> ?<tbody> ?<tr> ?<td[^>]*>[^<]*<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)/i;
			statusNo = 3;
			detailDateNo = 2;
			detailLocationNo = 4;
			detailStatusNo = 3;

		} else if (theSite == 'DHL GlobalMail') {

			statusRegEx = detailRegEx = /<tbody> ?<tr[^>]*> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)/i;
			statusNo = 4;
			detailDateNo = 1;
			detailLocationNo = 3;
			detailStatusNo = 4;

		} else if (theSite == 'DHL (Germany)') {

			statusRegEx = /<td class="status">(.*?)<\/td>/i;
			detailRegEx = /<tr> ?(<!-- ?<td[^>]*> ?-->)? ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*> ?<div[^>]*>([^<]*)<\/div> ?<\/td> ?<td[^>]*> ?<div[^>]*>([^<]*)<\/div> ?<\/td> ?<\/tr> ?<\/tbody> ?<\/table>/i;
			detailDateNo = 2;
			detailLocationNo = 3;
			detailStatusNo = 4;
			deliveredRegEx = /<div class="[a-z]*progressbar"[^>]*> ?<span>([0-9]+%)<\/span>/i;
			deliveredString = /100%/i;
			errorRegEx = /(?:<div class="error"> ?<h3>[^<]*<\/h3> ?<p>|<ul id="errorlist"> ?<li>)([^<]*)/i;
			connectRegEx = /<h3>Das System ist zur Zeit sehr ausgelastet!/i;

		} else if (theSite == 'DHL UK') {

			statusRegEx = detailRegEx = /<tr> ?<TD>([^<]*)<\/TD> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)/i;
			statusNo = 1;
			detailDateNo = 2;
			detailLocationNo = 5;
			detailStatusNo = 1;
			connectRegEx = /<h1>Service Unavailable<\/h1>/i;

		} else if (theSite == 'DPD') {

			detailRegEx = /<tr[^>]*> ?<td[^>]*>([^<]*)<br>[^<]*<\/td> ?<td[^>]*>[^<]*(?:<img[^>]*>[^<]*<a[^>]*><b>[^<]*<\/b><\/a>)?[^<]*<br>([^<]*)<\/td> ?<td[^>]*>[^<]*(?:<img[^>]*>[^<]*<a[^>]*><b>[^<]*<\/b><\/a>)?[^<]*<br>([^<]*)<\/td>/i;
			detailDateNo = 1;
			detailLocationNo = 2;
			detailStatusNo = 3;
			deliveredString = /^(Delivered|Zustellung)/i;

			var theSections = theOutput.match(/<tr[^>]*> ?<td[^>]*>([^<]*)<br>[^<]*<\/td> ?<td[^>]*>[^<]*(?:<img[^>]*>[^<]*<a[^>]*><b>[^<]*<\/b><\/a>)?[^<]*<br>([^<]*)<\/td> ?<td[^>]*>[^<]*(?:<img[^>]*>[^<]*<a[^>]*><b>[^<]*<\/b><\/a>)?[^<]*<br>([^<]*)<\/td>/gi);
			if (theSections) detailSection = theSections[theSections.length-1];

		} else if (theSite == 'FedEx') {

			statusRegEx = /<DIV CLASS="detailshipmentstatus"> ?<DIV[^>]*>([^<]*)/i;
			detailRegEx = /{"scanDate":"(.*?)","showReturnToShipper":(.*?),"scanStatus":"(.*?)"(,"scanLocation":"(.*?)")?(,"scanComments":"(.*?)")?(,"GMTOffset":"(.*?)")?(,"scanTime":"(.*?)")?}/i;
			detailDateNo = 1;
			detailLocationNo = 5;
			detailStatusNo = 3;
			// details often displayed in a confusing way
			// detailStatusNoExtra = 7;
			shipDateRegEx = /"shipDate" ?: ?"(.*?)"/i;
			// estimatedDeliveryDate should also work? deliveryDateTime shows up after delivery
			deliverDateRegEx = /"(?:estimatedDateTime)" ?: ?"(.+?)"/i;
			errorRegEx = /<div id="dupTableMsg"[^>]*>([^<]*)/i;
			connectRegEx = /<title>System Currently Unavailable<\/title>/i;

		} else if (theSite == 'GLS') {

			statusRegEx = detailRegEx = /<tr class="resulthead">.*?<tr[^>]*> ?<td>([^<]*)<\/td> ?<td> ?(?:[a-z]{2} [0-9]{3} )?(?:, )?([^<]*)<\/td> ?<td>[^<]*<\/td> ?<td>([^<]*)/i;
			statusNo = 3;
			detailDateNo = 1;
			detailLocationNo = 2;
			detailStatusNo = 3;
			shipDateRegEx = /(?:Pick-Up Date|Abhol-Datum|Date enlèvement|Afhentningsdato): ?<\/td> ?<td class="value"> ?([^<]*)/i;
			deliverDateRegEx = /(?:Delivery Date|Zustell-Datum|Date livraison|Leveringsdato): ?<\/td> ?<td class="value"> ?([^<]*)/i;
			deliveredString = /^(Delivered|Zugestellt|LIVRE|Forsendelsen er leveret)/i;

		} else if (theSite == 'HLG') {

			statusRegEx = detailRegEx = /<tr> ?<td class="content">([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)/i;
			statusNo = 5;
			detailDateNo = 4;
			detailLocationNo = 1;
			detailStatusNo = 5;
			deliveredString = /^(The consignment has been delivered|Die Sendung wurde zugestellt)/i;
			connectRegEx = /(auf Grund von Wartungsarbeiten <br> steht Ihnen unser Sendungsinformationssystem <br> im Moment leider nicht zur Verf&uuml;gung\.|Mit dem praktischen Tarifrechner wissen Sie sofort, wie g&uuml;nstig Hermes ist)/i;

		} else if (theSite == 'HongkongPost') {

			if (theType == 1) {

				statusRegEx = detailRegEx = /<tr> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<\/tr> ?<\/table> ?<!-- #[a-z]* -->/i
				statusNo = 3;
				detailDateNo = 1;
				detailStatusNo = 3;
				detailLocationNo = 2;

			} else {

				statusRegEx = detailRegEx = /<!-- #[a-z]* --> ?(<P[^>]*> ?<IMG[^>]*> ?<a[^>]*>[^<]*<\/a> ?<\/P> ?)?<p>(<span class="textNormalBlack">[^<]*<\/span>[^<]*<\/p>)?(.*?)<br \/>/i;
				statusNo = 3;
				detailStatusNo = 3;
				shipDateRegEx = /<!-- #[a-z]* --> ?<p>.*on ([0-9]{1,2}-[a-z]+-[0-9]{4})/i;

			}
			connectRegEx = /<!-- #[a-z]* --> ?<p> ?The Track and Trace System is temporarily out of service, please try later\./i;

		} else if (theSite == 'JapanPost') {

			detailRegEx = /<tr class="number_search_data"> ?<td nowrap rowspan="2">([^<]*)(<BR>([^<]*))?<\/td> ?<td rowspan="2">([^<]*)<\/td> ?<td rowspan="2">([^<]*)<\/td> ?<td>(.*?)<td rowspan="2">[^<]*<\/td> ?<\/tr> ?<tr[^>]*> ?<td[^>]*>([^<]*)/i;
			detailDateNo = 1;
			detailLocationNo = 6;
			detailLocationNoExtra = 7;
			detailStatusNo = 4;
			detailStatusNoExtra = 5;
			deliverDateRegEx = /(?:Scheduled delivery date:|配達予定日：) ?([^<]*)/i;
			deliveredString = /(Final delivery|お届け先にお届け済み|窓口でお渡し)/i;

			var theSections = theOutput.match(/<tr class="number_search_data"> ?<td nowrap rowspan="2">([^<]*)(<BR>([^<]*))?<\/td> ?<td rowspan="2">([^<]*)<\/td> ?<td rowspan="2">([^<]*)<\/td> ?<td>(.*?<td rowspan="2">[^<]*<\/td> ?<\/tr> ?<tr[^>]*> ?<td[^>]*>[^<]*)/gi);
			if (theSections) detailSection = theSections[theSections.length-1];

		} else if (theSite == 'MyTracking') {

			statusRegEx = /<span id="CurrentStatus"[^>]*>([^<]*)/i;
			detailRegEx = /<tr class="grid grid-item"> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<\/tr>/i;
			detailDateNo = 1;
			detailLocationNo = 4;
			detailStatusNo = 3;
			shipDateRegEx = /<span id="Tenderdate"[^>]*>([^<]*)/i;
			deliverDateRegEx = /<span id="ETA"[^>]*>([^<]*)/i;

		} else if (theSite == 'OnTrac') {

			statusRegEx = /Delivery Status:<\/b> ?<\/TD> ?<TD[^>]*>([^<]*)/i;
			detailRegEx = /<tr> ?<td[^>]*> ?<p>([^<]*)<br \/><\/p> ?<\/td> ?<td[^>]*> ?<p>([^<]*)<br \/> ?<\/p> ?<\/td> ?<td[^>]*> ?<p>([^<]*)/i;
			detailDateNo = 2;
			detailLocationNo = 3;
			detailStatusNo = 1;
			shipDateRegEx = /Ship Date:<\/b> ?<\/TD> ?<TD[^>]*>([^<]*)/i;
			deliverDateRegEx = /(?:Estimated Delivery Time|Service Commitment Time):<\/b> ?<\/TD> ?<TD[^>]*>([^<]*)/i;
			updatedRegEx = /<b>Delivery Time:<\/b> ?<\/TD> ?<TD[^>]*>(?! ?n\/a)([^<]*)/i;

		} else if (theSite == 'Parcelforce') {

			if (theType == 0) { // summary only

				statusRegEx = detailRegEx = /Results<\/b> ?<\/td> ?<\/tr> ?<tr> ?<td>([^<]*)/i;
				statusNo = 1;
				detailStatusNo = 1;
				deliveredString = /has been delivered/i;

			} else if (theType == 1) { // full details

				statusRegEx = /Status: ?<\/b> ?<\/td> ?<td[^>]*>([^<]*)/i;
				detailRegEx = /<tr> ?<td width="75" valign="top">([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)/i;
				detailDateNo = 1;
				detailLocationNo = 3;
				detailStatusNo = 4;

			}

		} else if (theSite == 'Post.at') {

			statusRegEx = detailRegEx = /<tr[^>]*> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([0-9\/\.]+)( [0-9:]+ ?[A-Z]*)?<\/td> ?<td>([^<]*)<\/td> ?<\/tr> ?<\/table>/i;
		 	statusNo = 1;
			detailDateNo = 3;
			detailLocationNo = 2;
			detailStatusNo = 1;
			deliveredString = /(Item delivered to consignee|Sendung an Empf&#228;nger &#252;bergeben|Item delivered acc. to consignees instruction|Sendung laut Empf&#228;ngervereinbarung zugestellt|Item delivered to flat mate|Sendung an Mitbewohner\/in zugestellt)/i;
			connectRegEx = /<h4> ?Die Seite kann nicht angezeigt werden/i;

		} else if (theSite == 'PostDanmark') {

			// Location: ( [0-9]{3,} [A-Za-z ]{3,})?
			statusRegEx = detailRegEx = /<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<\/tr> ?<\/tbody>/i;
		 	statusNo = 3;
			detailDateNo = 1;
			detailStatusNo = 3;
			deliveredString = /(Delivered|Delivered to a|Udleveret|Udleveret til)/i;
			connectRegEx = /(The Track &amp; Trace-service does not work at the moment.<br>|Track &amp; Trace-servicen fungerer desv&aelig;rre ikke i &oslash;jeblikket.<br>)/i;

		} else if (theSite == 'Poste-it') {

			statusRegEx = detailRegEx = /<tr[^>]*> ?<td><font[^>]*>(<b>)?([^<]+)(<\/b>)?<\/font><\/td><td><font size=1>(<b>)?([^<]+)(<\/b>)?<\/font><\/td><td><font[^>]*>(<b>)?([^<]+)(<\/b>)?<\/font><\/td> ?<\/tr>/i;

			if (theOutput.match(statusRegEx)) {
				statusNo = 5;
				detailDateNo = 2;
				detailLocationNo = 8;
				detailStatusNo = 5;
			} else {
				statusRegEx = detailRegEx = /<tr[^>]*> ?<td><font size=1>(<b>)?([^<]+)(<\/b>)?<\/font><\/td> ?<td><font[^>]*>(<b>)?([^<]+)(<\/b>)?<\/font><\/td> ?<td><font[^>]*>(<b>)?([^<]+)(<\/b>)?<\/font><\/td> ?<td><font[^>]*>(<b>)?([^<]+)(<\/b>)?<\/font><\/td> ?<\/tr>/i;
				statusNo = 8;
				detailDateNo = 2;
				detailLocationNo = 11;
				detailStatusNo = 8;
			}
			deliveredString = /consegnat[oai]/i;
			connectRegEx = /^\s*<BR>/i;

		} else if (theSite == 'Posten-no') {

			statusRegEx = /<div class="sporing-sendingandkolli-latestevent-text"> ?<strong>(.*?)<\/strong>/i;
			statusRegEx = detailRegEx = /<tbody> ?<tr> ?<td> ?<div class="sporing-sendingandkolli-latestevent-text">(.*?)<\/div>(.*?)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<\/tr>/i;
			detailDateNo = 3;
			detailLocationNo = 4;
			detailStatusNo = 1;
			deliverDateRegEx = /<span id="sporing-sendingandkolli--latestevent-deliverydate"> ?<strong>([^<]*)/i;
			deliveredString = /(Package has been delivered|Sendingen er utlevert)/i;
			connectRegEx = /<div class="sporing-error-text"> ?(The service is too busy at the moment.|An error has occurred.|Tjenesten er ikke tilgjengelig for øyeblikket.|En feil har oppstått.)/i;

		} else if (theSite == 'Posten-se') {

			if (theType == 0) { // most tracking numbers

				statusRegEx = detailRegEx = /<tr class="trListA"> ?<td valign="top" class="tdListA"> ?([^<]*)<\/td> <td[^>]*> ?([^<]*)<\/td> <td[^>]*> ?([^<]*)<\/td> <td[^>]*> ?([^<]*)<\/td> <\/tr>/i;
				statusNo = 4;
				detailDateNo = 1;
				detailLocationNo = 3;
				detailStatusNo = 4;
				if (this.args['lang'] == 'SE') {
					shipDateRegEx = /<td[^>]*> ?Avs&auml;nt ?<\/td> ?<td[^>]*> ?([^<]*)<\/td>/i;
					deliverDateRegEx = /<td[^>]*> ?Utl&auml;mnat ?<\/td> ?<td[^>]*> ?([^<]*)<\/td>/i;
					deliveredString = /^(Mottagaren har h&auml;mtat f&ouml;rs&auml;ndelsen)/i;
				} else {
					shipDateRegEx = /<td[^>]*> ?Shipment date ?<\/td> ?<td[^>]*> ?([^<]*)<\/td>/i;
					deliverDateRegEx = /<td[^>]*> ?Delivery date ?<\/td> ?<td[^>]*> ?([^<]*)<\/td>/i;
					deliveredString = /(Delivered from post office|Recipient has collected item)/i;
				}

			} else { // tracking numbers that start with two letters

				statusRegEx = detailRegEx = /<td class="firstcol important even">([^<]*)<\/td><td[^>]*>(?:([^,]*),)?([^<]*)<\/td>/i;
				statusNo = 3;
				detailDateNo = 1;
				detailLocationNo = 2;
				detailStatusNo = 3;
				deliverDateRegEx = /<h3>(?:Ber&auml;knad leverans|Estimated time of delivery):<\/h3>(?:Tidigast|At the earliest) ([0-9]+ [a-z]+)/i;
				deliveredString = /(överlämnad till mottagaren|Mottagaren har hämtat försändelsen$|Recipient has collected item$|Försändelsen har lämnats till mottagaren$|Försändelsen är överlämnad till mottagaren\.$|The item has been consigned to the recipient\.$)/;

			}

		} else if (theSite == 'Purolator') {

			statusRegEx = /(?:<input type="hidden" name="deliveryStatus" value="([^"]*)">|<font class="datatext">([^<]*)<\/font>)/i;
			detailRegEx = /<input type="hidden" name="deliveryStatus" value="([^"]*)"> ?<input type="hidden" name="deliveryDateTime" value="([^"]*)"> ?<input type="hidden" name="depot" value="([^"]*)">/i;
			detailDateNo = 2;
			detailLocationNo = 3;
			detailStatusNo = 1;
			deliveredString = /^(Delivered|Livré)/;
			connectRegEx = /An error occured with your request\.<BR>Please try again later\./i;

		} else if (theSite == 'RoyalMail') {

			statusRegEx = /Status: ?<\/b> ?<\/td> ?<td[^>]*>([^<]*)/i;
			if (theOutput.match(statusRegEx)) {

				deliverDateRegEx = /Delivered on: ?<\/b> ?<\/td> ?<td[^>]*>([^<]*)/i;

			} else {

				statusRegEx = detailRegEx = /<div class="track-right-box"> ?<img[^>]*alt='([^']*)'[^>]*\/> ?<p> ?([^<]*([0-9]{2}\/[0-9]{2}\/[0-9]{2})?[^<]*)<\/p> ?(<p>([^<]*))?/i;
				statusNo = 1;
				detailDateNo = 3;
				detailStatusNo = 2;
				detailStatusNoExtra = 5;
				shipDateRegEx = /Your item, posted on ([0-9\/]+)/i;
				deliverDateRegEx = /(?:We have received your item and expect to deliver it (?:before the guaranteed time)?|was delivered from our [a-z\s]*) on ([^.]*)/i;
				deliveredString = /Delivered/i;

			}

		} else if (theSite == 'Sagawa') {

			theOutput = decodeDecimalEntities(theOutput);

			statusRegEx = detailRegEx = /詳細表示 ?<\/TD> ?<TD[^>]*> ?(?:⇒&nbsp;)?([0-9]+年[0-9]+月[0-9]+日)? ?([0-9]+:[0-9]+)? ?([^↑<]*)/i;
			statusNo = 3;
			detailDateNo = 1;
			detailStatusNo = 3;
			shipDateRegEx = /出荷日 ?<\/TD> ?<TD[^>]*> ?([0-9]+年[0-9]+月[0-9]+日)/i;
			deliveredString = /(配達は終了致しました。|配達終了)/i;

		} else if (theSite == 'SwissPost') {

			statusRegEx = detailRegEx = /<tr[^>]*> ?<td[^>]*>(<span[^>]*>[^<]*<\/span>)?([^>]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>(<span[^>]*>[^<]*<\/span>)?([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ? ?<\/tr> ?<\/(tbody|table)>/i;
			statusNo = 5;
			detailDateNo = 2;
			detailLocationNo = 6;
			detailLocationNoExtra = 7;
			detailStatusNo = 5;
			deliveredString = /(delivered|Zugestellt|Distribué|Distribuito|Recapitato)/i;

		} else if (theSite == 'TNT') {

			statusRegEx = detailRegEx = /<tr vAlign="top"><td noWrap="true">([^<]*)<\/td><td>([^<]*)<\/td><td>([^<]*)<\/td><td>([^<]*)/i;
			statusNo = 4;
			detailDateNo = 1;
			detailLocationNo = 3;
			detailStatusNo = 4;
			shipDateRegEx = /(?:Pick up date|提貨日期) ?<\/td> ?<td[^>]*> ?<b>([a-z0-9\s]*)/i;
			deliverDateRegEx = /(?:Delivery Date|送貨日期) ?<\/td> ?<td[^>]*> ?<b>(?:[0-9]+\:[0-9]+, )?([^<]*)/i;
			deliveredString = /^(Delivered|Shipment Delivered)/i;
			connectRegEx = /TNT web services are temporarily unavailable/i;

			if (isChild) {
				var theSections = theOutput.match(/<a[^>]*><br[^>]*><\/a><table[^>]*>(.*?)<\/table><\/td><\/tr><\/table>/gi);
				if (theSections) theOutput = theSections[theSections.length-1];
			}

		} else if (theSite == 'TNTPost.nl') {

			statusRegEx = /<span id="ctl00_DefaultContent_fvShipment_lblStatusData">([^<]*)/i;
			detailRegEx = /<div id="[^"]*" class="columncontainerHighlight"> ?<span[^>]*>([^<:]*):?<\/span> ?<div[^>]*> ?<span[^>]*>([^<]*)<\/span> ?<span[^>]*>([^<]*)/i;
			detailDateNo = 1;
			detailLocationNo = 3;
			detailStatusNo = 2;
			deliveredString = /^(Zending afgeleverd|Parcel delivered|Shipment delivered|Sendung an der Zieladresse zugestellt|Sendung zugestellt|Sendung ausgeliefert|Sendung in Postfach eingelegt|Envoi remis|Envoi déposé dans Boîte Postale)/i;

		} else if (theSite == 'USPS') {

			statusRegEx = /Status: ?<span[^>]*> ?([^<]*)/i;
			// Possible result: <td valign="top" class="mainTextbold">Arrival</td>
			detailRegEx = /<td valign="top" class="mainTextbold">([^<]*?)(,|;) ([a-z]+ [0-9]{1,2}, [0-9]{4})(?:, ([0-9]{1,2}:[0-9]{2} [a-z]{2})(, ([^<]*))?)?/i;
			
			if (theOutput.match(detailRegEx)) {
				detailDateNo = 3;
				detailLocationNo = 6;
				detailStatusNo = 1;
				shipDateRegEx = /facility on ([^.]*)\./i;
			} else {
				// For shipments with only one update
				detailRegEx = /Status: ?<span[^>]*> ?([^<]*)<\/span> ?<br> ?<br>([^\.<]* ([A-Z]+, [A-Z]+ [0-9]+)? (facility)? on ([^\.<]*))./i;
				detailDateNo = 5;
				detailLocationNo = 3;
				detailStatusNo = 1;
			}

			deliverDateRegEx = /(?:(?:Scheduled for Delivery|Expected Delivery Date|Guaranteed Delivery Date): ?<span[^>]*>|delivered at [0-9]+:[0-9]+ [a-z]{2} on) ?(([a-z]+,)? [a-z]+ [0-9]+, [0-9]+)/i;
			connectRegEx = /Track &(amp;)? Confirm is temporarily unavailable/i;

		} else if (theSite == 'UPS') {

			statusRegEx = /<h4> ?<span> ?<a[^>]*>([^<]*)/i;
			detailRegEx = /<tr[^>]*class="(odd|sec-row-od)"> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^<]*>([^<]*)<\/td>/i;
			detailDateNo = 3;
			detailLocationNo = 2;
			detailStatusNo = 5;
			shipDateRegEx = /Shipped&#047;Billed On: ?<\/label> ?<\/dt> ?<dd[^>]*>([^<]*)/i;
			deliverDateRegEx = /(?:Scheduled Delivery|Schedule Delivery|Scheduled Delivery Updated To|Schedule Delivery Updated To|Scheduled For Early Delivery On|Delivered On|Next Delivery Attempt): ?<\/label> ?<\/dt> ?<dd> ?(?:[a-z]*, ?&nbsp; ?)?([0-9\/]+)/i;
			deliverLocRegEx = /To: ?<\/label> ?<\/dt> ?<dd> ?<strong>([^<]*)/i;
			deliveredString = /^(Delivered|Delivered by Local Post Office)$/i;
			// (<p class="error">&gt;&gt;&gt;&nbsp;Not all tracking information is available at this time\. Please try again later\.<br><\/p>|Tracking information is not available at this time. Please try again later\.)
			connectRegEx = /<!-- SearchBodyStart --> ?<!-- SearchBodyEnd -->/i;

		} else if (theSite == 'UPS Mail Innovations') {

			statusRegEx = detailRegEx = /<tr> ?<td class="LeftD_Bottom(L|D)">(.*?)<\/td><td class="LeftL_Bottom(L|D)">(.*?)<\/td><td class="LeftL_Bottom(L|D)_RightD">(.*?)<\/td> ?<\/tr>/i;
			statusNo = 4;
			detailDateNo = 2;
			detailLocationNo = 6;
			detailStatusNo = 4;
			shipDateRegEx = /<font[^>]*>([^<]*)<\/font><\/span> ?<\/td> ?<td[^>]*> ?<span><font[^>]*>Mail Retrieved From Shipper/i;

		} else if (theSite == 'Yamato') {

			statusRegEx = /<a name="AA00"\/>.*?<td class="font14">([^<]*)/i;
			detailRegEx = /<tr[^>]*> ?<td[^>]*> ?<img[^>]*> ?<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>(?:<a[^>]*>)?([^<]*)(?:<\/a>)?<\/td> ?<td>([^<]*)<\/td> ?<\/tr> ?<\/table>/i;
			detailDateNo = 2;
			detailLocationNo = 4;
			detailStatusNo = 1;
			deliverDateRegEx = /(?:お届け予定日時<\/th> ?<\/tr> ?<tr> ?<td[^>]*>[^<]*<br> ?<\/td> ?<td[^>]*>|<tr> ?<td>[^<]*<\/td> ?<td>[^<]*(?:<br>)?<\/td> ?<td>[^<]*(?:<br>)?<\/td> ?<td>(?:<a[^>]*>)?[^<]*(?:<\/a>)?<\/td> ?<td>[^<]*<\/td> ?<td>)([0-9]{1,2}\/[0-9]{1,2})/i;
			deliveredString = /^(配達完了|投函完了)/i;

		}

		if (!isChild) {
			if (useCache && iPhone) delivery.html = cleanHTML(theOutput,delivery.from);
			var thisItem = resetItem();
			thisItem['theItem'] = (delivery.name) ? htmlEntities(delivery.name) : htmlEntities(delivery.no);
			delivery.items = new Array();
			delivery.items[y] = thisItem;
		}

		// Get the ship date
		if (shipDateRegEx) {
			theResult = theOutput.match(shipDateRegEx);
			if (theResult && theResult[1]) thisShipped = theResult[1];
			if (thisShipped == '--') thisShipped = false;
		}

		// Get the delivery date  
		theResult = theOutput.match(deliverDateRegEx);
		if (updatedRegEx) {
			thisResult = theOutput.match(updatedRegEx);
			if (thisResult) theResult = thisResult;
		}
		if (theResult && theResult[1]) {
			thisDelivered = theResult[1];
			// Remove time estimates from FedEx orders if necessary
			if (theSite == 'FedEx') thisDelivered = thisDelivered.replace(/(by [0-9]{1,2}:[0-9]{2} (AM|PM))/i,'');
			if (thisDelivered == '--') thisDelivered = false;
		}

		// Get the status
		if (statusRegEx && (theResult = theOutput.match(statusRegEx))) {
			if (theResult[statusNo]) {
				foundStatus = true;
				thisStatus = theResult[statusNo];
			} else if (theSite == 'Purolator' && theResult[2]) {
				foundStatus = true;
				thisStatus = theResult[2];
			}			
			thisStatus = stripHTML(thisStatus);
		}

		// Get the details
		theResult = (detailSection) ? detailSection.match(detailRegEx) : theOutput.match(detailRegEx);
		if (theResult) {

			theseDetails = new Array();
			theseDetails['date'] = theResult[detailDateNo];

			var detailResult = theResult[detailStatusNo];
			if (theSite == 'Posten-no') detailResult = detailResult.replace(/\&lt;/g,'<');
			theseDetails['status'] = stripHTML(detailResult);

			if (detailStatusNoExtra >= 0 && theResult[detailStatusNoExtra]) theseDetails['status'] += ' '+theResult[detailStatusNoExtra];
			if (detailLocationNo) theseDetails['location'] = theResult[detailLocationNo];
			if (detailLocationNoExtra >= 0 && theResult[detailLocationNoExtra]) theseDetails['location'] += ' '+theResult[detailLocationNoExtra];
			if (theseDetails['location'] == undefined) theseDetails['location'] = '';

		}

		if (!thisStatus && theseDetails) thisStatus = theseDetails['status'];
		if (deliveredRegEx) {
			thisResult = theOutput.match(deliveredRegEx);			
			if (thisResult && thisResult[1] && thisResult[1].match(deliveredString)) thisStatus = 'Complete';
		} else if (thisStatus && thisStatus.match(deliveredString)) {
			thisStatus = 'Complete';
		}

		if (theseDetails) {

			if (thisStatus == 'Complete') {
				if (!thisDelivered) thisDelivered = theseDetails['date'];
				if (deliverLocRegEx) {
					theResult = theOutput.match(deliverLocRegEx);
					if (theResult && theResult[1]) theseDetails['location'] = theResult[1];
				}
			}

			if (theSite == 'AmazonTracker' || theSite == 'DHL (Germany)') {
				theseDetails['location'] = theseDetails['location'].replace(/^ ?-+ ?$/i,'');
			} else if (theSite == 'DHL') {
				theseDetails['status'] = theseDetails['status'].replace(trim(theseDetails['location']),'');
			} else if (theSite == 'HongkongPost' && theType == 0) {
				theseDetails['date'] = thisShipped;
				thisShipped = false;		
			} else if (theSite == 'Parcelforce') {
				if (thisStatus && !theseDetails['status']) theseDetails['status'] = thisStatus;
			}

		}

		if (isChild) {
			if (connectRegEx && theOutput.match(connectRegEx)) {
				if (delivery.previousItems) delivery.items = delivery.previousItems;
				thisStatus = theseDetails = thisShipped = thisDelivered = false;
				delivery.notFound();
			}
		} else {
			if (!foundStatus && !thisShipped && !thisDelivered && !theseDetails) {
				if (connectRegEx && theOutput.match(connectRegEx)) {
					if (!delivery.count) {
						delivery.count = -1;
					} else delivery.items = delivery.previousItems;
					delivery.notFound();
				} else if (theSite == 'TNTPost.nl' && delivery.tries < 1) {
					delivery.tries++;
					delivery.loadCookiePage(delivery.url,getTracker,false,this.args);
				} else {
					delivery.tries = 0;
					delivery.count = 0;
					if (errorRegEx) {
						theResult = theOutput.match(errorRegEx);
						if (theResult) thisError = theResult[1];
					}
					delivery.notFound(thisError);
				}
			} else delivery.count = 1;
		}

		if (delivery.items[y]) {
			if (thisStatus) delivery.items[y]['theStatus'] = thisStatus;
			if (theseDetails) delivery.items[y]['theDetails'] = theseDetails;
			if (thisShipped) delivery.items[y]['shipSaved'] = thisShipped;
			if (thisDelivered) delivery.items[y]['deliverySaved'] = thisDelivered;
		}

	} else if (isChild) {

		if (delivery.previousItems) delivery.items = delivery.previousItems;
		delivery.notFound();

	} else {

		var connectRegEx = '';
		switch (theSite) {
			case 'UPS':
				connectRegEx = /Tracking information is not available at this time\. Please try again later\./i;
				break;
			case 'Posten-no':
				connectRegEx = /<h1>Feilmelding: Feil i underliggende system<\/h1>/i;
				break;
		}
		if (connectRegEx && this.responseText) {
			theOutput = stripWhiteSpace(this.responseText);
			if (theOutput.match(connectRegEx)) {
				if (!delivery.count) delivery.count = -1;
			} else delivery.count = 0;
		} else if (!delivery.count) {
			delivery.count = -1;
		}
		delivery.notFound();

	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getFromName (from,translateName,dropDown) {

	switch(from) {

		case 'www.adobe.com':
			var thisName = 'Adobe';
			if (dropDown) thisName += ' – '+translate('US and Canada');
			break;
		case 'www.apple.com':
			var thisName = 'Apple';
			if (dropDown) thisName += ' – '+translate('by email address');
			break;
		case 'www.apple.com/zip':
			var thisName = 'Apple';
			if (dropDown) thisName += ' – '+translate('by zip code');
			break;
		case 'www.apple.com/japan':
			var thisName = 'Apple';
			if (dropDown) thisName += ' – Japan, '+translate('by email address');
			break;
		case 'www.apple.com/japanzip':
			var thisName = 'Apple';
			if (dropDown) thisName += ' – Japan, '+translate('by zip code');
			break;
		case 'www.apple.com/hk':
			var thisName = 'Apple';
			if (dropDown) thisName += ' – Hong Kong';
			break;
		case 'www.aramex.com':
			var thisName = 'Aramex';
			break;
		case 'em.canadapost.ca':
			var thisName = (translateName) ? translate('Canada Post') : 'Canada Post';
			break;
		case 'www.city-link.co.uk':
			var thisName = 'City Link';
			break;			
		case 'www.dhl.com':
		case 'track.dhl-usa.com':
			var thisName = 'DHL';
			if (dropDown) thisName += ' – Express';
			break;
		case 'www.dhlglobalmail.com':
			var thisName = 'DHL';
			if (dropDown) thisName += ' – '+translate('US')+' GlobalMail';
			break;
		case 'nolp.dhl.de':
		case 'nolp.dhl.de/int':
			var thisName = 'DHL';
			if (dropDown) thisName += ' – '+translate('Germany');
			break;
		case 'www.dhl.co.uk':
			var thisName = 'DHL';
			if (dropDown) thisName += ' – '+translate('UK Domestic');
			break;
		case 'www.dpd.com':
			var thisName = 'DPD';
			if (dropDown) thisName += ' – '+translate('Germany');
			break;
		case 'www.fedex.com':
		case 'spportal.fedex.com':
			var thisName = 'FedEx';
			break;
		case 'www.gls-germany.com':
			var thisName = 'GLS';
			break;
		case 'checkout.google.com':
			var thisName = 'Google Checkout';
			break;
		case 'www.hlg.de':
			var thisName = 'Hermes Logistik Gruppe';
			if (dropDown) thisName += ' – '+translate('Germany');
			break;
		case 'www.hongkongpost.com':
			var thisName = 'Hongkong Post';
			break;
		case 'www.japanpost.jp/ems':
			var thisName = (translateName) ? translate('Japan Post') : 'Japan Post';
			if (dropDown) thisName += ' – EMS';
			break;
		case 'www.japanpost.jp/m10':
			var thisName = (translateName) ? translate('Japan Post') : 'Japan Post';
			if (dropDown) thisName += ' – '+translate('Morning 10 Overnight Mail');
			break;
		case 'www.japanpost.jp/reg':
			var thisName = (translateName) ? translate('Japan Post') : 'Japan Post';
			if (dropDown) thisName += ' – '+translate('Registered Mail');
			break;
		case 'www.japanpost.jp/yupack':
			var thisName = (translateName) ? translate('Japan Post'):'Japan Post';
			if (dropDown) thisName += ' – '+translate('Yu-Pack');
			break;
		case 'www.laposte.fr':
			var thisName = 'La Poste';
			if (dropDown) thisName += ' – '+translate('France');
			break;
		case 'www.ontrac.com':
			var thisName = 'OnTrac';
			break;
		case 'www.parcelforce.com':
			var thisName = 'Parcelforce';
			break;
		case 'www.post.at':
			var thisName = (translateName)?'Post':'Post.at';
			if (dropDown) thisName += ' – '+translate('Austria');
			break;
		case 'www.postdanmark.dk':
			var thisName = 'Post Danmark';
			break;
		case 'www.poste.it/posta1':
			var thisName = (translateName)?'Poste Italiane':'Poste.it';
			if (dropDown) thisName += ' – Postacelere1 Plus';
			break;
		case 'www.poste.it/pacco1':
			var thisName = (translateName)?'Poste Italiane':'Poste.it';
			if (dropDown) thisName += ' – Paccocelere1 Plus';
			break;
		case 'www.poste.it/maxi':
			var thisName = (translateName)?'Poste Italiane':'Poste.it';
			if (dropDown) thisName += ' – Paccocelere Maxi';
			break;
		case 'www.poste.it':
			var thisName = (translateName)?'Poste Italiane':'Poste.it';
			if (dropDown) thisName += ' – Paccocelere3';
			break;
		case 'www.poste.it/pacco':
			var thisName = (translateName)?'Poste Italiane':'Poste.it';
			if (dropDown) thisName += ' – Paccocelere Internationale';
			break;
		case 'www.poste.it/ems':
			var thisName = (translateName)?'Poste Italiane':'Poste.it';
			if (dropDown) thisName += ' – EMS';
			break;
		case 'www.posten.no':
			var thisName = (translateName)?'Posten':'Posten.no';
			if (dropDown) thisName += ' – '+translate('Norway');
			break;
		case 'www.posten.se':
			var thisName = (translateName)?'Posten':'Posten.se';
			if (dropDown) thisName += ' – '+translate('Sweden');
			break;
		case 'www.purolator.com':
			var thisName = 'Purolator';
			break;
		case 'www.royalmail.com':
			var thisName = 'Royal Mail';
			break;
		case 'www.sagawa-exp.co.jp':
			var thisName = (translateName) ? translate('Sagawa Express'):'Sagawa';
			break;
		case 'www.post.ch':
			var thisName = (translateName) ? translate('Swiss Post'):'Swiss Post';
			break;
		case 'www.tnt.com':
			var thisName = 'TNT';
			if (dropDown) thisName += ' – '+translate('by consignment number');
			break;
		case 'www.tnt.com/ref':
			var thisName = 'TNT';
			if (dropDown) thisName += ' – '+translate('by reference number');
			break;
		case 'www.tntpost.nl':
			var thisName = (translateName) ? 'TNT Post' : 'TNTPost.nl';
			if (dropDown) thisName += ' – '+translate('Netherlands');
			break;
		case 'www.ups.com':
			var thisName = 'UPS';
			break;
		case 'www.ups-mi.net':
			var thisName = 'UPS Mail Innovations';
			break;
		case 'www.usps.com':
			var thisName = 'US Postal Service';
			break;
		case 'www.kuronekoyamato.co.jp':
			var thisName = (translateName) ? translate('Yamato Transport'):'Yamato Transport';
			break;
		case 'www.amazon.com':
		case 'www.amazon.ca':
		case 'www.amazon.co.uk':
		case 'www.amazon.co.jp':
		case 'www.amazon.de':
		case 'www.amazon.at':
		case 'www.amazon.fr':
		case 'www.amazon.it':
			var thisName = 'A'+from.substring(5);
			break;
		case 'other':
			var thisName = (translateName) ? translate('Other'):'Other';
			break;
		default:
			var thisName = from;
			break;

	}
	return thisName;

}

function cleanDate (theInput) {

	var theOutput;
	var theResults = new Array();
	var endDate = false;

	if (theInput) {

		var thisYear = new Date().getFullYear();

		theInput = theInput.toString();
		// Get rid of the time if necessary
		theInput = theInput.replace(/([0-9]{2}:[0-9]{2}:[0-9]{2}|[0-9]{1,2}:[0-9]{2} ?(A\.?M\.?|P\.?M\.?|Uhr|Hours|h))/i,'');
		while (theInput.indexOf('&nbsp;') != -1) theInput = theInput.replace('&nbsp;',' ');
		theInput = trim(theInput);
		theOutput = theInput;

		// Add the year if it's missing, needed for Apple store shipping estimates, Google status updates
		if (theOutput.match(/^[a-z]* [0-9]{1,2}$/i)) theOutput = theOutput+' '+thisYear;

		// Fix international dates
		theOutput = theOutput.replace(/([0-9]{4})-([0-9]{2})-([0-9]{2})/i,'$2/$3/$1');

		if (this.fromName == 'Amazon.de' || this.fromName == 'Amazon.at') {
			theOutput = cleanGermanDate(theOutput);
		} else if (this.fromName == 'Amazon.fr') {
			theOutput = cleanFrenchDate(theOutput);
		} else if (this.fromName == 'Amazon.it') {
			theOutput = cleanItalianDate(theOutput);
		} else if (this.fromName == 'Apple') {
			theOutput = theOutput.replace(/^(?:by )?([a-z]+) ([0-9]{1,2})[a-z]{2}$/i,'$1 $2,'+thisYear);
			theOutput = theOutput.replace(/^([0-9]{1,2})\/([0-9]{1,2})$/i,'$1/$2/'+thisYear);
		} else if (this.fromClass == 'CityLink') {
			theOutput = flexibleInternationalDate(theOutput);
			theOutput = theOutput.replace(/([0-9]{1,2})[a-z]+ ([a-z]+)/i,'$2 $1, '+thisYear);
		} else if (this.from == 'nolp.dhl.de') {
			theOutput = theOutput.replace(/^([a-z]+\.,)/i,'');
			theOutput = flexibleInternationalDate(theOutput);
		} else if (this.fromClass == 'Parcelforce' || this.fromClass == 'GLS' || this.fromClass == 'HLG' || 
			this.from == 'www.dhl.co.uk' || this.fromName == 'TNTPost.nl' || this.from == 'www.laposte.fr') {
			theOutput = flexibleInternationalDate(theOutput);
		} else if (this.fromClass == 'RoyalMail' || this.from == 'www.posten.no') {
			// Could be DD/MM/YY (RoyalMail), DD.MM.YYYY (Posten), or YYYY-MM-DD. The latter was fixed above.
			if (theInput == theOutput) theOutput = flexibleInternationalDate(theOutput);
		} else if (this.fromClass == 'Posten-se') {
			theResult = theOutput.match(/([0-9]{1,2}) ([a-z]*)/i);
			if (theResult) theOutput = getSwedishMonth(theResult[2])+'/'+theResult[1]+'/'+thisYear;
		} else if (this.fromClass == 'JapanPost' && translate('Japan Post') == '日本郵便') {
			theOutput = theOutput.replace(/([0-9]{1,2})月([0-9]{1,2})日/i,'$1/$2')+'/'+thisYear;
		} else if (this.fromClass == 'Sagawa') {
			theOutput = theOutput.replace(/([0-9]+)年([0-9]+)月([0-9]+)日/i,'$2/$3/$1');
		} else if (this.from == 'www.post.at') {
			// Only reorder if periods are used
			theOutput = theOutput.replace(/([0-9]{2})\.([0-9]{2})\.([0-9]{2,4})/i,'$2/$1/$3');
		} else if (this.fromClass == 'PostDanmark') {
			theOutput = cleanDanishDate(theOutput);
		} else if (this.fromClass == 'Poste-it') {
			theOutput = theOutput.replace(/([0-9]{2})\-([0-9]{2})\-([0-9]{4})/i,'$2/$1/$3');
		} else if (this.fromClass == 'SwissPost') {
			theOutput = theOutput.replace(/([0-9]{2})\.([0-9]{2})\.([0-9]{4})/i,'$2/$1/$3');
		} else if (this.fromClass == 'Yamato') {
			theOutput += '/'+thisYear;
		}

		if (theOutput) {
			endDate = new Date(theOutput);
			if (new String(endDate.getDate()) == 'NaN') endDate = false;
		}

	}
	theResults[0] = theOutput;
	theResults[1] = endDate;
	return theResults;

}

function reorderInternationalDate (theInput) {
	return (theInput) ? theInput.replace(/([0-9]{2})\/([0-9]{2})\/([0-9]{4})/i,'$2/$1/$3') : '';
}

function flexibleInternationalDate (theInput) {
	// Might be safe to replace reorderInternationalDate with this?
	return (theInput) ? theInput.replace(/([0-9]{2})(?:\/|-|\.)([0-9]{2})(?:\/|-|\.)([0-9]{2,4})/i,'$2/$1/$3') : '';
}

function cleanLocation (theString) {
	if (theString) {
		theString = trim(theString);
		theString = theString.replace(/ (Hub|Depot|Distribution|Distributionsbasis|Paketzentrum|Centre Colis|Base de distribution)$/i,'');
		switch (this.from) {
			case 'www.dhl.com':
				theString = theString.replace(/ (HUB|GATEWAY),/i,'');
				break;
			case 'www.dhl.co.uk':
				theString = theString.replace(/ (SERVICE CENTRE|HOME DELIVERY)$/i,'');
				break;
			case 'nolp.dhl.de':
				theString = theString.replace(/^HUB /i,'');
				break;
			case 'www.fedex.com':
				theString = theString.replace(/^FEDEX SMARTPOST /i,'');
				break;
			case 'www.parcelforce.com':
				theString = theString.replace(/^Delivery Agent - /i,'');
				break;
			case 'www.post.ch':
				theString = theString.replace(/ Zustellung$/i,'');
				theString = theString.replace(/^[0-9]+ /,'');
				break;
			case 'www.posten.no':
				theString = theString.replace(/^[0-9]+ /,'');
				break;
			case 'www.posten.se':
				theString = theString.replace(/^(Posten ?Företag|Posten)\b ?/,'');
				break;
			case 'www.usps.com':
				theString = theString.replace(/ \(USPS\)$/i,'');
				break;
		}
	}
	return theString;
}

function cleanHTML (theString,theFrom) {
	if (theString) {
		switch (theFrom) {
			case 'em.canadapost.ca':
				// Remove the viewport tag that prevents zooming
				theString = theString.replace(/<meta[^>]*name="viewport"[^>]*>/i,'');
				break;
		}
	}
	return theString;
}

function guessFrom (no,correctNo) {

	// Could get better results by supplying a list of companies, ordered by most used.
	// Then if we're not sure, we can guess the first one in the list.
	// Alternatively, we could just use the favorites list.

	var thisNo = false;
	var thisFrom = false;
	no = no.replace(/ /g,'');

	if (no.match(/^1Z[0-9A-Z]{16}$/i)) {
		thisFrom = new Array('www.ups.com');
	} else if (matches = no.match(/^([A-Z]{2})[0-9]{9}([A-Z]{2})$/i)) {
		var thisCountry = matches[2].toUpperCase();
		switch (thisCountry) {
			case 'AT': thisFrom = new Array('www.post.at'); break;
			case 'CA': thisFrom = new Array('em.canadapost.ca'); break;
			case 'CH': thisFrom = new Array('www.post.ch'); break;
			case 'DK': thisFrom = new Array('www.postdanmark.dk'); break;
			case 'FR': thisFrom = new Array('www.laposte.fr'); break;
			case 'GB': thisFrom = new Array('www.royalmail.com','www.parcelforce.com'); break;
			case 'HK': thisFrom = new Array('www.hongkongpost.com'); break;
			case 'IT': thisFrom = new Array('www.poste.it','www.poste.it/maxi'); break; // Probably maxi if it starts with LC|LM|LP|LX
			case 'JP': thisFrom = new Array('www.japanpost.jp/ems'); break;
			case 'NL': thisFrom = new Array('www.tntpost.nl'); break;
			case 'NO': thisFrom = new Array('www.posten.no'); break;
			case 'SE': thisFrom = new Array('www.posten.se'); break;
			case 'US': thisFrom = new Array('www.usps.com'); break;
		}
	} else if (no.match(/^96(11|12|13)[0-9]{18}$/)) { // 22 digits, last digit is a check
		thisFrom = new Array('www.fedex.com');
	} else if (no.match(/^(420[0-9]{5})?9[0-9]{21}$/)) {
		// 22-30 digits, usually 9x0x
		// (420xxxxx)?9102xxxxxxxxxxxxxxxxxx is usually www.dhlglobalmail.com or www.ups-mi.net?
		thisFrom = new Array('www.usps.com','www.dhlglobalmail.com','www.ups-mi.net');
	} else if (no.match(/^0034043[0-9]{13}$/)) { // 20 digits
		thisFrom = new Array('nolp.dhl.de');
	} else if (no.match(/^J?JD[0-9]{2}\.?[0-9]{2}\.?[0-9]{3}\.?[0-9]{3}\.?[0-9]{3}\.?([0-9]{3,10})?$/i)) {
		thisFrom = new Array('nolp.dhl.de','www.dhl.co.uk','www.dhl.com');
	} else if (no.match(/^0[1-3][0-9]{18}$/)) { // 20 digits
		thisFrom = new Array('www.usps.com');
	} else if (no.match(/^70[0-9]{18}$/)) { // 20 digits, Certified Mail
		thisFrom = new Array('www.usps.com');
	} else if (no.match(/^[0-9]{15}$/)) { // 15 digits
		thisFrom = new Array('www.fedex.com','checkout.google.com','www.hlg.de','www.dpd.com');
	} else if (no.match(/^[0-9]{12}$/)) { // 12 digits, including UPS InfoNotice
		thisFrom = new Array('nolp.dhl.de','www.kuronekoyamato.co.jp','www.sagawa-exp.co.jp','www.hlg.de',
			'www.japanpost.jp/yupack','www.japanpost.jp/reg','www.japanpost.jp/m10','www.gls-germany.com');
		if (checkFedEx12(no)) {
			thisFrom.unshift('www.fedex.com');
		} else thisFrom.push('www.ups.com');
	} else if (no.match(/^DT[0-9]{12}$/)) { // DT followed by 12 digits, FedEx delivery notice number
		thisFrom = new Array('www.fedex.com');
	} else if (no.match(/^(00)?37[0-9]{16}$/)) { // 18 or 20 digits
		thisFrom = new Array('www.posten.no','www.posten.se','www.postdanmark.dk');
		if (no.match(/^[0-9]{18}$/)) thisFrom.push('www.dhl.com'); // 18 digits, odds are low
	} else if (no.match(/^(98|99)\.?[0-9]{2}\.?[0-9]{6}\.?[0-9]{8}$/)) { // 18 digits possibly with periods
		thisFrom = new Array('www.post.ch');
		if (no.match(/^[0-9]{18}$/)) thisFrom.push('www.dhl.com'); // 18 digits, odds are low
	} else if (no.match(/^[0-9]{18}$/)) { // 18 digits
		thisFrom = new Array('www.dhl.com');
	} else if (no.match(/^([0-9]{10}|[0-9]{18})$/)) { // 10 digits
		// www.tnt.com/ref always starts with 8? apple always starts with 71?
		thisFrom = new Array('www.dhl.com','www.aramex.com','www.tnt.com/ref','www.apple.com','www.apple.com/zip',
			'www.apple.com/japan','www.apple.com/japanzip','www.apple.com/hk');
	} else if (no.match(/^P[0-9]{12}$/i)) { // P plus 12 digits
		thisFrom = new Array('nolp.dhl.de');
	} else if (no.match(/^[0-9]{3}-[0-9]{7}-[0-9]{7}$/)) {
		thisFrom = new Array('www.amazon.com','www.amazon.co.jp','www.amazon.de','www.amazon.co.uk','www.amazon.fr',
			'www.amazon.ca','www.amazon.it','www.amazon.at');
	} else if (no.match(/^WR?[0-9]{8,9}$/i)) {
		thisFrom = new Array('www.apple.com','www.apple.com/zip','www.apple.com/japan','www.apple.com/japanzip',
			'www.apple.com/hk');
	} else if (no.match(/^7[0-9]{16}$/)) { // 17 digits
		thisFrom = new Array('www.posten.no');
	} else if (no.match(/^[0-9]{4}-[0-9]{4}-[0-9]{4}$/)) { // 12 digits with dashes
		thisFrom = new Array('www.kuronekoyamato.co.jp','www.sagawa-exp.co.jp','www.japanpost.jp/yupack',
			'www.japanpost.jp/reg','www.japanpost.jp/m10');
	} else if (no.match(/^[0-9]{3}-[0-9]{2}-[0-9]{5}-[0-9]{1}$/)) { // 11 digits with dashes
		thisFrom = new Array('www.japanpost.jp/yupack','www.japanpost.jp/reg');
	} else if (no.match(/^[0-9]{11}$/)) { // 11 digits
		thisFrom = new Array('www.gls-germany.com','www.japanpost.jp/yupack','www.japanpost.jp/reg');
	} else if (no.match(/^[0-9]{14}[A-Z]$/i)) { // 14 digits plus letter
		thisFrom = new Array('www.dpd.com');
	} else if (no.match(/^[0-9]{14}$/)) { // 14 digits
		thisFrom = new Array('www.dpd.com','www.hlg.de','www.posten.se');
	} else if (no.match(/^000[0-9]{4}0530800815[0-9]{4}101[0-9]{3}[A-Z0-9]$/i)) {
		thisFrom = new Array('www.dpd.com');
	} else if (no.match(/^[0-9]{16}$/)) { // 16 digits
		thisFrom = new Array('em.canadapost.ca','www.hlg.de');
	} else if (no.match(/^[0-9]{9}$/)) { // 9 digits, UPS freight PRO number
		thisFrom = new Array('www.tnt.com','www.ups.com');
	} else if (no.match(/^[0-9]{2}.[0-9]{3}.[0-9].[0-9]{2}.[0-9]{5}.[0-9]$/)) { // 14 digits with periods
		thisFrom = new Array('www.hlg.de');
	} else if (no.match(/^(C1099|C1100|D1001)[0-9]{10}$/i)) {
		thisFrom = new Array('www.ontrac.com');
	} else if (no.match(/^3S[A-Z]{4}[0-9]{6,9}$/i)) {
		thisFrom = new Array('www.tntpost.nl');
	} else if (no.match(/^[0-9]{5}\.[0-9]{2}\.([0-9]{4}|[0-9]{6})$/)) { // 11 or 13 digits with periods
		thisFrom = new Array('www.gls-germany.com');
	} else if (no.match(/^([A-Z]{3}[0-9]{5})$/i)) { // 8 characters, 3 letters and 5 digits
		thisFrom = new Array('www.city-link.co.uk','www.gls-germany.com');
	} else if (no.match(/^(1[A-Z][0-9A-Z]{4}|[A-Z][0-9A-Z]{7})$/i)) {
		thisFrom = new Array('www.gls-germany.com');
	} else if (no.match(/^(PB[A-Z]{2}[0-9]{7}001|TW[A-Z]{2}[0-9]{7}GB|[A-Z]{2}[0-9]{7})$/i)) {
		thisFrom = new Array('www.parcelforce.com');
	} else if (no.match(/^[A-Z]{3}[0-1]00[0-9]{6}$/i)) {
		thisFrom = new Array('www.purolator.com');
	} else if (no.match(/^[A-Z][A-Z0-9]{2}[0-9]{5}$/i)) {
		thisFrom = new Array('www.city-link.co.uk');
	} else if (no.match(/^8[A-Z][0-9]{11}$/i)) { // 13 characters, second is a letter
		thisFrom = new Array('www.laposte.fr');
	} else if (no.match(/^[0-9]{11}DK$/i)) {
		thisFrom = new Array('www.postdanmark.dk');
	} else if (no.match(/^101[0-9]{19}$/i)) { // 22 digits
		thisFrom = new Array('www.post.at');
	} else if (no.match(/^AD[0-9]{9}[A-Z]{0,4}$/i)) {
		thisFrom = new Array('www.adobe.com');
	} else if (no.match(/^[0-9]{32}$/) && checkFedEx12(no.substring(16,28))) { // 32 digits, 12 digits inside a barcode
		thisFrom = new Array('www.fedex.com');
		thisNo = no.substring(16,28);
	}

	if (correctNo) thisFrom.unshift(thisNo);
	return thisFrom;

}

function checkFedEx12 (no) {
	// Expects a string
	var checkDigit = ((no[0]*3)+(no[1]*1)+
		(no[2]*7)+(no[3]*3)+(no[4]*1)+
		(no[5]*7)+(no[6]*3)+(no[7]*1)+
		(no[8]*7)+(no[9]*3)+(no[10]*1)) % 11;
	if (checkDigit == 10) checkDigit = 0;
	return (checkDigit == no[11]) ? true : false;
}