var appId = 'com.mikepiontek.widget.deliverystatus';
var thisVersion;
var readableVersion;
var syncVersion = 4.3;
var defsVersion = 47;
var iPhone = false;
var localeCode = 'US';
var timeZone = new Date().getTimezoneOffset();

var historyDays = 30; // number of days to keep old items in the history
var dismissDays = 30; // number of days to dismiss version checking
var lastVersion = 0; // the last version installed
var currentVersion; // the most recent version available
var downloadUrl = 'http://junecloud.com/software/mac/delivery-status.html';
var disableTooltips = false;

var deliveries = new Array();
var updateQueue;
var updatingCount = 0;
var doneCount = 0;
var hadSuccess = false;
var updateStamp = 0;

var currentSide = 'front';
var currentView = 'deliveries';
var nextSide = '';
var nextView = '';

var editingDelivery;
var lastFrom;
var openQueue = new Array();
var closeQueue = new Array();
var extraEdited = false;

var clickSpeed = 500;
var lastClick;
var clickTimer;

var growlEnabled = false;
var pushEnabled = false;
var updateTimer = null;
var dashboardActive = true;
var scrollTimer;

var largePrint = false;

// create an object to handle sync and version check requests

var sync = new Object();
sync.sync = true;
sync.req = new Array();
sync.reqCount = 0;
sync.reqComplete = 0;
sync.loadPage = loadPage;
sync.client = '';
sync.password = '';
sync.updated = 0;
sync.force = true;
sync.success;
sync.first = 0;
sync.updateAfter = true;
var syncQueue = new Array();

var defsPath = 'Scripts/Definitions.js';
var defsUpdate = 0;
var defsLocal = defsVersion;

var services = new Array(
	'www.adobe.com',
	'www.amazon.com',
	'www.amazon.ca',
	'www.amazon.co.uk',
	'www.amazon.co.jp',
	'www.amazon.de',
	'www.amazon.at',
	'www.amazon.fr',
	'www.amazon.it',
	'www.apple.com',
	'www.apple.com/zip',
	'www.apple.com/japan',
	'www.apple.com/japanzip',
	'www.apple.com/hk',
	'www.aramex.com',
	'em.canadapost.ca',
	'www.city-link.co.uk',
	'www.dhl.com',
	'www.dhlglobalmail.com',
	'nolp.dhl.de',
	'www.dhl.co.uk',
	'www.dpd.com',
	'www.fedex.com',
	'www.gls-germany.com',
	'checkout.google.com',
	'www.hlg.de',
	'www.hongkongpost.com',
	'www.japanpost.jp/ems',
	'www.japanpost.jp/m10',
	'www.japanpost.jp/reg',
	'www.japanpost.jp/yupack',
	'www.laposte.fr',
	'www.ontrac.com',
	'www.parcelforce.com',
	'www.post.at',
	'www.postdanmark.dk',
	'www.poste.it/posta1',
	'www.poste.it/pacco1',
	'www.poste.it/maxi',
	'www.poste.it',
	'www.poste.it/pacco',
	'www.poste.it/ems',
	'www.posten.no',
	'www.posten.se',
	'www.purolator.com',
	'www.royalmail.com',
	'www.sagawa-exp.co.jp',
	'www.post.ch',
	'www.tnt.com',
	'www.tnt.com/ref',
	'www.tntpost.nl',
	'www.ups.com',
	'www.ups-mi.net',
	'www.usps.com',
	'www.kuronekoyamato.co.jp',
	'other');
var favorites = new Array();
var showAll = true;
var useCount = new Array();

function $ (id) {
	return document.getElementById(id);
}

function setup () {

	if (typeof DeliveryStatus == 'undefined') {
		document.body.className = 'unsupported';
		$('unsupported').innerHTML = translate('Delivery Status requires Mac OS X 10.5 or later.');
		return;
	}

	if (window.widget) {

		// load settings

		if (DeliveryStatus) localeCode = DeliveryStatus.getLocaleCode();

		lastVersion = (widget.preferenceForKey('lastversion')) ? 
			parseFloat(widget.preferenceForKey('lastversion')) : 0;

		sync.client = (widget.preferenceForKey('syncclient')) ? 
			widget.preferenceForKey('syncclient') : '';
		sync.email = (widget.preferenceForKey('syncemail')) ? 
			widget.preferenceForKey('syncemail') : '';		
		if (sync.email) sync.password = getPassword('junecloud.com',sync.email);
		sync.updated = (widget.preferenceForKey('syncupdated')) ? 
			parseInt(widget.preferenceForKey('syncupdated')) : 0;
		sync.offset = (widget.preferenceForKey('syncoffset')) ? 
			parseFloat(widget.preferenceForKey('syncoffset')) : 0;

		disableTooltips = (widget.preferenceForKey('disabletooltips') == '1') ? 
			true : false;

		if (widget.preferenceForKey('favorites')) {
			favorites = widget.preferenceForKey('favorites').split(';');
		}
		showAll = (widget.preferenceForKey('showall') != null) ? 
			widget.preferenceForKey('showall') : true;

		if (widget.preferenceForKey('usecount')) {
			var useTemp = widget.preferenceForKey('usecount').split(';');
			for (var i in useTemp) {
				if (useTemp[i]) {
					var thisService = useTemp[i].split(':');
					useCount[thisService[0]] = parseInt(thisService[1]);
				}
			}
			sortUseCount();
		}

		// reset syncing when upgrading from a pre-5.0 version

		if (lastVersion < 5.0) {
			sync.client = '';
			sync.updated = 0;
		}

		checkNotifications();

		largePrint = (widget.preferenceForKey('size') && widget.preferenceForKey('size') != 'small') ? true : false;
		$('size').checked = largePrint;

		// make sure the service definitions are up to date

		defsUpdate = (widget.preferenceForKey('defsupdate')) ? 
			parseFloat(widget.preferenceForKey('defsupdate')) : 0;
		if (widget.preferenceForKey('defspath')) {
			var tempPath = widget.preferenceForKey('defspath');
			if (DeliveryStatus && DeliveryStatus.fileExists(tempPath)) {
				if (widget.preferenceForKey('defs')) defsVersion = parseInt(widget.preferenceForKey('defs'));
				if (defsVersion <= defsLocal) {
					resetDefinitions();
				} else defsPath = tempPath;
			}	
		}
		loadDefinitions(defsPath,true);

	}

	// set up the resize handles

	$('resizer-front').addEventListener('mousedown',startResize,true);
	$('resizer-back').addEventListener('mousedown',startResize,true);

	// adjust AppleScrollArea to call didScroll(), since using onscroll doesn't work reliably

	AppleScrollArea.prototype.mousewheelScroll = function(event) {
		didScroll();
		var deltaScroll = event.wheelDelta / 120 * this.singlepressScrollPixels;
		this.verticalScrollTo(this.content.scrollTop - deltaScroll);
		event.stopPropagation();
		event.preventDefault();
	}

	// modify AppleScrollbar so it scrolls one delivery when the track is clicked

	AppleScrollbar.prototype._trackScrollOnePage = function(self) {
		var scrollPixels = this.scrollarea.singlepressScrollPixels * 14.8;
		if (self._track_mouse_temp < self._thumbStart)
			this.scrollarea.verticalScrollTo(this.scrollarea.content.scrollTop - scrollPixels);
		else if (self._track_mouse_temp > (self._thumbStart + self._thumbLength))
			this.scrollarea.verticalScrollTo(this.scrollarea.content.scrollTop + scrollPixels);
	}

	// set up the scroll bar

	var scrollBar = new AppleVerticalScrollbar($('scrollbar'));
	scrollBar.setSize(8);
	scrollBar.setTrackStart('Images/Scroll/spacer.png',6);
	scrollBar.setTrackMiddle('Images/Scroll/spacer.png');
	scrollBar.setTrackEnd('Images/Scroll/spacer.png',6);
	scrollBar.setThumbStart('Images/Scroll/thumb-top.png',6);
	scrollBar.setThumbMiddle('Images/Scroll/thumb-middle.png');
	scrollBar.setThumbEnd('Images/Scroll/thumb-bottom.png',6);

	scrollArea = new AppleScrollArea($('scroll'),scrollBar);
	scrollBar.setAutohide(true);
	scrollArea.singlepressScrollPixels = 5;
	scrollArea.refresh();
	scrollArea.focus();

	// set up the add and info buttons

	var addButton = newObject('a','add','add');
	addButton.title = translate('Add');
	addButton.addEventListener('click',addDelivery,true);
	var infoButton = newObject('a','info','info');
	infoButton.addEventListener('click',function(){ showInfo('general') },true);
	infoButton.title = translate('Settings');
	var theseButtons = new Array(addButton,infoButton);
	new Buttons('front','info-buttons',theseButtons,false);

	// set up the tabs

	$('general-title').innerText = translate('General');
	$('sync-title').innerText = translate('Sync');
	$('donate-title').innerText = translate('Donate');
	$('signin-title').innerText = translate('Sign In');
	$('register-title').innerText = translate('Register');

	// set up the edit view

	$('editlabel').innerText = translate('Enter your tracking information');
	$('fromlabel').innerText = translate('Delivery From:');
	$('fromField').title = translate('Select the company your delivery is from.');
	$('fav').title = translate('Click here to mark this service as a favorite.');
	$('passwordlabel').innerText = translate('Password:');
	$('passwordField').title = translate('Enter the password you use to log in to your account.');
	$('namelabel').innerText = translate('Item Name:');
	$('name').placeholder = translate('Optional');
	$('nameField').title = translate('Enter a name to identify this shipment. It will display on the front of the widget. This is optional and is not used to find your shipment.');
	$('historylabel').innerText = translate('Or choose an item from your history');
	$('history').title = translate('History');
	$('helplink').title = translate('Help');

	// set up the date select menus

	$('dateField').className = localeCode;

	var yearSelect = newObject('select','year','year');
	var thisYear = (new Date()).getFullYear();
	for (var i = 0; i <= 5; i++) {
		var thisText = (i == 0) ? '' : thisYear+i-1;
		var thisNo = thisText;
		if (thisText && localeCode == 'JP') thisText += '年';
		yearSelect.options[i] = new Option(thisText,thisNo);
	}
	var monthSelect = newObject('select','month','month');
	monthSelect.options[0] = new Option('','');
	for (var i = 0; i < 12; i++) {
		var thisText = i;
		if (DeliveryStatus) {
			var dateMonth = i+1;
			if (dateMonth < 10) dateMonth = '0'+dateMonth;
			var dateString = thisYear+'-'+dateMonth+'-01';
			thisText = DeliveryStatus.formatDate(dateString,translate('MMMM'));
		}
		monthSelect.options[i+1] = new Option(thisText,i);
	}
	var daySelect = newObject('select','day','day');
	for (var i = 0; i <= 31; i++) {
		var thisText = (i == 0) ? '' : i;
		var thisNo = thisText;
		if (thisText && localeCode == 'JP') thisText += '日'; 
		daySelect.options[i] = new Option(thisText,thisNo);
	}

	monthSelect = newSelectWrapper(monthSelect);
	daySelect = newSelectWrapper(daySelect);
	yearSelect = newSelectWrapper(yearSelect);

	if (localeCode == 'US') {
		$('dateselects').appendChild(monthSelect);
		$('dateselects').appendChild(daySelect);
		$('dateselects').appendChild(yearSelect);
	} else if (localeCode == 'JP') {
		$('dateselects').appendChild(yearSelect);
		$('dateselects').appendChild(monthSelect);
		$('dateselects').appendChild(daySelect);
	} else {
		$('dateselects').appendChild(daySelect);
		$('dateselects').appendChild(monthSelect);
		$('dateselects').appendChild(yearSelect);
	}

	// set up the info view

	$('growllabel').innerHTML = translate('Display notifications with <a href="http://growl.info/" onclick="return openSite(this.href)">Growl</a>');
	$('pushlabel').innerHTML = translate('Send notifications to <a href="http://junecloud.com/software/iphone/delivery-status-touch.html" onclick="return openSite(this.href)">Delivery Status touch</a> (requires syncing)');
	$('sizelabel').innerHTML = translate('Use larger text');

	$('junecloud').title = translate('Copyright © 2006-2011 Junecloud LLC. Delivery Status is not affiliated with or endorsed by any of the supported shipping services.');

	$('syncemaillabel').innerText = translate('Email Address:');
	$('syncpasswordlabel').innerText = translate('Password:');
	$('syncconfirmlabel').innerText = translate('Confirm Password:');
	$('syncnamelabel').innerText = translate('Your Name:');
	$('syncname').placeholder = translate('Optional');
	$('synctermslabel').innerHTML = translate('I agree to the <a href="http://junecloud.com/sync/legal/terms.html" onclick="return openSite(this.href)">Terms of Service</a>');
	$('sync-info').innerText = translate('Sign in to your Junecloud account to sync with any Mac, iPhone, iPod touch, iPad, or web browser. Data will be synced securely through junecloud.com.');
	$('forgot').innerHTML = '<a href="https://junecloud.com/sync/?cmd=reset" onclick="return openSite(this.href)">'+translate('Forgot your password?')+'</a>';

	// create buttons

	var doneButton = new AppleGlassButton($('done-button'),translate('Done'),function(){saveSettings(true)});
	var cancelButton = new AppleGlassButton($('cancel-button'),translate('Cancel'),finishEditing);
	var signInButton = new AppleGlassButton($('signin-button'),translate('Sign In'),saveSync);
	var registerButton = new AppleGlassButton($('register-button'),translate('Register'),saveSync);
	var logOutButton = new AppleGlassButton($('logout-button'),translate('Log Out'),logOut);
	var donateButton = new AppleGlassButton($('donate-button'),translate('Donate'),openDonate);

	// display the front view

	$('loading').style.display = 'none';
	$('front').style.display = 'block';

	getCurrentVersion();

	if (window.widget) {
		widget.onhide = function () { dashboardActive = false; }
		widget.onshow = function () {
			if (!dashboardActive) { // prevent calling this on initial load
				dashboardActive = true;
				showScrollBar();
				var currentZone = new Date().getTimezoneOffset();
				if (timeZone != currentZone) {			
					timeZone = currentZone;
					updateDeliveries(true,false);
				} else {
					for (var i in deliveries) if (!deliveries[i].reqCount) displayItem(deliveries[i].id,deliveries[i].displayed,false);
					updateDeliveries((sync.first > 0),false);
				}
			}
		};
		widget.setPreferenceForKey(thisVersion,'lastversion');
	}

}

function showScrollBar () {
	clearTimeout(scrollTimer);
	$('scrollbar').className = 'visible';
	scrollTimer = setTimeout(function(){ $('scrollbar').className = ''; },300);
}

function didScroll () {
	showScrollBar();
}

function keyPress (event,id) {
	switch (event.keyCode) {
		case 13: // return
		case 3:  // enter
			switch (id) {
				case 'save':
					saveSettings(true);
					break;
				case 'sync':
					saveSync();
					break;
			}
	}
}

function loadDeliveries () {

	// load the deliveries

	if (widget.preferenceForKey('deliveries')) {
		var thisArray = widget.preferenceForKey('deliveries').split(';');
		for (var i in thisArray) {
			if (thisArray[i]) {
				deliveries[i] = loadDelivery(thisArray[i],i);
				if (deliveries[i].unfrozen) {
					displayItem(deliveries[i].id,deliveries[i].displayed,false);
					var thisUpdateStamp = (deliveries[i].lastUpdate) ? deliveries[i].lastUpdate.getTime() : 0;
					if (thisUpdateStamp > updateStamp) updateStamp = thisUpdateStamp;
				}
				if (updateStamp) hadSuccess = true;
			}
		}
	}
	
	$('deliveries').style.height = (deliveries.length * 74) + 'px';
	showNoDeliveries();

	thisSize = savedSize();
	setMinMax(currentView);
	setSize(thisSize.width,thisSize.height,true,false);
	setMaximized(thisSize);
	setTimeout(showScrollBar,1000);

	updateQueue = new Queue();
	if (thisVersion > lastVersion) {
		updateDeliveries(true,false);
	} else startSync();

}

function loadDelivery (id,index) {

	/* the HTML generated below looks like this:

	<div class="delivery">
		<div class="highlight"></div>
		<div class="shadow"></div>
		<div class="icon">
			<img class="spinner"/>
			<div class="daycount"></div>
			<div class="daytext"></div>
		</div>
		<div class="text">
			<div class="item"></div>
			<div class="ship"></div>
			<div class="deliver"></div>
		</div>
		<div class="button" onclick="clickDelivery('id')"></div>
	</div> */

	var deliveryObj = newObject('div',id,'delivery');
	deliveryObj.appendChild(newObject('div',false,'highlight'));
	deliveryObj.appendChild(newObject('div',false,'shadow'));

	var iconObj = newObject('div',id+'-icon','icon');
	iconObj.appendChild(newObject('img',id+'-spinner','spinner'));
	iconObj.appendChild(newObject('div',id+'-daycount','daycount'));
	iconObj.appendChild(newObject('div',id+'-daytext','daytext'));
	deliveryObj.appendChild(iconObj);

	var textObj = newObject('div',id+'-text','text');
	textObj.appendChild(newObject('div',id+'-item','item'));
	textObj.appendChild(newObject('div',id+'-ship','ship'));
	textObj.appendChild(newObject('div',id+'-deliver','deliver'));
	deliveryObj.appendChild(textObj);
	
	var buttonObj = newObject('div',id+'-button','button');
	buttonObj.addEventListener('click',function(){ clickDelivery(id) },true);
	deliveryObj.appendChild(buttonObj);

	var settings = new Array();
	settings['uuid'] = id;
	if (window.widget) {
		settings['from'] = widget.preferenceForKey(id+'-store');
		settings['name'] = widget.preferenceForKey(id+'-itemname');
		settings['no'] = widget.preferenceForKey(id+'-orderno');
		settings['extra'] = widget.preferenceForKey(id+'-email');
		settings['date'] = widget.preferenceForKey(id+'-date');
		settings['html'] = widget.preferenceForKey(id+'-html');
		settings['htmldate'] = widget.preferenceForKey(id+'-htmldate');
		settings['item'] = widget.preferenceForKey(id+'-item');
	}

	if (index < 0) {
		deliveryObj.style.opacity = 0;
		deliveryObj.style.height = 0;
		var newDelivery = $('deliveries').insertBefore(deliveryObj,$('deliveries').childNodes[0]);
		openQueue.push(newDelivery);
	} else if ($(id)) {
		$('deliveries').replaceChild(deliveryObj,$(id));
	} else $('deliveries').appendChild(deliveryObj);

	var delivery;
	if (deliveries[index]) {
		delivery = deliveries[index];
		delivery.resetRequests(true);
		delivery.setDelivery(settings);
	} else {
		delivery = new Delivery(settings);
		if (window.widget && widget.preferenceForKey(id+'-items')) {
			var jsonData = JSON.parse(widget.preferenceForKey(id+'-items'));
			var thisData = jsonData.shift();
			if (thisData.length == 4 && jsonData[0] && jsonData[0].length == 23) {
				delivery.url = thisData[0];
				delivery.count = thisData[1];
				if (thisData[2]) delivery.lastUpdate = new Date(thisData[2]);
				if (thisData[3]) delivery.nextUpdate = thisData[3];
				for (var x in jsonData) {
					var thisItem = new Array();
					thisItem['theItem'] = jsonData[x][0];
					thisItem['date'] = jsonData[x][1];
					thisItem['daysNumber'] = jsonData[x][2];
					thisItem['icon'] = jsonData[x][3];
					thisItem['trackingUrl'] = jsonData[x][4];
					thisItem['theStatus'] = jsonData[x][5];
					thisItem['statusDate'] = jsonData[x][6];
					thisItem['shipSaved'] = jsonData[x][7];
					thisItem['shipDate'] = jsonData[x][8];
					thisItem['shipDays'] = jsonData[x][9];
					thisItem['shipStamp'] = jsonData[x][10];
					thisItem['shipDateBold'] = jsonData[x][11];
					thisItem['shipDaysBold'] = jsonData[x][12];
					thisItem['deliverySaved'] = jsonData[x][13];
					thisItem['deliveryDate'] = jsonData[x][14];
					thisItem['deliveryDays'] = jsonData[x][15];
					thisItem['deliveryStamp'] = jsonData[x][16];
					thisItem['deliveryDateBold'] = jsonData[x][17];
					thisItem['deliveryDaysBold'] = jsonData[x][18];
					thisItem['theDetails'] = new Array();
					thisItem['theDetails']['date'] = jsonData[x][19];
					thisItem['theDetails']['location'] = jsonData[x][20];
					thisItem['theDetails']['status'] = jsonData[x][21];
					thisItem['clickable'] = jsonData[x][22];
					delivery.items[x] = thisItem;
				}
				delivery.unfrozen = true;
			}
		}
	}

	deliveryObj.className = 'delivery '+delivery.fromClass;
	delivery.addButtons();

	return delivery;

}

function saveItems () {
	if (typeof JSON.stringify == 'function' && window.widget) {
		var jsonData = new Array();
		var lastUpdateTime = (this.lastUpdate) ? this.lastUpdate.getTime() : null;
		var jsonItem = new Array(this.url,this.count,lastUpdateTime,this.nextUpdate);
		jsonData.push(jsonItem);
		for (var x in this.items) {
			var jsonItem = new Array(
				this.items[x]['theItem'],
				this.items[x]['date'],
				this.items[x]['daysNumber'],
				this.items[x]['icon'],
				this.items[x]['trackingUrl'],
				this.items[x]['theStatus'],
				this.items[x]['statusDate'],
				this.items[x]['shipSaved'],
				this.items[x]['shipDate'],
				this.items[x]['shipDays'],
				this.items[x]['shipStamp'],
				this.items[x]['shipDateBold'],
				this.items[x]['shipDaysBold'],
				this.items[x]['deliverySaved'],
				this.items[x]['deliveryDate'],
				this.items[x]['deliveryDays'],
				this.items[x]['deliveryStamp'],
				this.items[x]['deliveryDateBold'],
				this.items[x]['deliveryDaysBold'],
				this.items[x]['theDetails']['date'],
				this.items[x]['theDetails']['location'],
				this.items[x]['theDetails']['status'],
				this.items[x]['clickable']);
			jsonData.push(jsonItem);
		}
		widget.setPreferenceForKey(JSON.stringify(jsonData),this.id+'-items');
	}
}

function addButtons ( ) {
	var editButton = newObject('a',this.id+'-edit','edit');
	editButton.title = translate('Edit');
	editButton.parent = this;
	editButton.addEventListener('click',this.editParent,true);
	var closeButton = newObject('a',this.id+'-close','close');
	closeButton.title = translate('Delete');
	closeButton.parent = this;
	closeButton.addEventListener('click',this.closeParent,true);
	var theseButtons = new Array(editButton,closeButton);
	this.buttons = new Buttons(this.id,'edit-buttons',theseButtons,true);
}

function getIndex ( id ) {
	for (var i in deliveries) {
		if (deliveries[i].id == id) return i;
	}
	return -1;
}

function getUUID () {
	if (DeliveryStatus) {
		return DeliveryStatus.getUUID();
	} else return (new Date()).getTime();
}

function getPassword ( from, extra ) {
	var result;
	if (DeliveryStatus) result = DeliveryStatus.getPassword(from,extra);
	if (result == null) result = '';
	return result;
}

function newObject ( element, id, classname ) {
	var thisObj = document.createElement(element);
	if (id) thisObj.setAttribute('id',id);
	thisObj.className = classname;
	if (element == 'a') thisObj.href = '#';
	return thisObj;
}

function newSelectWrapper ( select ) {

	select.onkeyup = function(){ setSelect(select.id,false); }
	select.onchange = function(){ setSelect(select.id,false); }
	
	// Show focus?
	// select.onfocus = function(){ $(select.id+'-popup').style.border = '1px solid red'; }
	// select.onblur = function(){ $(select.id+'-popup').style.border = 'none'; }
	
	var wrapperObj = newObject('div',select.id+'-popup','popup');
	wrapperObj.appendChild(newObject('div',select.id+'-text','text'));
	wrapperObj.appendChild(select);

	return wrapperObj;

}

function setSelect ( id, value ) {
	if (value !== false) $(id).value = value;
	$(id+'-text').innerText = $(id).options[$(id).selectedIndex].innerText;
}

function updateDeliveries ( force, skipSync ) {

	if (!skipSync) {

		if (force) {
			sync.force = true;
			for (var i in deliveries) deliveries[i].nextUpdate = 0;
			sync.updateAfter = true;
		}
		startSync();

	} else {

		clearTimeout(updateTimer);
		var resetSuccess = false;
		var rightNow = getUnixTime();
		if (force) updateQueue.reset();

		for (var i in deliveries) {
			if (force) {
				updateQueue.add(deliveries[i]);
			} else {
				if (rightNow >= deliveries[i].nextUpdate && deliveries[i].reqComplete >= deliveries[i].reqCount) {
					if (!resetSuccess) {
						hadSuccess = false;
						resetSuccess = true;
					}
					updateQueue.add(deliveries[i]);
				}
			}
		}
		if (updateQueue.count()) {
			updateQueue.update();
		} else showTime(false);
		if (growlEnabled || pushEnabled) updateTimer = setTimeout('updateDeliveries(false,false)',30*60000);

	}

}

function setHistoryTitle ( id ) {
	var index = getIndex(id);
	if (deliveries[index]) {
		var thisItem = deliveries[index].items[0];
		if (thisItem && window.widget) {
			widget.setPreferenceForKey(thisItem['theItem'],id+'-historytitle');
		}
	}
}

function updateOther ( delivery ) {

	var thisItem = resetItem();
	if (delivery.name) {
		thisItem['theItem'] = htmlEntities(delivery.name);
	} else if (delivery.no) {
		thisItem['theItem'] = htmlEntities(delivery.no);
	}

	if (delivery.url) {
		thisItem['shipDate'] = translate('Click for more information');
		thisItem['shipDateBold'] = true;
	} else {
		thisItem['shipDate'] = translate('Ship date unknown');
		thisItem['shipDateBold'] = false;
	}

	delivery.html = cleanOtherHTML(delivery.html);
	if (delivery.html && delivery.html != delivery.oldhtml) {
		if (delivery.oldhtml) delivery.htmldate = (new Date()).getTime();
		saveHTML(delivery);
	}

	if (delivery.date) {
		var thisDate = widget.preferenceForKey(delivery.id+'-date');
		if (thisDate) delivery.date = stringToTimeStamp(thisDate);
		var daysApart = getDaysApart(delivery.date);
		thisItem['icon'] = (daysApart < 0) ? 'checkmark' : '';
		thisItem['date'] = delivery.date.getTime();
		thisItem['deliveryDate'] = thisItem['deliveryDays'] = translate('Delivered by %@');
		thisItem['deliveryDateBold'] = thisItem['deliveryDaysBold'] = false;
		thisItem['deliveryStamp'] = delivery.date.getTime();
	} else {
		thisItem['icon'] = 'transit';
		thisItem['date'] = '';
		thisItem['deliveryDate'] = translate('Delivery date unknown');
		thisItem['deliveryDateBold'] = false;
		thisItem['deliveryStamp'] = '';
	}
	delivery.items = new Array();
	delivery.items[0] = thisItem;
	delivery.count = 1;

}

function setIcon (id,icon) {
	$(id+'-icon').className = (icon) ? 'icon '+icon : 'icon days';
}

function convertDate ( theDate ) {
	return (theDate) ? theDate.getTime() : 0;
}

function timeStampToString ( theDate ) {
	var dateObject = new Date(theDate);
	var dateString = dateObject.getFullYear()+'-';
	var dateMonth = dateObject.getMonth()+1;
	if (dateMonth < 10) dateMonth = '0'+dateMonth;
	dateString += dateMonth+'-';
	var dateDay = dateObject.getDate();
	if (dateDay < 10) dateDay = '0'+dateDay;
	dateString += dateDay;
	return dateString; // yyyy-MM-dd
}

function displayDate ( theDate, useRelative, useCaps ) {
	var thisResult = '';
	var daysApart = getDaysApart(theDate);	
	if (useRelative && daysApart == 0) {
		thisResult = (useCaps) ? translate('Today') : translate('today');
	} else if (useRelative && daysApart == 1) {
		thisResult = (useCaps) ? translate('Tomorrow') : translate('tomorrow');
	} else if (useRelative && daysApart == -1) {
		thisResult = (useCaps) ? translate('Yesterday') : translate('yesterday');
	} else if (useRelative > 1 && daysApart > 1 && daysApart < 7) {	
		thisResult = DeliveryStatus.formatDate(timeStampToString(theDate),'EEEE');
	} else if (DeliveryStatus) {
		thisResult = DeliveryStatus.formatDate(timeStampToString(theDate),'MMMM d');
	}
	return thisResult;
}

function displayItem (id,x,update) {

	var index = getIndex(id);
	var delivery = deliveries[index];
	if (delivery) {

		if (parseInt(x) + 1 > delivery.count) x = 0;
		if (update) {
			deliveries[index].displayed = x;
			if (window.widget) widget.setPreferenceForKey(x,id+'-item');
		}

		delivery.stopLoad();

		if (delivery.items[x]) {

			var thisItem = delivery.items[x];
			var thisIcon = thisItem['icon'];
			var daysClass = '';

			if (delivery.loading || (!thisIcon && thisItem['date'] == undefined)) {
				thisIcon = 'loading';
			} else {
				var daycount = getDaysApart(thisItem['date']);
				if (daycount < 0 && !thisIcon) thisIcon = (delivery.from == 'other') ? 'checkmark' : 'error';	
				if (daycount > 999) {
					daycount = '999+';
					daysClass = 'many';
				} else if (daycount > 99) {
					daysClass = 'small';
				} else if (daycount < 20) {
					daysClass = 'compress';
				}
			}
			setIcon(id,thisIcon);
			$(delivery.id+'-daycount').className = 'daycount '+daysClass;
			$(delivery.id+'-daycount').innerText = daycount;
			$(delivery.id+'-daytext').innerText = (daycount == 1) ? translate('day') : translate('days');
	
			var itemObj = $(delivery.id+'-item');
			if (delivery.count > 1) {
				var nextItem = x + 1;
				if (nextItem > delivery.count - 1) nextItem = 0;
				var displayNo = x + 1;
				if (displayNo > 9) displayNo = 'Plus';
				itemObj.innerHTML = '<img src="Images/Dot-'+displayNo+'.png" class="no" onclick="displayItem(\''+
					id+'\','+nextItem+',true)"><a href="javascript:displayItem(\''+id+'\','+nextItem+',true)">'+thisItem['theItem']+'</a>';
				itemObj.className = 'item number';
			} else {
				itemObj.innerHTML = thisItem['theItem'];
				itemObj.className = 'item';
			}

			if (delivery.from == 'other' && delivery.htmldate && DeliveryStatus) {
				var thisDate = displayDate(delivery.htmldate,2,false);
				var thisTime = DeliveryStatus.formatTime(delivery.htmldate/1000);
				thisItem['shipDate'] = translateFormat('Site updated %@ at %@',thisDate,thisTime);
				thisItem['shipDateBold'] = true;
			}

			var thisTitle = delivery.fromTrans+'\n'+trim(removeHtmlEntities(thisItem['theItem']))+'\n';
			if (delivery.lastUpdate) thisTitle += updatedText(delivery.lastUpdate)+'\n';

			thisTitle += '\n'+formatLine(thisItem['shipDate'],thisItem['shipStamp'],1,false,true)+'\n';
			if (thisItem['shipDays'] && thisItem['shipDays'] != thisItem['shipDate']) {
				var thisDate = thisItem['statusDate'];
				thisTitle += formatLine(thisItem['shipDays'],thisDate,1,false,true)+'\n\n';
			}
			thisTitle += formatLine(thisItem['deliveryDate'],thisItem['deliveryStamp'],1,false,true);
			if (thisItem['deliveryDays'] && thisItem['deliveryDays'] != thisItem['deliveryDate']) {
				thisTitle += '\n'+formatLine(thisItem['deliveryDays'],thisItem['deliveryStamp'],1,false,true);
			}			
			setTitle(delivery.id,thisTitle);

			var shipDate = thisItem['shipDate'];
			var deliveryDate = thisItem['deliveryDate'];

			if (getDonated() + 1 < thisVersion && deliveryDate == translate('Delivered!')) {
				if (shipDate == translate('Shipped!')) shipDate = deliveryDate;
				deliveryDate = '<a href="javascript:showInfo(\'donate\')">'+
					translate('Please consider a donation')+'</a>';
				thisItem['clickable'] = true;
			}
			$(delivery.id+'-deliver').className = (thisItem['clickable']) ?
				'deliver clickable' : 'deliver';

			$(delivery.id+'-ship').innerHTML = formatLine(shipDate,thisItem['shipStamp'],2,thisItem['shipDateBold'],false);
			$(delivery.id+'-deliver').innerHTML = formatLine(deliveryDate,thisItem['deliveryStamp'],2,thisItem['deliveryDateBold'],false);

		}

	}

}

function formatLine ( text, date, relative, bold, clean ) {
	var thisDate = '';
	if (date) {
		thisDate = displayDate(date,relative,true);
		if (!bold) thisDate = '<b>'+thisDate+'</b>';
	}
	text = text.replace('%@',thisDate);
	if (bold) text = '<b>'+text+'</b>';
	if (clean) text = trim(removeHtmlEntities(stripHTML(text))).replace(/\s+/ig,' ');
	return text;
}

function setTitle ( id, thisTitle ) {
	if (!disableTooltips && thisTitle) {
		$(id+'-item').title = thisTitle;
		$(id+'-button').title = thisTitle;
	}
}

function showMessage (message) {
	$('message').innerHTML = message;
	if (this.id && !$(this.id+'-ship').innerText) {
		$(this.id+'-ship').innerHTML = '<div class="updating">'+message+'</div>';
	}
}

function showTime (setToNow) {
	if (doneCount >= updatingCount) {

		doneCount = 0;
		updatingCount = 0;

		var message = '';
		if (hadSuccess) {
			if (DeliveryStatus && (setToNow || updateStamp)) {
				if (setToNow) updateStamp = (new Date()).getTime();
				message = updatedText(updateStamp);
			}
		} else if (deliveries.length > 0) {
			message = translate('Couldn’t connect');
		}
		showMessage(message);

	}
}

function updatedText (timeStamp) {
	var thisDate = displayDate(timeStamp,2,false);
	var thisTime = DeliveryStatus.formatTime(timeStamp/1000);
	return translateFormat('Updated %@ at %@',thisDate,thisTime);
}

function openSite (theUrl) {
	if (window.widget) {
		widget.openURL(theUrl);
		return false;
	}
	return true;
}

function clickDelivery (id) {
	var i = getIndex(id);
	if (i >= 0) {
		clearTimeout(clickTimer);
		var rightNow = new Date();
		if (rightNow - lastClick < clickSpeed) {
			openDeliverySite(i,2);
		} else clickTimer = setTimeout(function(){ openDeliverySite(i,1) },clickSpeed);
		lastClick = rightNow;
	}
}

function openDeliverySite (i,clicks) {

	var x = (deliveries[i].displayed) ? deliveries[i].displayed : 0;
	var thisLocation = (clicks > 1 && deliveries[i].items[x]) ? 
		deliveries[i].cleanLocation(deliveries[i].items[x]['theDetails']['location']) : false;

	if (clicks > 1 && thisLocation) {
		// escaping the location causes problems with Japanese characters
		openSite('http://maps.google.com/maps?q='+thisLocation);
	} else if (deliveries[i].url) {
		openSite(deliveries[i].url);
	}

}


// open or close a delivery


function startAnimation ( thisObject, startHeight, stopHeight, startFade, stopFade, stopAction, id ) {

	var startingRect = new AppleRect(0,0,thisObject.offsetWidth,startHeight);
	var finishingRect = new AppleRect(0,0,thisObject.offsetWidth,stopHeight);	
	var rectAnimation = new AppleRectAnimation(startingRect,finishingRect,closeRectHandler);
	rectAnimation.object = thisObject;

	var fadeAnimation = new AppleAnimation(startFade,stopFade,fadeHandler);
	fadeAnimation.object = thisObject;

	var thisAnimator = new AppleAnimator(300,13);
	thisAnimator.addAnimation(rectAnimation);
	thisAnimator.addAnimation(fadeAnimation);
	thisAnimator.id = id;
	thisAnimator.object = thisObject;
	if (stopAction) thisAnimator.oncomplete = stopAction;
	thisAnimator.start();

	showScrollBar();

}

function animateQueues () {
	if (openQueue.length > 0 || closeQueue.length > 0) {
		setTimeout(refreshDeliveries,0);
		var thisWait = (openQueue.length > closeQueue.length) ? 100 : 0;
		setTimeout(function(){
				for (var i in openQueue) startAnimation(openQueue[i],0,74,0,1,false,false);
				openQueue = new Array();
				for (var i in closeQueue) startAnimation(closeQueue[i],closeQueue[i].offsetHeight,0,1,0,false,false);
				closeQueue = new Array();
			},thisWait);
	}
}

function closeParent () {
	var thisObject = $(this.parent.id);
	startAnimation(thisObject,thisObject.offsetHeight,0,1,0,deliveryClosed,this.parent.id);
}

function closeRectHandler (rectAnimation, currentRect, startingRect, finishingRect) {
	this.object.style.height = currentRect.bottom + 'px';
}

function fadeHandler (currentAnimator, current, start, finish) {
	this.object.style.opacity = current;
}

function deliveryClosed () {
	var index = getIndex(this.id);
	if (index >= 0) {
		deliveries.splice(index,1);
		saveDeliveries();
		$('deliveries').removeChild(this.object);
		refreshDeliveries();
		syncDelivery(this.id,'delete',getUnixTime()-sync.offset);
	}
}

function refreshDeliveries () {

	var oldDeliveries = $('deliveries').offsetHeight;
	$('deliveries').style.height = (deliveries.length * 74) + 'px';

	if (oldDeliveries != $('deliveries').offsetHeight) {
		setMinMax(currentView);
		
		if (size.height > max.height) {

			nextSide = 'front';
			nextView = 'deliveries';
			adjustSize();

		} else if (maximized && size.height < max.height) {

			nextSide = 'front';
			nextView = 'deliveries';

			var top = 0;
			var out = widget.system("/usr/bin/defaults read com.apple.dashboard layer-gadgets",null).outputString;
			var regex = new RegExp('id = '+widget.identifier+';(.*?)"pos-y" = ([0-9]+);','i');
			var result = stripWhiteSpace(out).match(regex);
			if (result && result[2]) top = parseInt(result[2]);

			if (top + max.height + 66 < screen.height) {
				adjustSize(true);
			} else setSize(size.width,size.height,true,false);

		} else setSize(size.width,size.height,true,false);

	}
	showNoDeliveries();

}

function showNoDeliveries () {
	if (deliveries.length == 0) {
		$('no-deliveries').innerText = translate('You do not have any deliveries');
		// $('front').title = translate('Click + to add a delivery, or click the “i” button to set up syncing.');
		$('no-deliveries').style.display = 'block';
	} else {
		$('no-deliveries').style.display = 'none';
		$('front').title = '';
	}
}


// display loading spinner


function startLoad () {

	setIcon(this.id,'loading');

	var self = this;
	this.loading = true;
	this.spinAngle = 0;
	$(self.id+'-spinner').style.display = 'none';

	switch(this.fromClass) {
		case 'DHL':
			$(self.id+'-spinner').src = 'Images/DHL/Spinner.png';
			break;
		case 'LaPoste':
			$(self.id+'-spinner').src = 'Images/LaPoste/Spinner.png';
			break;
		case 'UPS':
			$(self.id+'-spinner').src = 'Images/UPS/Spinner.png';
			break;
		case 'CanadaPost':
		case 'FedEx':
		case 'GLS':
		case 'HongkongPost':
		case 'JapanPost':
		case 'OnTrac':
			$(self.id+'-spinner').src = 'Images/Spinner-White.png';
			break;
		default:
			$(self.id+'-spinner').src = 'Images/Spinner.png';
			break;
	}

	self.spinTimer = setTimeout(function(){ continueLoad(self) },100);

}

function continueLoad ( self ) {
	$(self.id+'-spinner').style.display = 'block';
	$(self.id+'-spinner').style.webkitTransform = 'rotate('+self.spinAngle+'deg)';
	self.spinAngle += 30;
	self.spinTimer = setTimeout(function(){ continueLoad(self) },100);
}

function stopLoad () {
	clearTimeout(this.spinTimer);
	$(this.id+'-spinner').style.display = 'none';
	this.loading = false;
}


// display the info and settings


function showInfo (thisView) {

	$('syncemail').value = sync.email;
	$('syncpassword').value = sync.password;

	checkNotifications();
	setDonated(true);
	$('version').innerText = 'Delivery Status '+readableVersion+' ('+defsVersion+')';
	switchToView('back',thisView);

}


// add, edit, and save deliveries


function addDelivery () {

	var settings = new Array();
	settings['from'] = lastFrom = (widget.preferenceForKey('store')) ? 
		widget.preferenceForKey('store') : 'www.amazon.com';

	editingDelivery = new Delivery(settings);
	updateEditForm(editingDelivery.from);
	fillEditForm(editingDelivery,true);
	switchToView('back','edit');

}

function editDelivery ( delivery ) {

	var settings = new Array();
	settings['uuid'] = delivery.id;
	if (window.widget) {
		settings['from'] = delivery.from;
		settings['name'] = delivery.name;
		settings['no'] = delivery.no;
		settings['extra'] = delivery.extra;
		settings['date'] = (delivery.date) ? timeStampToString(delivery.date) : '';
		settings['html'] = delivery.html;
		settings['htmldate'] = delivery.htmldate;
		settings['item'] = delivery.item;
	}

	editingDelivery = new Delivery(settings);
	editingDelivery.fromEdited = true;
	updateEditForm(editingDelivery.from);
	fillEditForm(editingDelivery,false);
	switchToView('back','edit');

}

function editParent () {
	editDelivery(this.parent);
}

function editPassword (id) {
	var i = getIndex(id);
	if (i >= 0) editDelivery(deliveries[i]);
	$('password').focus();
}

function fillEditForm ( delivery, isNew ) {

	showServices(delivery.from,showAll);

	$('from').value = delivery.from;
	$('name').value = delivery.name;
	$('no').value = delivery.no;

	if (!isNew) {
		$('extra').value = delivery.extra;
		$('password').value = ($('extra').value) ? getPassword($('from').value,$('extra').value) : '';

		if (delivery.date) {
			setSelect('month',delivery.date.getMonth());
			setSelect('day',delivery.date.getDate());
			setSelect('year',delivery.date.getFullYear());
		} else {
			setSelect('month','');
			setSelect('day','');
			setSelect('year','');
		}
	}

	$('history').selectedIndex = 0;
	populateHistory();

}

function showServices ( thisFrom, all ) {

	while ($('from').hasChildNodes()) $('from').removeChild($('from').firstChild);
	if (favorites.length > 0) {
		$('from').appendChild(newObject('optgroup','from-favs'));
		$('from-favs').label = translate('Favorites');
	}
	for (var x in favorites) {
		$('from').appendChild(new Option(getFromName(favorites[x],true,true),favorites[x]));
	}
	if (all) {
		if ($('from').hasChildNodes()) {
			$('from').appendChild(document.createElement('hr'));
			$('from').appendChild(newObject('optgroup','from-all'));
			$('from-all').label = translate('All Services');
		}
		for (var x in services) {
			$('from').appendChild(new Option(getFromName(services[x],true,true),services[x]));
		}
		$('from').appendChild(document.createElement('hr'));
		$('from').appendChild(new Option(translate('Show favorites only'),'favs'));
	} else {
		if (favorites.indexOf(thisFrom) == -1) {
			$('from').appendChild(document.createElement('hr'));
			$('from').appendChild(new Option(getFromName(thisFrom,true,true),thisFrom));
		}
		$('from').appendChild(document.createElement('hr'));
		$('from').appendChild(new Option(translate('Show all'),'all'));
	}

}

function sortUseCount () {

	var useSorter = new Array();
	for (var key in useCount) {
		useSorter.push(key);
	}

	useSorter.sort(function(a,b){
		// If the values are equal, favorites should come first
		if (useCount[b] == useCount[a]) {
			aFavorite = (favorites.indexOf(a) == -1) ? 0 : 1;
			bFavorite = (favorites.indexOf(b) == -1) ? 0 : 1;
			return (bFavorite - aFavorite);
		}
		// Otherwise higher values should come first
		return (useCount[b] - useCount[a]);
	});
	
	var useSorted = new Array();
	for (var i in useSorter) {
		useSorted[useSorter[i]] = useCount[useSorter[i]];
	}
	useCount = useSorted;

}

function updateUseCount ( thisFrom ) {
	useCount[thisFrom] = (useCount[thisFrom]) ? useCount[thisFrom] + 1 : 1;
	if (window.widget) {
		sortUseCount();
		var useTemp = '';
		for (var key in useCount) useTemp += key+':'+useCount[key]+';';
		widget.setPreferenceForKey(useTemp,'usecount');
	}
}

function selectGuessFrom ( event, thisValue ) {

	// Don't continue if the "from" was previously set, or the return or enter key was pressed
	if (!editingDelivery.fromEdited && event.keyCode != 13 && event.keyCode != 3) {

		var guessArray = guessFrom(thisValue);
		if (guessArray) {

			var newFrom = false;
			// If there's only one guess, just set it
			if (guessArray.length == 1) {
				newFrom = guessArray[0];
			} else if (guessArray.indexOf(lastFrom) != -1) {
				newFrom = lastFrom;
			} else {

				// If any favorites are in the list, only consider those
				var favGuessArray = new Array();
				for (var i in guessArray) {
					if (favorites.indexOf(guessArray[i]) != -1) favGuessArray.push(guessArray[i]);
				}
				if (favGuessArray.length) guessArray = favGuessArray;

				// Get the most used match
				if (!newFrom) {
					for (var key in useCount) {
						if (guessArray.indexOf(key) != -1) {
							newFrom = key;
							break;
						}
					}
				}
				if (!newFrom) newFrom = guessArray[0];

			}
			if (newFrom) {
				showServices(newFrom,showAll);
				$('from').value = newFrom;
				selectFrom(newFrom,false);
			}
	
		}

	}

}

function selectFrom ( thisValue, userSelected ) {

	if (thisValue == 'all') {

		showAll = true;
		if (window.widget) widget.setPreferenceForKey(true,'showall');
		showServices(editingDelivery.from,true);
		$('from').value = editingDelivery.from;

	} else if (thisValue == 'favs') {

		showAll = false;
		if (window.widget) widget.setPreferenceForKey(false,'showall');
		showServices(editingDelivery.from,false);
		$('from').value = editingDelivery.from;
		
	} else {

		if (userSelected) editingDelivery.fromEdited = true;
		updateEditForm(thisValue);

	}

}

function updateEditForm ( thisFrom ) {

	$('from-text').innerText = getFromName(thisFrom,true,true);
	$('delivery-info').innerText = '';

	editingDelivery.from = thisFrom;
	editingDelivery.setFrom();
	updateFavorite(thisFrom);

	if (!extraEdited || !$('extra').value) {
		$('extra').value = (widget.preferenceForKey(thisFrom+'-email')) ? 
			widget.preferenceForKey(thisFrom+'-email') : '';
		$('password').value = ($('extra').value) ? getPassword(thisFrom,$('extra').value) : '';	
		extraEdited = false;
	}

	editingDelivery.changedPassword = false;

	if (thisFrom == 'www.apple.com' || thisFrom == 'www.apple.com/zip' || thisFrom == 'www.apple.com/japan' || 
		thisFrom == 'www.apple.com/japanzip' || thisFrom == 'www.apple.com/hk') {

		$('nolabel').innerText = translate('Order Number:');
		$('noField').title = translate('Enter the order number from your confirmation email. You can also visit the web site and log into your account to look up your order number.');

		showExtra(true,editingDelivery.passRequired,false);
		if (thisFrom == 'www.apple.com/zip' || thisFrom == 'www.apple.com/japanzip') {
			$('extralabel').innerText = translate('Shipping Address Zip Code:');
			$('extraField').title = translate('Enter the postal code of the address your order is shipping to.');
		} else {
			$('extralabel').innerText = translate('Email Address:');
			$('extraField').title = translate('Enter the email address associated with your order.');
		}

	} else if (thisFrom == 'www.city-link.co.uk' || thisFrom == 'nolp.dhl.de' || thisFrom == 'www.tntpost.nl') {

		trackingFieldDefaults();
		showExtra(true,editingDelivery.passRequired,false);
		$('extralabel').innerText = translate('Shipping Address Zip Code:');
		$('extraField').title = translate('Enter the postal code of the address your order is shipping to.');

	} else if (thisFrom == 'www.poste.it') {

		trackingFieldDefaults();
		showExtra(false,false,false);

	} else if (thisFrom == 'other') {

		trackingFieldDefaults();
		showExtra(true,false,true);
		$('extralabel').innerText = translate('Web Site:');
		$('extraField').title = translate('Enter the address of the web site you use to track your delivery.');
		$('datelabel').innerText = translate('Delivery Date:');
		$('dateField').title = translate('Enter the date you expect this package to be delivered.');

	} else if (editingDelivery.extraRequired == false) {

		showExtra(false,false,false);
		if (thisFrom == 'www.tnt.com') {
			$('nolabel').innerText = translate('Consignment Number:');
			$('noField').title = translate('Enter the consignment number for your package.');
		} else if (thisFrom == 'www.royalmail.com' || thisFrom == 'www.tnt.com/ref') {
			$('nolabel').innerText = translate('Reference Number:');
			$('noField').title = translate('Enter the reference number for your package.');
		} else trackingFieldDefaults();

	} else {

		showExtra(true,editingDelivery.passRequired,false);
		$('extralabel').innerText = translate('Email Address:');
		$('extraField').title = translate('Enter the email address you use to log in to your account at this store.');
		$('nolabel').innerText = translate('Order Number:');
		$('noField').title = translate('Enter the order number from your confirmation email. You can also visit the web site and log into your account to look up your order number.');

	}

	$('no').placeholder = (thisFrom == 'other') ? translate('Optional') : '';

}

function trackingFieldDefaults () {
	$('nolabel').innerText = translate('Tracking Number:');
	$('noField').title = translate('Enter the tracking number for your package.');
}

function showExtra ( extraVisible, passVisible, dateVisible ) {
	$('extraField').style.display = (extraVisible) ? 'block' : 'none';
	$('passwordField').style.display = (passVisible) ? 'block' : 'none';
	$('dateField').style.display = (dateVisible) ? 'block' : 'none';
	if (!extraVisible) $('extra').value = '';
	if (!passVisible) $('password').value = '';
	$('extra').placeholder = (editingDelivery.extraRequired) ? '' : translate('Optional');
}

function editedExtra () {
	extraEdited = true;
	$('password').value = ($('extra').value) ? getPassword($('from').value,$('extra').value) : '';
}

function editedPassword () {
	editingDelivery.changedPassword = true;
}

function updateFavorite ( thisFrom ) {
	$('fav').className = (favorites.indexOf(thisFrom) != -1) ? 'favorite' : '';
}

function toggleFavorite () {

	var thisFrom = $('from').value;
	var index = favorites.indexOf(thisFrom);
	if (index == -1) {
		var newFavorites = new Array();
		favorites.push(thisFrom);
		for (var x in services) {
			if (favorites.indexOf(services[x]) != -1) newFavorites.push(services[x]);
		}
		favorites = newFavorites;
	} else favorites.splice(index,1);

	if (window.widget) widget.setPreferenceForKey(favorites.join(';'),'favorites');

	updateFavorite(thisFrom);
	showServices(thisFrom,showAll);
	sortUseCount();
	$('from').value = thisFrom;

}

function saveSettings ( finish ) {
	if (currentView == 'edit') {
		if (checkComplete(editingDelivery)) {
			// Important to call this first, so any size adjustments are made later
			if (finish) finishEditing();
			saveDelivery(editingDelivery);
		}
	} else {
		growlEnabled = $('growl').checked;
		pushEnabled = $('push').checked;
		largePrint = $('size').checked;

		if (window.widget) {
			widget.setPreferenceForKey($('growl').value,'usegrowl');
			widget.setPreferenceForKey($('push').value,'usepush');
			widget.setPreferenceForKey($('size').value,'size');
		}
		if (finish) finishEditing();
	}
}

function finishEditing () {
	switchToView('front','deliveries');
}

function checkComplete ( delivery ) {
	var theResult = false;
	var theMessage = '';
	var missingFields = new Array();
	if ($('from').value != 'other') {
		if (!$('no').value) missingFields.push(getLabel('no'));
		if (delivery.extraRequired && !$('extra').value) missingFields.push(getLabel('extra'));
		if (delivery.passRequired && !$('password').value) missingFields.push(getLabel('password'));
	}
	switch (missingFields.length) {
		case 0:
			theResult = true;
			break;
		case 1:
			theResult = false;
			theMessage = translateFormat("%@ is required.",
				missingFields[0]);
			break;
		case 2:
			theResult = false;
			theMessage = translateFormat("%@ and %@ are required.",
				missingFields[0],missingFields[1]);
			break;
		default:
			theResult = false;
			theMessage = translateFormat("%@, %@, and %@ are required.",
				missingFields[0],missingFields[1],missingFields[2]);
			break;
	}
	$('delivery-info').innerText = theMessage;
	return theResult;
}

function getLabel ( thisField ) {
	var thisLabel = $(thisField+'label').innerText;
	return thisLabel.replace(/:$/i,'');
}

function saveDelivery ( delivery ) {

	if (!delivery.id) delivery.id = getUUID();
	if (window.widget) {

		var now = getUnixTime();
		$('no').value = trim($('no').value);
		$('extra').value = trim($('extra').value);

		widget.setPreferenceForKey($('name').value,delivery.id+'-itemname');
		widget.setPreferenceForKey($('from').value,delivery.id+'-store');
		widget.setPreferenceForKey($('from').value,'store');
		widget.setPreferenceForKey($('no').value,delivery.id+'-orderno');
		widget.setPreferenceForKey($('extra').value,delivery.id+'-email');
		widget.setPreferenceForKey($('extra').value,$('from').value+'-email');
		widget.setPreferenceForKey(now,delivery.id+'-modified');

		if ($('from').value == 'other' && $('month').value) {

			var thisMonth = parseInt($('month').value) + 1;
			thisMonth = (thisMonth < 10) ? '0'+thisMonth : thisMonth;
			var thisDay = ($('day').value) ? $('day').value : 1;
			thisDay = (thisDay < 10) ? '0'+thisDay : thisDay;
			var thisYear = ($('year').value) ? $('year').value : (new Date()).getFullYear();
			var thisDate = thisYear+'-'+thisMonth+'-'+thisDay;
			widget.setPreferenceForKey(thisDate,delivery.id+'-date');
			
			widget.setPreferenceForKey(null,delivery.id+'-html');
			widget.setPreferenceForKey(null,delivery.id+'-htmldate');
			
		} else widget.setPreferenceForKey(null,delivery.id+'-date');

		if (DeliveryStatus && $('password').value) {
			DeliveryStatus.setPassword($('from').value,$('extra').value,$('password').value);
			if (delivery.changedPassword) {
				var shouldUpdate = false;
				for (var i in deliveries) {	
					if (deliveries[i].id != delivery.id &&
						deliveries[i].from == $('from').value && 
						deliveries[i].extra == $('extra').value) {
						deliveries[i].password = $('password').value;
						deliveries[i].nextUpdate = 0;
						shouldUpdate = true;
					}
				}
				if (shouldUpdate) updateDeliveries(false,true);
			}
			$('password').value = '';
		}

		updateHistory(delivery.id);
		extraEdited = false;

	}

	delivery = queueDeliveryObject(delivery.id,false);
	syncDelivery(delivery.id,'add',0);

}

function saveHTML ( delivery ) {
	if (window.widget) {
		widget.setPreferenceForKey(delivery.html,delivery.id+'-html');
		widget.setPreferenceForKey(delivery.htmldate,delivery.id+'-htmldate');
	}
}

function queueDeliveryObject ( id, thisDelete ) {

	var delivery;
	var i = getIndex(id);

	if (thisDelete) {
		if (i >= 0) {
			deliveries.splice(i,1);
			closeQueue.push($(id));
		}	
	} else {
		if (i >= 0) {
			delivery = loadDelivery(id,i);
			updateQueue.add(deliveries[i]);
		} else {
			delivery = loadDelivery(id,-1);
			deliveries.unshift(delivery);
			updateQueue.add(delivery);
			updateUseCount(delivery.from);
		}
		updateQueue.updateIfIdle();
	}
	saveDeliveries();
	return delivery;

}

function saveDeliveries () {
	var thisList = new Array();
	for (var i in deliveries) thisList[i] = deliveries[i].id;
	thisList = thisList.join(';');
	widget.setPreferenceForKey(thisList,'deliveries');
}


// growl


function checkNotifications () {

	if (DeliveryStatus && DeliveryStatus.getGrowl()) {
		growlEnabled = (widget.preferenceForKey('usegrowl')) ? true : false;
		$('growl').checked = growlEnabled;
		$('growl').disabled = false;
		$('growlField').className = '';
	} else {
		growlEnabled = false;
		$('growl').checked = false;
		$('growl').disabled = true;
		$('growlField').className = 'disabled';
	}
	if (syncEnabled()) {
		pushEnabled = (widget.preferenceForKey('usepush')) ? true : false;
		$('push').checked = pushEnabled;
		$('push').disabled = false;
		$('pushField').className = '';
	} else {
		pushEnabled = false;
		$('push').checked = false;
		$('push').disabled = true;
		$('pushField').className = 'disabled';
	}

}

function activeUse () {
	// If Dashboard is open and the computer has been used in the past minute, it's active
	var result = false;
	if (dashboardActive) {
		var idleTime = (DeliveryStatus) ? DeliveryStatus.getIdleTime() : 0;
		if (idleTime < 60) result = true;
	}
	return result;
}

function showNotifications (delivery) {

	if (delivery.success > 0 && (growlEnabled || pushEnabled)) {

		var yesterday =  (new Date()).getTime() - 86400000;
		var emptyStatus = new Array(translate('Shipped!'),translate('Ship date unknown'));
		var hasError = (delivery.success < 2);
		var thisKey = (hasError) ? delivery.id+'-error' : delivery.id+'-status';
		var newUpdates = new Array();
		var lastUpdates = (widget.preferenceForKey(thisKey)) ? JSON.parse(widget.preferenceForKey(thisKey)) : new Array();

		for (var x in delivery.items) {

			var thisItem = delivery.items[x];

			// 1: status change
			// 2: delivered
			// 3: error
			// 4: new version

			var thisType = 1;
			if (hasError) {
				thisType = 3;
			} else if (thisItem['theStatus'].match(/^complete$/i)) {
				thisType = 2;
			}

			var lastUpdate = lastUpdates[x];
			var lastArray = (lastUpdate) ? lastUpdate.split(';') : new Array();
			var lastStatus = (lastArray[1]) ? lastArray[1] : '';
			var lastDate = lastArray[2];
			var lastStatusDate = lastArray[3];
			var lastType = lastArray[4];

			var compareItem = thisItem['theItem'].replace(/[;]/g,'');
			var compareStatus = formatLine(thisItem['shipDate'],thisItem['shipStamp'],0,false,true).replace(/[:;,.]/g,'');
			if (delivery.from == 'other') compareStatus = delivery.htmldate;
			var compareDate = thisItem['date'];
			var compareStatusDate = thisItem['statusDate'];
			var compareType = thisType;

			var thisUpdate = (new Array(compareItem,compareStatus,compareDate,compareStatusDate,compareType)).join(';');

var realUpdate = thisUpdate;

			var ratio = 0;
			var changed = false;

			// First check to see if this exact status was displayed for a different item before.
			// If it was we assume the items were just reordered, and don't show anything, just save the new status.

			if (lastUpdates.indexOf(thisUpdate) == -1) {

				// Ignore dates in the past and (essentially) empty status updates
				if (compareDate < yesterday && lastDate) compareDate = lastDate;
				// Once we start picking up the time, copy over the previous status if the date and time are exact
				// This would fix problems with DHL Express, TNT Post Netherlands, possibly others
				if (lastStatus && emptyStatus.indexOf(compareStatus) != -1) {
					compareStatus = lastStatus;
					compareStatusDate = lastStatusDate;
					compareType = lastType;
				}
				thisUpdate = (new Array(compareItem,compareStatus,compareDate,compareStatusDate,compareType)).join(';');

				if (hasError) {

					var ratio = diffRatio(lastStatus,compareStatus);
					if (ratio < 0.72) changed = true; // Status changed significantly

if (changed) alert ('Error text changed ('+delivery.no+')');

				} else if (delivery.from == 'other') { // Other delivery

					if (compareStatus && compareStatus != lastStatus) changed = true;

if (changed) alert ('Other text changed ('+delivery.no+')');

				} else if (compareType == 2 && lastType != 2) { // Changed to delivered

alert('Delivered status changed ('+delivery.no+')');

					changed = true;
				} else if (compareDate && compareDate != lastDate) { // Ship or delivery date changed

alert('Ship or delivery date changed ('+delivery.no+')');

					changed = true;

				} else {
					var ratio = diffRatio(lastStatus,compareStatus);
					if (ratio < 1) {

						// Status changed significantly or the status date changed
						// Ignore 0.72 and above, display 0.72 and below, must display 0.62 and below
						if (ratio < 0.72) {

alert('Ratio is less than 0.72 ('+ratio+' for '+delivery.no+')');

							changed = true;
						} else if (compareStatusDate && compareStatusDate != lastStatusDate) {

alert('Status date changed ('+ratio+' for '+delivery.no+')');

							changed = true;
						}

					}
				}

			} else {
			
if (lastUpdates.indexOf(thisUpdate) != x) alert('Item found in a different position ('+delivery.no+')');

			}

			if (changed) {

alert('Last updates: '+lastUpdates.join('\n'));
alert('This update: '+thisUpdate);

				var inuse = activeUse();

if (inuse) alert('In use?');

				var thisTitle = removeHtmlEntities(thisItem['theItem']);
				var thisStatus = formatLine(thisItem['shipDate'],thisItem['shipStamp'],2,false,true)+'\n'+
					formatLine(thisItem['deliveryDate'],thisItem['deliveryStamp'],2,false,true);

				if (growlEnabled && !inuse && DeliveryStatus) {
					DeliveryStatus.setGrowl(thisType,thisTitle,thisStatus,'Icon');
				}

				if (pushEnabled && thisType <= 2 && !inuse) {

					// The limit for theData is around 161 bytes
					// Display only fits around 150, 35 per line

					if (thisTitle.length > 70) thisTitle = thisTitle.substring(0,70)+'…';
					var charsLeft = 150 - thisTitle.length;
					if (thisStatus.length > charsLeft) thisStatus = thisStatus.substring(0,charsLeft)+'…';
					pushNotification('push',thisTitle+'\n'+thisStatus,delivery.id);

				}

			} else {

if (thisUpdate != lastUpdate) alert('No notification! '+delivery.no+' ratio: '+ratio+'\nold: '+lastUpdate+'\nnew: '+realUpdate);

			}

			newUpdates.push(thisUpdate);
	
		}

		widget.setPreferenceForKey(JSON.stringify(newUpdates),thisKey);

	}

}

function diffRatio ( oldText, newText ) {
	var ratio = 0;
	if (oldText == newText) {
		ratio = 1;
	} else if (typeof oldText == 'string' && typeof newText == 'string') {
		var oldLines = difflib.stringAsLines(oldText.replace(/\s+/g,'\n'));
		var newLines = difflib.stringAsLines(newText.replace(/\s+/g,'\n'));
		var sm = new difflib.SequenceMatcher(oldLines,newLines);
		ratio = sm.quick_ratio();
	}
	return ratio;
}

function pushNotification (theCmd,theData,theId) {

	var pushData = 'cmd='+theCmd+'&type=widget&version='+syncVersion+
		'&client='+encodeURIComponent(sync.client)+
		'&email='+encodeURIComponent(sync.email)+
		'&password='+encodeURIComponent(sync.password)+
		'&data='+encodeURIComponent(theData);
	if (theId) pushData += '&id='+encodeURIComponent(theId);
	var theArgs = {'function':'pushNotification','cmd':theCmd,'data':theData,'id':theId};	

	alert('Sending notification: '+theData);
	sync.loadPage('https://junecloud.com/sync/deliveries/push.php',false,pushData,theArgs);

}


// donations


function setDonated (getValue) {

	var theValue = false;
	if (getValue) {
		if (getDonated() + 1 >= thisVersion) theValue = true;
	} else {
		if ($('alreadydonated').checked) theValue = true;
	}
	if (theValue == true) {
		$('alreadydonated').checked = true;
		widget.setPreferenceForKey(thisVersion,'donated');
		$('donate-info').innerText = translate('Thank you for your donation! Your support allows us to keep making Delivery Status the best package tracking widget possible.');
	} else {
		$('alreadydonated').checked = false;
		widget.setPreferenceForKey(0,'donated');
		$('donate-info').innerText = translate('This widget is free, but it takes a lot of time to keep it working with so many different services. Please consider a small donation to help support Delivery Status!');
	}
	$('alreadydonatedlabel').innerText = translate('Check this box if you have donated.');

}

function getDonated ( ) {
	var donatedVersion = 0;
	if (window.widget) donatedVersion = widget.preferenceForKey('donated');
	return donatedVersion;
}

function openDonate() {
	openSite('http://junecloud.com/software/donate/');
}


// history


function populateHistory () {

	if (window.widget) {

		// var prefsVersion = widget.preferenceForKey('prefsversion');
		// if (prefsVersion < 5.0) widget.setPreferenceForKey(5.0,'prefsversion');

		// check for hidden historydays setting

		historyDays = (widget.preferenceForKey('historydays') > 0) ? widget.preferenceForKey('historydays') : 30;

		// populate the item history

		var theHistory = (widget.preferenceForKey('history')) ? widget.preferenceForKey('history') : '';
		var historyArray = theHistory.split(';');
		var newHistoryArray = new Array();

		var optCount = 1;
		var optSelected = 0;
		var thePopup = $('history');
		while (thePopup.hasChildNodes()) {
			thePopup.removeChild(thePopup.firstChild);
		}
		thePopup.options[0] = new Option('');

		for (var i in historyArray) {
			var thisId = historyArray[i];
			if (widget.preferenceForKey(thisId+'-store')) {

				var thisUpdated = widget.preferenceForKey(thisId+'-modified');
				if (!thisUpdated) {
					thisUpdated = getUnixTime();
					widget.setPreferenceForKey(thisUpdated,thisId+'-modified');
				}
				if (thisUpdated + (86400 * historyDays) > getUnixTime() || optCount <= 25) {

					newHistoryArray.push(thisId);
					var thisFrom = widget.preferenceForKey(thisId+'-store');
					var thisItem = widget.preferenceForKey(thisId+'-orderno');
					if (thisId == editingDelivery.id) optSelected = optCount;

					if (widget.preferenceForKey(thisId+'-historytitle')) {
						thisItem = widget.preferenceForKey(thisId+'-historytitle');
					} else if (widget.preferenceForKey(thisId+'-itemname')) {
						thisItem = widget.preferenceForKey(thisId+'-itemname');
					}

					thisFrom = getFromName(thisFrom,true,false);
					thePopup.options[optCount] = new Option(thisFrom+': '+thisItem,thisId);
					optCount++;

				} else removeDelivery(thisId);

			} else removeDelivery(thisId);
		}
		if (thePopup.options.length > 1) {
			thePopup.options[optCount] = new Option(translate('Clear History'),'Clear History');
			var newElement = document.createElement('hr');
			thePopup.insertBefore(newElement,thePopup.options[optCount]);
		}
		thePopup.options[optSelected].selected = true;
		setSelect('history',false);
		theHistory = newHistoryArray.join(';');
		widget.setPreferenceForKey(theHistory,'history');

	}

}

function loadHistory ( thisId ) {

	if (thisId == 'Clear History') {

		$('history-text').innerText = '';
		var theHistory = (widget.preferenceForKey('history')) ? widget.preferenceForKey('history') : '';
		var historyArray = theHistory.split(';');
		var newHistory = new Array();
		for (var i in historyArray) {
			if (!removeDelivery(historyArray[i])) newHistory.push(historyArray[i]);
		}
		widget.setPreferenceForKey(newHistory.join(';'),'history');
		populateHistory();

	} else {

		setSelect('history',false);
		
		if (thisId) {
			if (!editingDelivery.id) {
				if (getIndex(thisId) >= 0) {
					editingDelivery.id = getUUID();
				} else editingDelivery.id = thisId;
			}
	
			var thisFrom = (widget.preferenceForKey(thisId+'-store')) ? 
				widget.preferenceForKey(thisId+'-store') : 'www.amazon.com';
	
			// Make sure the "from" menu includes the selected service
			if (!showAll) showServices(thisFrom,false);
	
			$('name').value = (widget.preferenceForKey(thisId+'-itemname')) ? 
				widget.preferenceForKey(thisId+'-itemname') : '';
			$('from').value = thisFrom;
			$('extra').value = (widget.preferenceForKey(thisId+'-email')) ? 
				widget.preferenceForKey(thisId+'-email') : '';
			$('no').value = (widget.preferenceForKey(thisId+'-orderno')) ? 
				widget.preferenceForKey(thisId+'-orderno') : '';
			if ($('extra').value) $('password').value = getPassword($('from').value,$('extra').value);
	
	
			var dateString = (widget.preferenceForKey(thisId+'-date')) ? 
				widget.preferenceForKey(thisId+'-date').toString().replace(/-/g,'/') : '';
	
			if (dateString) {
				var thisDate = new Date(dateString);
				setSelect('month',thisDate.getMonth());
				setSelect('day',thisDate.getDate());
				setSelect('year',thisDate.getFullYear());
			} else {
				setSelect('month','');
				setSelect('day','');
				setSelect('year','');
			}
	
			extraEdited = true;
			updateEditForm($('from').value);
		}

	}

}

function updateHistory ( thisId ) {

	if (window.widget && thisId) {

		var theHistory = (widget.preferenceForKey('history')) ? widget.preferenceForKey('history') : '';
		var historyArray = theHistory.split(';');

		var orderFound = false;
		for (var i in historyArray) {
			if (thisId == historyArray[i]) {
				orderFound = true;
				if (i > 0) {
					historyArray.splice(i,1);
					orderFound = false;
				}
				break;
			}
		}
		if (!orderFound) historyArray.unshift(thisId);
		theHistory = historyArray.join(';');
		widget.setPreferenceForKey(theHistory,'history');

	}

}

function removeDelivery (thisId) {
	var removed = false;
	if (thisId && getIndex(thisId) == -1) {
		widget.setPreferenceForKey(null,thisId+'-itemname');
		widget.setPreferenceForKey(null,thisId+'-store');
		widget.setPreferenceForKey(null,thisId+'-orderno');
		widget.setPreferenceForKey(null,thisId+'-email');
		widget.setPreferenceForKey(null,thisId+'-size');
		widget.setPreferenceForKey(null,thisId+'-item');
		widget.setPreferenceForKey(null,thisId+'-error');
		widget.setPreferenceForKey(null,thisId+'-status');

		// No longer used as of 5.4, remove this in the future
		widget.setPreferenceForKey(null,thisId+'-0-error');
		widget.setPreferenceForKey(null,thisId+'-0-status');
		widget.setPreferenceForKey(null,thisId+'-1-status');
		widget.setPreferenceForKey(null,thisId+'-2-status');
		widget.setPreferenceForKey(null,thisId+'-3-status');
		widget.setPreferenceForKey(null,thisId+'-4-status');
		widget.setPreferenceForKey(null,thisId+'-5-status');
		widget.setPreferenceForKey(null,thisId+'-6-status');
		widget.setPreferenceForKey(null,thisId+'-7-status');
		widget.setPreferenceForKey(null,thisId+'-8-status');
		widget.setPreferenceForKey(null,thisId+'-9-status');

		widget.setPreferenceForKey(null,thisId+'-historytitle');
		widget.setPreferenceForKey(null,thisId+'-date');
		widget.setPreferenceForKey(null,thisId+'-html');
		widget.setPreferenceForKey(null,thisId+'-htmldate');
		widget.setPreferenceForKey(null,thisId+'-modified');
		widget.setPreferenceForKey(null,thisId+'-items');
		removed = true;
	}
	return removed;
}


// version checking


function getCurrentVersion () {

	var request = new XMLHttpRequest();
	request.open('GET','Info.plist',false);
	request.send();

	var nodes = request.responseXML.getElementsByTagName('dict')[0].childNodes;
	var nodeLength = nodes.length;
	for (var i = 0; i < nodeLength; i++) {
		if (nodes[i].nodeType == 1 && nodes[i].tagName.toLowerCase() == 'key') {
			if (nodes[i].firstChild.data == 'CFBundleShortVersionString') {
				readableVersion = nodes[i+2].firstChild.data;
			} else if (nodes[i].firstChild.data == 'CFBundleVersion') {
				var result = nodes[i+2].firstChild.data;
				result = result.replace(/([0-9]+)\.([0-9]+)\.([0-9]+)/,'$1.$2$3');
				thisVersion = currentVersion = parseFloat(result);				
			}
		} 
	} 

}

function checkVersion (theDays,skipDismissed) {

	var lastVersionCheck = (widget.preferenceForKey('lastversioncheck')) ? 
		widget.preferenceForKey('lastversioncheck') : 0;
	var dismissedUpdate = (widget.preferenceForKey('dismissedupdate')) ? 
		widget.preferenceForKey('dismissedupdate') : 0;
	var currentTime = (new Date()).getTime();

	if (skipDismissed || !dismissedUpdate || dismissedUpdate + (86400000 * dismissDays) < currentTime) {
		if (lastVersionCheck + (86400000 * theDays) < currentTime) {
			checkVersionNow();
		} else {
			currentVersion = (widget.preferenceForKey('currentversion')) ? 
				parseFloat(widget.preferenceForKey('currentversion')) : thisVersion;
			if (currentVersion > thisVersion) showUpdateBadge();
		}
	}

}

function checkVersionNow () {
	sync.loadPage('https://junecloud.com/software/mac/version.php',getVersion,'id='+appId,false);
}

function getVersion () {

	var currentTime = (new Date()).getTime();
	widget.setPreferenceForKey(currentTime,'lastversioncheck');

	if (this.status == 200 && this.responseXML) {
		for (var child = this.responseXML.firstChild; child != null; child = child.nextSibling) {
			if (child.nodeName == 'versionstatus') {
				var itemlist = child;
				for (var item = itemlist.firstChild; item != null; item = item.nextSibling) {
					if (item.nodeName == 'version') {
						currentVersion = parseFloat(item.getAttribute('value'));
						widget.setPreferenceForKey(currentVersion,'currentversion');
					} else if (item.nodeName == 'download') {
						downloadUrl = item.getAttribute('value');
					}
				}
				break;
			}
		}
	}

	if (currentVersion > thisVersion) {
		showUpdateBadge();
		if (DeliveryStatus && growl) DeliveryStatus.setGrowl(4,'Delivery Status',
			translate('A new version of Delivery Status is available!'),'Icon');
	}

	this.reqComplete++;
	return;

}

function showUpdateBadge () {
	$('getupdate').href = downloadUrl;
	$('getupdate').title = translate('A new version of Delivery Status is available! Click here to download it.');
	$('updatebox').style.display = 'block';
}

function dismissUpdate () {
	widget.setPreferenceForKey((new Date()).getTime(),'dismissedupdate');
	$('updatebox').style.display = 'none';
}


// cookie request functions


function loadCookiePage (thisUrl,theFunction,theData,theArgs) {

	var thisReq = this.reqCount;
	this.reqCount++;

	var thisRequest = new Object();
	thisRequest.abort = function() { };
	thisRequest.checkForData = checkForData;
	thisRequest.getTracker = getTracker;
	thisRequest.delivery = this;
	thisRequest.runCount = 0;
	thisRequest.id = this.id;
	thisRequest.args = (theArgs) ? theArgs : new Array();
	thisRequest.oncomplete = theFunction;
	if (!theData) theData = '';

	this.req[thisReq] = thisRequest;

	if (DeliveryStatus) {
		thisRequest.resultId = DeliveryStatus.loadWebPage(thisUrl,theData,navigator.userAgent);
		setTimeout(function(){ thisRequest.checkForData() },300);
	}

}

function checkForData () {

	var thisResult;
	if (DeliveryStatus && this.resultId && this.id) 
		thisResult = DeliveryStatus.getWebPageForId(this.resultId);

	// Get data or time out after 30 seconds (300ms x 100)
	if (!thisResult && this.runCount >= 100) thisResult = '503';
	if (thisResult) {

		if (thisResult.match(/^[0-9]+$/)) {
			this.responseText = '';
			this.status = parseInt(thisResult);
			if (this.status = 999) this.oncomplete = connectFailed;
		} else {
			this.responseText = thisResult;
			this.status = 200;
		}

		switch(this.oncomplete) {
			case connectFailed:
				this.delivery.connectFailed();
				break;
			case sessionAdobe:
				this.sessionAdobe = sessionAdobe;
				this.sessionAdobe();
				break;
			case getAdobe:
				this.getAdobe = getAdobe;
				this.getAdobe();
				break;
			case sessionAmazon:
				this.sessionAmazon = sessionAmazon;
				this.sessionAmazon(); 
				break;
			case getAmazon:
				this.sessionAmazon = sessionAmazon;
				this.getAmazon = getAmazon;
				this.getAmazon(); 
				break;
			case getGoogle:
				this.getGoogle = getGoogle;
				this.getGoogle();
				break;
			case getHermes:
				this.getHermes = getHermes;
				this.getHermes();
				break;
			case getTNT:
				this.getTNT = getTNT;
				this.getTNT();
				break;
			case getTNTPost:
				this.getTNTPost = getTNTPost;
				this.getTNTPost();
				break;
			case getParcelforce:
				this.getParcelforce = getParcelforce;
				this.getParcelforce();
				break;
			case getTracker:
				this.getTracker();
				break;
		}

	} else {
		this.runCount++;
		var thisRequest = this;
		setTimeout(function(){ thisRequest.checkForData() },300);
	}

}


// syncing


function changedSyncEmail () {
	if ($('cmd').value == 'login') $('syncpassword').value = 
		($('syncemail').value) ? getPassword('junecloud.com',$('syncemail').value) : '';
}

function setSync ( theCmd ) {

	$('cmd').value = theCmd;

	if (sync.success && sync.email) {
		$('login-info').innerText = translateFormat('You are currently signed in as %@',sync.email);
		selectTab('sync signedin');
	} else {
		if (theCmd == 'register') {
			$('syncemail').value = '';
			$('syncpassword').value = '';
			$('syncconfirm').value = '';
			$('syncname').value = '';
			$('syncterms').checked = false;
			selectTab('sync register');
		} else selectTab('sync signin');
	}

}

function saveSync () {

	if (!$('syncemail').value) {
		$('sync-info').innerText = translate('Please enter your email address.');
	} else if (!$('syncpassword').value) {
		$('sync-info').innerText = translate('Please enter your password.');
	} else if ($('cmd').value == 'register' && $('syncpassword').value != $('syncconfirm').value) {
		$('sync-info').innerText = translate('Both password fields must match.');
	} else if ($('cmd').value == 'register' && !$('syncterms').checked) {
		$('sync-info').innerText = translate('You must agree to the Terms of Service to continue.');
	} else {

		sync.email = $('syncemail').value;
		sync.password = $('syncpassword').value;

		widget.setPreferenceForKey(sync.email,'syncemail');
		if (DeliveryStatus) DeliveryStatus.setPassword('junecloud.com',sync.email,sync.password);

		var syncData = 'cmd='+$('cmd').value+'&type=widget&version='+syncVersion+
			'&client='+encodeURIComponent(sync.client)+
			'&updated='+encodeURIComponent(sync.updated)+
			'&now='+encodeURIComponent(getUnixTime())+
			'&email='+encodeURIComponent($('syncemail').value);

		if ($('cmd').value == 'register') {

			sync.first = 1;
			syncData += '&newpassword='+encodeURIComponent($('syncpassword').value)+
				'&confirmpass='+encodeURIComponent($('syncconfirm').value)+
				'&name='+encodeURIComponent($('syncname').value);
			if ($('syncterms').checked) syncData += '&terms=1';

		} else {

			sync.first = 2;
			syncData += '&password='+encodeURIComponent($('syncpassword').value);

		}

		showMessage(translate('Syncing with Junecloud…'));
		$('sync-info').innerHTML = translate('Syncing with Junecloud…');
		sync.loadPage('https://junecloud.com/sync/deliveries/xml.php',getSyncResult,syncData,false);

	}

}

function syncEnabled () {
	return (sync.email && sync.password) ? true : false;
}

function timeForSync () {
	var thisResult = false;
	if (syncEnabled()) {
		if (sync.force) {
			thisResult = true;
			sync.force = false;
		} else {
			var now = getUnixTime() - sync.offset;
			var inuse = activeUse();
			if ((inuse && now > sync.updated + 300) || (!inuse && now > sync.updated + 1800)) {
				thisResult = true;
			}
		}
	}
	return thisResult;
}

function syncDelivery (thisId, thisCmd, thisDate) {
	if (syncEnabled()) {

		var modified = thisDate;
		if (!modified && widget.preferenceForKey(thisId+'-modified')) modified = 
			parseFloat(widget.preferenceForKey(thisId+'-modified')) - sync.offset;

		var syncData = 'cmd='+thisCmd+'&type=widget&version='+syncVersion+'&defs='+defsVersion+
			'&client='+encodeURIComponent(sync.client)+
			'&updated='+encodeURIComponent(sync.updated)+
			'&now='+encodeURIComponent(getUnixTime())+
			'&email='+encodeURIComponent(sync.email)+
			'&password='+encodeURIComponent(sync.password)+
			'&uuid='+encodeURIComponent(thisId);
		if (modified) syncData += '&modified='+modified;

		if (thisCmd == 'add') {
			syncData += '&from='+encodeURIComponent(widget.preferenceForKey(thisId+'-store'))+
				'&name='+encodeURIComponent(widget.preferenceForKey(thisId+'-itemname'))+
				'&no='+encodeURIComponent(widget.preferenceForKey(thisId+'-orderno'))+
				'&extra='+encodeURIComponent(widget.preferenceForKey(thisId+'-email'));
			if (widget.preferenceForKey(thisId+'-date'))
				syncData += '&date='+encodeURIComponent(widget.preferenceForKey(thisId+'-date'));
		}

		showMessage(translate('Syncing with Junecloud…'));
		$('sync-info').innerHTML = translate('Syncing with Junecloud…');

		var theArgs = {'function':'syncDelivery','cmd':thisCmd,'id':thisId,'date':modified};
		sync.loadPage('https://junecloud.com/sync/deliveries/xml.php',getSyncResult,syncData,theArgs);

	}
}

function queueDelivery (thisId, thisCmd, thisDate) {
	var modified = thisDate;
	if (!modified && widget.preferenceForKey(thisId+'-modified')) modified = 
		parseFloat(widget.preferenceForKey(thisId+'-modified')) - sync.offset;
	var thisItem = {'function':'syncDelivery','cmd':thisCmd,'id':thisId,'date':modified};
	syncQueue.push(thisItem);
}

function removeFromQueue (thisId, olderThan) {
	for (var i in syncQueue) {
		if (syncQueue[i]['id'] == thisId) {
			if (syncQueue[i]['date'] < olderThan) {
				syncQueue.splice(i,1);
				return true;
			} else return false;
		}
	}
	return true;
}

function startSync () {

	var syncNow = false;
	var loggedIn = false;
	
	if (syncEnabled()) {
		if (syncQueue.length || timeForSync()) syncNow = true;
		loggedIn = true;
	} else {
		var currentTime = getUnixTime();		
		// If syncing is disabled, update once a week,
		// or once a day if there are errors
		if (currentTime >= defsUpdate + 604800) {
			syncNow = true;
		} else if (currentTime >= defsUpdate + 86400) {
			for (var i in deliveries) {
				if (deliveries[i].success < 2) {
					syncNow = true;
					break;
				}
			}
		}
	}

	sync.updateAfter = true;
	if (syncNow) {
		if (!continueSync()) {
			var syncData = 'type=widget&version='+syncVersion+'&defs='+defsVersion;
			if (loggedIn) {
				syncData += '&cmd=get&client='+encodeURIComponent(sync.client)+
					'&updated='+encodeURIComponent(sync.updated)+
					'&now='+encodeURIComponent(getUnixTime())+
					'&email='+encodeURIComponent(sync.email)+
					'&password='+encodeURIComponent(sync.password);
				showMessage(translate('Syncing with Junecloud…'));
				$('sync-info').innerHTML = translate('Syncing with Junecloud…');
			} else showMessage(translate('Updating service definitions…'));
			sync.loadPage('https://junecloud.com/sync/deliveries/xml.php',getSyncResult,syncData,false);
		}
	} else syncFinish();

}

function continueSync () {
	var willContinue = false;
	if (syncQueue.length) {
		var thisItem = syncQueue.shift();
		if (thisItem['function'] == 'syncDelivery') {
			syncDelivery(thisItem['id'],thisItem['cmd'],thisItem['date']);
		} else if (thisItem['function'] == 'pushNotification') {
			pushNotification(thisItem['cmd'],thisItem['data'],thisItem['id']);
		}
		willContinue = true;
	}
	return willContinue;
}

function searchArray (needle,haystack) {
	result = false;
	for (var i in haystack) {
		if (needle == haystack[i]) {
			result = true;
			break;
		}
	}
	return result;
}

function getSyncResult () {

	var thisSuccess = false;
	var updateVersion;
	var updateData;

	if (this.status == 200 && this.responseXML) {
		for (var child = this.responseXML.firstChild; child != null; child = child.nextSibling) {
			if (child.nodeName == 'result') {
				var items = child;
				for (var item = items.firstChild; item != null; item = item.nextSibling) {

					if (item.nodeName == 'client') {

						sync.client = item.getAttribute('value');
						if (window.widget) widget.setPreferenceForKey(sync.client,'syncclient');

					} else if (item.nodeName == 'message') {

						var thisMessage = translate(item.getAttribute('value'));
						if (thisMessage) showMessage(thisMessage);
						$('sync-info').innerHTML = thisMessage.replace(/…$/,'.').replace(/・・・$/,'');

					} else if (item.nodeName == 'success') {

						if (item.getAttribute('value') == 'true') thisSuccess = true;
						if (thisSuccess && sync.first == 2) {
							for (var i in deliveries) queueDelivery(deliveries[i].id,'add',0);
						}

					} else if (item.nodeName == 'updated') {

						sync.updated = parseInt(item.getAttribute('value'));
						if (window.widget) widget.setPreferenceForKey(sync.updated,'syncupdated');

					} else if (item.nodeName == 'offset') {

						sync.offset = parseFloat(item.getAttribute('value'));
						if (window.widget) widget.setPreferenceForKey(sync.offset,'syncoffset');

					} else if (item.nodeName == 'delivery') {

						var thisId = (item.getAttribute('uuid')) ? item.getAttribute('uuid') : getUUID();
						var thisUpdated = (item.getAttribute('updated')) ? item.getAttribute('updated') : 0;

						if (removeFromQueue(thisId,thisUpdated)) {

							var thisFrom = item.getAttribute('from');
							var thisName = item.getAttribute('name');
							var thisNo = item.getAttribute('no');
							var thisExtra = item.getAttribute('extra');
							var thisDate = item.getAttribute('date');
							var thisDeleted = (item.getAttribute('deleted') > 0) ? true : false;

							if (thisDeleted) {
								queueDeliveryObject(thisId,true);
							} else {
								if (window.widget) {
									var now = getUnixTime();
									widget.setPreferenceForKey(thisFrom,thisId+'-store');
									widget.setPreferenceForKey(thisName,thisId+'-itemname');	
									widget.setPreferenceForKey(thisNo,thisId+'-orderno');
									widget.setPreferenceForKey(thisExtra,thisId+'-email');
									widget.setPreferenceForKey(now,thisId+'-modified');
									if (thisFrom == 'other') widget.setPreferenceForKey(thisDate,thisId+'-date');
								}
								updateHistory(thisId);
								queueDeliveryObject(thisId,false);
							}

						}

					} else if (item.nodeName == 'updatedata') {

						if (DeliveryStatus && DeliveryStatus.getMD5(item.textContent) == 
							item.getAttribute('md5')) updateData = item.textContent;
				
					} else if (item.nodeName == 'updateversion') {
				
						updateVersion = parseInt(item.getAttribute('value'));
				
					} else if (item.nodeName == 'updateavail') {

						if (item.getAttribute('value') == 'false') markDefsUpdated();

					}
				}
				break;
			}
		}
	}

	if (updateData && DeliveryStatus) {
		var defsPath = DeliveryStatus.saveDefinitions(updateData);
		if (defsPath) {
			markDefsUpdated();
			defsVersion = updateVersion;
			if (window.widget) {
				widget.setPreferenceForKey(defsVersion,'defs');
				widget.setPreferenceForKey(defsPath,'defspath');
			}
			if (document.getElementsByTagName('head')[0].removeChild($('definitions'))) {
				loadDefinitions('file://'+escape(defsPath),false);
				sync.updateAfter = false;
			}
		}
	}

	sync.success = thisSuccess;
	if (currentSide == 'front') animateQueues();

	var willContinue = false;
	if (sync.success) {
		if (currentSide == 'back' && currentView.split(' ')[0] == 'sync') setSync('login');
		sync.first = (sync.first == 1) ? 2 : 0;
		willContinue = continueSync();
	}
	if (!willContinue) syncFinish();

}

function syncFail ( thisItem ) {
	if (thisItem) {
		for (i in syncQueue) {
			if (syncQueue[i]['function'] == thisItem['function'] && 
				syncQueue[i]['id'] == thisItem['id']) {
				syncQueue.splice(i,1);
				break;	
			}
		}
		syncQueue.push(thisItem);
	}
	sync.success = false;
	syncFinish();
}

function syncFinish () {
	if (sync.updateAfter) {
		updateDeliveries(false,true);
		sync.updateAfter = false;
	} else showTime(false);
}

function logOut () {
	syncDelivery('','logout',0);
	if (window.widget) {
		widget.setPreferenceForKey(null,'syncemail');
		widget.setPreferenceForKey(null,'syncclient');
		widget.setPreferenceForKey(null,'syncupdated');
	}
	sync.email = '';
	sync.password = '';
	sync.client = '';
	sync.updated = 0;
	sync.success = false;
	$('syncemail').value = '';
	$('syncpassword').value = '';
	setSync('login');
}

function markDefsUpdated () {
	defsUpdate = getUnixTime();
	if (window.widget) widget.setPreferenceForKey(defsUpdate,'defsupdate');
}

function loadDefinitions ( theSrc, firstLoad ) {

	element = document.createElement('script'); 
	element.src = theSrc + '?' + defsVersion;
	element.type = 'text/javascript';
	element.charset = 'utf-8';
	element.id = 'definitions';

	var loadAction;
	if (firstLoad) {
		loadAction = function(){ loadDeliveries(); };
	} else loadAction = function(){ updateDeliveries(true,true); };
	element.onload = loadAction;

	document.getElementsByTagName('head')[0].appendChild(element);

}

function resetDefinitions ( ) {
	if (DeliveryStatus) DeliveryStatus.resetDefinitions();
	defsVersion = defsLocal;
	defsUpdate = 0;
	if (window.widget) {
		widget.setPreferenceForKey(null,'defs');
		widget.setPreferenceForKey(null,'defsupdate');
	}
}

function NSLog (text) { alert(text); }

// https://github.com/douglascrockford/JSON-js
// 2011-02-23
// Needed for 10.5.x when Safari 5 is not installed

var JSON;
if (!JSON) {
    JSON = {};
}

(function () {

    "use strict";

    function f(n) {
        return n < 10 ? '0' + n : n;
    }

    if (typeof Date.prototype.toJSON !== 'function') {
        Date.prototype.toJSON = function (key) {
            return isFinite(this.valueOf()) ?
                this.getUTCFullYear()     + '-' +
                f(this.getUTCMonth() + 1) + '-' +
                f(this.getUTCDate())      + 'T' +
                f(this.getUTCHours())     + ':' +
                f(this.getUTCMinutes())   + ':' +
                f(this.getUTCSeconds())   + 'Z' : null;
        };
        String.prototype.toJSON      =
            Number.prototype.toJSON  =
            Boolean.prototype.toJSON = function (key) {
                return this.valueOf();
            };
    }

    var cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        gap,
        indent,
        meta = {    // table of character substitutions
            '\b': '\\b',
            '\t': '\\t',
            '\n': '\\n',
            '\f': '\\f',
            '\r': '\\r',
            '"' : '\\"',
            '\\': '\\\\'
        },
        rep;

    function quote(string) {
        escapable.lastIndex = 0;
        return escapable.test(string) ? '"' + string.replace(escapable, function (a) {
            var c = meta[a];
            return typeof c === 'string' ? c :
                '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
        }) + '"' : '"' + string + '"';
    }

    function str(key, holder) {

        var i,          // The loop counter.
            k,          // The member key.
            v,          // The member value.
            length,
            mind = gap,
            partial,
            value = holder[key];

        if (value && typeof value === 'object' &&
                typeof value.toJSON === 'function') {
            value = value.toJSON(key);
        }

        if (typeof rep === 'function') {
            value = rep.call(holder, key, value);
        }

        switch (typeof value) {
        case 'string':
            return quote(value);
        case 'number':
            return isFinite(value) ? String(value) : 'null';
        case 'boolean':
        case 'null':
            return String(value);
        case 'object':
            if (!value) {
                return 'null';
            }

            gap += indent;
            partial = [];

            if (Object.prototype.toString.apply(value) === '[object Array]') {
                length = value.length;
                for (i = 0; i < length; i += 1) {
                    partial[i] = str(i, value) || 'null';
                }

                v = partial.length === 0 ? '[]' : gap ?
                    '[\n' + gap + partial.join(',\n' + gap) + '\n' + mind + ']' :
                    '[' + partial.join(',') + ']';
                gap = mind;
                return v;
            }

            if (rep && typeof rep === 'object') {
                length = rep.length;
                for (i = 0; i < length; i += 1) {
                    if (typeof rep[i] === 'string') {
                        k = rep[i];
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            } else {
                for (k in value) {
                    if (Object.prototype.hasOwnProperty.call(value, k)) {
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            }

            v = partial.length === 0 ? '{}' : gap ?
                '{\n' + gap + partial.join(',\n' + gap) + '\n' + mind + '}' :
                '{' + partial.join(',') + '}';
            gap = mind;
            return v;
        }
    }

    if (typeof JSON.stringify !== 'function') {
        JSON.stringify = function (value, replacer, space) {

            var i;
            gap = '';
            indent = '';

            if (typeof space === 'number') {
                for (i = 0; i < space; i += 1) {
                    indent += ' ';
                }
            } else if (typeof space === 'string') {
                indent = space;
            }

            rep = replacer;
            if (replacer && typeof replacer !== 'function' &&
                    (typeof replacer !== 'object' ||
                    typeof replacer.length !== 'number')) {
                throw new Error('JSON.stringify');
            }

            return str('', {'': value});
        };
    }

    if (typeof JSON.parse !== 'function') {
        JSON.parse = function (text, reviver) {

            var j;

            function walk(holder, key) {
                var k, v, value = holder[key];
                if (value && typeof value === 'object') {
                    for (k in value) {
                        if (Object.prototype.hasOwnProperty.call(value, k)) {
                            v = walk(value, k);
                            if (v !== undefined) {
                                value[k] = v;
                            } else {
                                delete value[k];
                            }
                        }
                    }
                }
                return reviver.call(holder, key, value);
            }

            text = String(text);
            cx.lastIndex = 0;
            if (cx.test(text)) {
                text = text.replace(cx, function (a) {
                    return '\\u' +
                        ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
                });
            }

            if (/^[\],:{}\s]*$/
                    .test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, '@')
                    .replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']')
                	.replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                j = eval('(' + text + ')');
                return typeof reviver === 'function' ?
                    walk({'': j}, '') : j;
            }

            throw new SyntaxError('JSON.parse');

        };
    }

}());