var size = { width: 275, height: 140 };
var min  = { width: 104, height: 140 };
var max  = { width: 600, height: 140 };
var deliveriesMax = 140;
var offset = { x: 0, y: 0 };
var maximized = false;

var snapDist = 40;
var scrollArea;
var scrollWidth = 18;

function savedSize ( ) {
	var thisWidth = 275;
	var thisHeight = 140;
	if (window.widget) {
		if (widget.preferenceForKey('width')) thisWidth = widget.preferenceForKey('width');
		if (widget.preferenceForKey('height')) thisHeight = widget.preferenceForKey('height');
	}
	return { width: thisWidth, height: thisHeight };
}

function maxForDeliveries ( height ) {
	return height + 15 + 51;
}

function setMinMax (thisView) {
	deliveriesMax = thisHeight = maxForDeliveries(deliveries.length * 74);
	switch (thisView) {

		case 'deliveries':
			min.width  = 104;
			min.height  = 140;
			if (thisHeight < min.height) {
				thisHeight = min.height;
			} else if (thisHeight > screen.height) {
				thisHeight = screen.height;
			}
			max.height = thisHeight;
			break;

		case 'edit':
			min.width  = 275;
			min.height = 390;
			max.height = (thisHeight > min.height) ? thisHeight : min.height;
			break;

		case 'general':
		case 'sync signin':
		case 'sync register':
		case 'donate':
			min.width  = 275;
			min.height = (thisView == 'sync register') ? 430 : 335;
			max.height = (thisHeight > min.height) ? thisHeight : min.height;
			break;

	}
}

function startResize (e) {
	offset.x = window.innerWidth - e.pageX;
	offset.y = window.innerHeight - e.pageY;
	document.addEventListener('mousemove', doResize, true);
	document.addEventListener('mouseup', stopResize, true);
}

function stopResize () {
	document.removeEventListener('mousemove', doResize, true);
	document.removeEventListener('mouseup', stopResize, true); 
	saveSize(size);
}

function doResize (e) {
	var scrollbars = (currentSide == 'front') ? true : false;
	setSize(e.pageX+offset.x,e.pageY+offset.y,scrollbars,false);
	if (scrollbars) showScrollBar();
}

function setSize (thisWidth, thisHeight, scrollbars, animating) {
	var thisClass = (largePrint) ? 'large' : '';
	if (!animating) {
		if (thisHeight < min.height + snapDist) {
			thisHeight = min.height;
		} else if (thisHeight > max.height) {
			thisHeight = max.height;
		}
		var thisMin = (scrollbars && thisHeight < max.height) ? min.width + scrollWidth : min.width;
		if (thisWidth < thisMin + snapDist) {
			thisWidth = thisMin;
		} else if (thisWidth > max.width) {
			thisWidth = max.width;
		}
		if (thisHeight < deliveriesMax) thisClass += ' scrolling';
		if (thisWidth < min.width + snapDist) thisClass += ' mini';
	} else {
		thisClass += ' animating';
	}
	$('front').className = thisClass;
	
	window.resizeTo(thisWidth,thisHeight);
	size.width = thisWidth;
	size.height = thisHeight;
	if (!animating && scrollArea) scrollArea.refresh();
}

function setMaximized (thisSize) {
	maximized = (currentSide == 'front' && thisSize.height >= max.height) ? true : false;
}

function saveSize (thisSize) {
	if (window.widget) {
		widget.setPreferenceForKey(thisSize.width,'width');
		widget.setPreferenceForKey(thisSize.height,'height');
	}
	setMaximized(thisSize);
}

function rectHandler (rectAnimation, currentRect, startingRect, finishingRect) {
	setSize(currentRect.right,currentRect.bottom,true,true);
}


// changing views


function switchToView ( thisSide, thisView ) {

	nextSide = thisSide;
	nextView = thisView;
	setMinMax(nextView);

	if (currentSide == 'front') {
		scrollArea.blur();
		adjustSize();
	} else flipView();

}

function adjustSize ( forceExpand ) {

	var newSize = { width: size.width, height: size.height };
	if (currentSide != 'front') newSize = savedSize();

	if (min.width > newSize.width) {
		newSize.width = min.width;
	} else if (max.width < newSize.width) {
		newSize.width = max.width;
	}
	if (min.height > newSize.height) {
		newSize.height = min.height;
	} else if (max.height < newSize.height || forceExpand) {
		newSize.height = max.height;
	}
	if (forceExpand) saveSize(newSize);

	if (newSize.width != size.width || newSize.height != size.height) {
		var startingRect = new AppleRect(0,0,size.width,size.height);
		var finishingRect = new AppleRect(0,0,newSize.width,newSize.height);	
		var thisAnimation = new AppleRectAnimation(startingRect,finishingRect,rectHandler);
		var thisAnimator = new AppleAnimator(300,13);
		thisAnimator.addAnimation(thisAnimation);
		if (currentSide == 'front' && nextSide != 'front') {
			thisAnimator.oncomplete = flipView;
		} else thisAnimator.oncomplete = completeSwitch;
		thisAnimator.start();
	} else if (currentSide == 'front') {
		flipView();
	} else completeSwitch();

}

function flipView () {

	var thisTransition = (nextSide == 'front') ? 'ToFront' : 'ToBack';
	if (window.widget) widget.prepareForTransition(thisTransition);

	$(currentSide).style.display = 'none';
	if (nextSide == 'back') $('back').className = nextView;
	$(nextSide).style.display = 'block';

	setTimeout(function(){
			if (window.widget) widget.performTransition()
			if (currentSide == 'front' && nextSide != 'front') {
				completeSwitch();
			} else setTimeout(adjustSize,750);	
		},0);

}

function completeSwitch () {

	if (nextSide == 'front') {
		setSize(size.width,size.height,true,false);
		scrollArea.focus();
		animateQueues();
		showScrollBar();
	} else $('back').className = nextView;

	currentSide = nextSide;
	currentView = nextView;

	if (!currentSide) {
		currentSide = 'front';
		currentView = 'deliveries';
	} else if (currentSide == 'back' && currentView == 'edit' && !$('no').value) {
		$('name').focus();
	}

}

function selectTab ( thisTab ) {
	if (currentView == 'general') saveSettings(false);
	if (thisTab == 'general') checkNotifications();
	setMinMax(thisTab);
	if (size.height < min.height) {
		nextSide = 'back';
		nextView = thisTab;
		adjustSize();
	} else {
		$('back').className = thisTab;
		currentSide = 'back';
		currentView = thisTab;
	}
}